#include "ruby-spml.h"

#ifdef IFORT
extern double* eq_module_mp_rp_phi_;
extern double* eq_module_mp_rp_rad_;
extern double* eq_module_mp_er_rad_;
extern void eq_module_mp_eq_initial_(int*, int*, int*, int*, double*);
extern struct farray* eq_module_mp_rp_eq_(struct farray*, double*);
extern struct farray* eq_module_mp_eq_rp_(struct farray*, double*);
extern struct farray* eq_module_mp_eq_er_(struct farray*, double*);
extern struct farray* eq_module_mp_er_eq_(struct farray*, double*);
extern struct farray* eq_module_mp_rp_er_(struct farray*, double*);
extern struct farray* eq_module_mp_er_rp_(struct farray*, double*);
extern struct farray* eq_module_mp_eq_dphi_eq_(struct farray*, double*);
extern struct farray* eq_module_mp_eq_raddrad_eq_(struct farray*, double*);
extern struct farray* eq_module_mp_er_lapla_eq_(struct farray*, double*);
extern struct farray* eq_module_mp_eq_lapla_eq_(struct farray*, double*);
extern struct farray* eq_module_mp_eq_jacobian_eq_eq_(struct farray*, double*, double*);
extern void eq_module_mp_eq_boundary_(double*, double*, char*);
extern struct farray* eq_module_mp_eq_laplainv_eq_(struct farray*, double*, double*);
extern struct farray* eq_module_mp_eq_vor2strm_eq_(struct farray*, double*, double*, char*, int*);
extern double eq_module_mp_intradphi_rp_(double*);
extern struct farray* eq_module_mp_r_intphi_rp_(struct farray*, double*);
extern struct farray* eq_module_mp_p_intrad_rp_(struct farray*, double*);
extern double eq_module_mp_intphi_p_(double*);
extern double eq_module_mp_intrad_r_(double*);
extern double eq_module_mp_avrradphi_rp_(double*);
extern struct farray* eq_module_mp_r_avrphi_rp_(struct farray*, double*);
extern struct farray* eq_module_mp_p_avrrad_rp_(struct farray*, double*);
extern double eq_module_mp_avrphi_p_(double*);
extern double eq_module_mp_avrrad_r_(double*);
#endif
#ifdef GFORTRAN
extern double* __eq_module_MOD_rp_phi;
extern double* __eq_module_MOD_rp_rad;
extern double* __eq_module_MOD_er_rad;
extern void __eq_module_MOD_eq_initial(int*, int*, int*, int*, double*);
extern struct farray* __eq_module_MOD_rp_eq(struct farray*, double*);
extern struct farray* __eq_module_MOD_eq_rp(struct farray*, double*);
extern struct farray* __eq_module_MOD_eq_er(struct farray*, double*);
extern struct farray* __eq_module_MOD_er_eq(struct farray*, double*);
extern struct farray* __eq_module_MOD_rp_er(struct farray*, double*);
extern struct farray* __eq_module_MOD_er_rp(struct farray*, double*);
extern struct farray* __eq_module_MOD_eq_dphi_eq(struct farray*, double*);
extern struct farray* __eq_module_MOD_eq_raddrad_eq(struct farray*, double*);
extern struct farray* __eq_module_MOD_er_lapla_eq(struct farray*, double*);
extern struct farray* __eq_module_MOD_eq_lapla_eq(struct farray*, double*);
extern struct farray* __eq_module_MOD_eq_jacobian_eq_eq(struct farray*, double*, double*);
extern void __eq_module_MOD_eq_boundary(double*, double*, char*);
extern struct farray* __eq_module_MOD_eq_laplainv_eq(struct farray*, double*, double*);
extern struct farray* __eq_module_MOD_eq_vor2strm_eq(struct farray*, double*, double*, char*, int*);
extern double __eq_module_MOD_intradphi_rp(double*);
extern struct farray* __eq_module_MOD_r_intphi_rp(struct farray*, double*);
extern struct farray* __eq_module_MOD_p_intrad_rp(struct farray*, double*);
extern double __eq_module_MOD_intphi_p(double*);
extern double __eq_module_MOD_intrad_r(double*);
extern double __eq_module_MOD_avrradphi_rp(double*);
extern struct farray* __eq_module_MOD_r_avrphi_rp(struct farray*, double*);
extern struct farray* __eq_module_MOD_p_avrrad_rp(struct farray*, double*);
extern double __eq_module_MOD_avrphi_p(double*);
extern double __eq_module_MOD_avrrad_r(double*);
#endif
#ifdef FFC32
asm ("eq_module_rp_phi_:");
asm ("  pushl %ebp");
asm ("  movl %esp, %ebp");
asm ("  movl MODULE.eq_module_+0, %eax");
asm ("  leave");
asm ("  ret");
asm ("eq_module_rp_rad_:");
asm ("  pushl %ebp");
asm ("  movl %esp, %ebp");
asm ("  movl MODULE.eq_module_+60, %eax");
asm ("  leave");
asm ("  ret");
asm ("eq_module_er_rad_:");
asm ("  pushl %ebp");
asm ("  movl %esp, %ebp");
asm ("  movl MODULE.eq_module_+120, %eax");
asm ("  leave");
asm ("  ret");
asm ("eq_module_eq_initial_:");
asm ("  pushl %ebp");
asm ("  movl %esp,%ebp");
asm ("  movl 24(%ebp), %eax");
asm ("  pushl %eax");
asm ("  movl 20(%ebp), %eax");
asm ("  pushl %eax");
asm ("  movl 16(%ebp), %eax");
asm ("  pushl %eax");
asm ("  movl 12(%ebp), %eax");
asm ("  pushl %eax");
asm ("  movl 8(%ebp), %eax");
asm ("  pushl %eax");
asm ("  call eq_module.eq_initial_");
asm ("  leave");
asm ("  ret");
asm ("eq_module_rp_eq_:");
asm ("  pushl %ebp");
asm ("  movl %esp,%ebp");
asm ("  movl 12(%ebp), %eax");
asm ("  pushl %eax");
asm ("  movl 8(%ebp), %eax");
asm ("  pushl %eax");
asm ("  call eq_module.rp_eq_");
asm ("  leave");
asm ("  ret");
asm ("eq_module_eq_rp_:");
asm ("  pushl %ebp");
asm ("  movl %esp,%ebp");
asm ("  movl 12(%ebp), %eax");
asm ("  pushl %eax");
asm ("  movl 8(%ebp), %eax");
asm ("  pushl %eax");
asm ("  call eq_module.eq_rp_");
asm ("  leave");
asm ("  ret");
asm ("eq_module_eq_er_:");
asm ("  pushl %ebp");
asm ("  movl %esp,%ebp");
asm ("  movl 12(%ebp), %eax");
asm ("  pushl %eax");
asm ("  movl 8(%ebp), %eax");
asm ("  pushl %eax");
asm ("  call eq_module.eq_er_");
asm ("  leave");
asm ("  ret");
asm ("eq_module_er_eq_:");
asm ("  pushl %ebp");
asm ("  movl %esp,%ebp");
asm ("  movl 12(%ebp), %eax");
asm ("  pushl %eax");
asm ("  movl 8(%ebp), %eax");
asm ("  pushl %eax");
asm ("  call eq_module.er_eq_");
asm ("  leave");
asm ("  ret");
asm ("eq_module_rp_er_:");
asm ("  pushl %ebp");
asm ("  movl %esp,%ebp");
asm ("  movl 12(%ebp), %eax");
asm ("  pushl %eax");
asm ("  movl 8(%ebp), %eax");
asm ("  pushl %eax");
asm ("  call eq_module.rp_er_");
asm ("  leave");
asm ("  ret");
asm ("eq_module_er_rp_:");
asm ("  pushl %ebp");
asm ("  movl %esp,%ebp");
asm ("  movl 12(%ebp), %eax");
asm ("  pushl %eax");
asm ("  movl 8(%ebp), %eax");
asm ("  pushl %eax");
asm ("  call eq_module.er_rp_");
asm ("  leave");
asm ("  ret");
asm ("eq_module_eq_dphi_eq_:");
asm ("  pushl %ebp");
asm ("  movl %esp,%ebp");
asm ("  movl 12(%ebp), %eax");
asm ("  pushl %eax");
asm ("  movl 8(%ebp), %eax");
asm ("  pushl %eax");
asm ("  call eq_module.eq_dphi_eq_");
asm ("  leave");
asm ("  ret");
asm ("eq_module_eq_raddrad_eq_:");
asm ("  pushl %ebp");
asm ("  movl %esp,%ebp");
asm ("  movl 12(%ebp), %eax");
asm ("  pushl %eax");
asm ("  movl 8(%ebp), %eax");
asm ("  pushl %eax");
asm ("  call eq_module.eq_raddrad_eq_");
asm ("  leave");
asm ("  ret");
asm ("eq_module_er_lapla_eq_:");
asm ("  pushl %ebp");
asm ("  movl %esp,%ebp");
asm ("  movl 12(%ebp), %eax");
asm ("  pushl %eax");
asm ("  movl 8(%ebp), %eax");
asm ("  pushl %eax");
asm ("  call eq_module.er_lapla_eq_");
asm ("  leave");
asm ("  ret");
asm ("eq_module_eq_lapla_eq_:");
asm ("  pushl %ebp");
asm ("  movl %esp,%ebp");
asm ("  movl 12(%ebp), %eax");
asm ("  pushl %eax");
asm ("  movl 8(%ebp), %eax");
asm ("  pushl %eax");
asm ("  call eq_module.eq_lapla_eq_");
asm ("  leave");
asm ("  ret");
asm ("eq_module_eq_jacobian_eq_eq_:");
asm ("  pushl %ebp");
asm ("  movl %esp,%ebp");
asm ("  movl 16(%ebp), %eax");
asm ("  pushl %eax");
asm ("  movl 12(%ebp), %eax");
asm ("  pushl %eax");
asm ("  movl 8(%ebp), %eax");
asm ("  pushl %eax");
asm ("  call eq_module.eq_jacobian_eq_eq_");
asm ("  leave");
asm ("  ret");
asm ("eq_module_eq_boundary_:");
asm ("  pushl %ebp");
asm ("  movl %esp,%ebp");
asm ("  movl 16(%ebp), %eax");
asm ("  pushl %eax");
asm ("  movl 12(%ebp), %eax");
asm ("  pushl %eax");
asm ("  movl 8(%ebp), %eax");
asm ("  pushl %eax");
asm ("  call eq_module.eq_boundary_");
asm ("  leave");
asm ("  ret");
asm ("eq_module_eq_laplainv_eq_:");
asm ("  pushl %ebp");
asm ("  movl %esp,%ebp");
asm ("  movl 16(%ebp), %eax");
asm ("  pushl %eax");
asm ("  movl 12(%ebp), %eax");
asm ("  pushl %eax");
asm ("  movl 8(%ebp), %eax");
asm ("  pushl %eax");
asm ("  call eq_module.eq_laplainv_eq_");
asm ("  leave");
asm ("  ret");
asm ("eq_module_eq_vor2strm_eq_:");
asm ("  pushl %ebp");
asm ("  movl %esp,%ebp");
asm ("  movl 24(%ebp), %eax");
asm ("  pushl %eax");
asm ("  movl 20(%ebp), %eax");
asm ("  pushl %eax");
asm ("  movl 16(%ebp), %eax");
asm ("  pushl %eax");
asm ("  movl 12(%ebp), %eax");
asm ("  pushl %eax");
asm ("  movl 8(%ebp), %eax");
asm ("  pushl %eax");
asm ("  call eq_module.eq_vor2strm_eq_");
asm ("  leave");
asm ("  ret");
asm ("eq_module_intradphi_rp_:");
asm ("  pushl %ebp");
asm ("  movl %esp,%ebp");
asm ("  movl 8(%ebp), %eax");
asm ("  pushl %eax");
asm ("  call eq_module.intradphi_rp_");
asm ("  leave");
asm ("  ret");
asm ("eq_module_r_intphi_rp_:");
asm ("  pushl %ebp");
asm ("  movl %esp,%ebp");
asm ("  movl 12(%ebp), %eax");
asm ("  pushl %eax");
asm ("  movl 8(%ebp), %eax");
asm ("  pushl %eax");
asm ("  call eq_module.r_intphi_rp_");
asm ("  leave");
asm ("  ret");
asm ("eq_module_p_intrad_rp_:");
asm ("  pushl %ebp");
asm ("  movl %esp,%ebp");
asm ("  movl 12(%ebp), %eax");
asm ("  pushl %eax");
asm ("  movl 8(%ebp), %eax");
asm ("  pushl %eax");
asm ("  call eq_module.p_intrad_rp_");
asm ("  leave");
asm ("  ret");
asm ("eq_module_intphi_p_:");
asm ("  pushl %ebp");
asm ("  movl %esp,%ebp");
asm ("  movl 8(%ebp), %eax");
asm ("  pushl %eax");
asm ("  call eq_module.intphi_p_");
asm ("  leave");
asm ("  ret");
asm ("eq_module_intrad_r_:");
asm ("  pushl %ebp");
asm ("  movl %esp,%ebp");
asm ("  movl 8(%ebp), %eax");
asm ("  pushl %eax");
asm ("  call eq_module.intrad_r_");
asm ("  leave");
asm ("  ret");
asm ("eq_module_avrradphi_rp_:");
asm ("  pushl %ebp");
asm ("  movl %esp,%ebp");
asm ("  movl 8(%ebp), %eax");
asm ("  pushl %eax");
asm ("  call eq_module.avrradphi_rp_");
asm ("  leave");
asm ("  ret");
asm ("eq_module_r_avrphi_rp_:");
asm ("  pushl %ebp");
asm ("  movl %esp,%ebp");
asm ("  movl 12(%ebp), %eax");
asm ("  pushl %eax");
asm ("  movl 8(%ebp), %eax");
asm ("  pushl %eax");
asm ("  call eq_module.r_avrphi_rp_");
asm ("  leave");
asm ("  ret");
asm ("eq_module_p_avrrad_rp_:");
asm ("  pushl %ebp");
asm ("  movl %esp,%ebp");
asm ("  movl 12(%ebp), %eax");
asm ("  pushl %eax");
asm ("  movl 8(%ebp), %eax");
asm ("  pushl %eax");
asm ("  call eq_module.p_avrrad_rp_");
asm ("  leave");
asm ("  ret");
asm ("eq_module_avrphi_p_:");
asm ("  pushl %ebp");
asm ("  movl %esp,%ebp");
asm ("  movl 8(%ebp), %eax");
asm ("  pushl %eax");
asm ("  call eq_module.avrphi_p_");
asm ("  leave");
asm ("  ret");
asm ("eq_module_avrrad_r_:");
asm ("  pushl %ebp");
asm ("  movl %esp,%ebp");
asm ("  movl 8(%ebp), %eax");
asm ("  pushl %eax");
asm ("  call eq_module.avrrad_r_");
asm ("  leave");
asm ("  ret");
#endif
#ifdef FFC64
asm ("eq_module_rp_phi_:");
asm ("  push %rbp");
asm ("  movq %rsp, %rbp");
asm ("  leaq MODULE.eq_module_@GOTPCREL(%rip), %rax");
asm ("  movq 0(%rax), %r10");
asm ("  movq (%r10), %rax");
asm ("  leave");
asm ("  ret");
asm ("eq_module_rp_rad_:");
asm ("  push %rbp");
asm ("  movq %rsp, %rbp");
asm ("  leaq MODULE.eq_module_@GOTPCREL(%rip), %rax");
asm ("  movq 120(%rax), %r10");
asm ("  movq (%r10), %rax");
asm ("  leave");
asm ("  ret");
asm ("eq_module_er_rad_:");
asm ("  push %rbp");
asm ("  movq %rsp, %rbp");
asm ("  leaq MODULE.eq_module_@GOTPCREL(%rip), %rax");
asm ("  movq 240(%rax), %r10");
asm ("  movq (%r10), %rax");
asm ("  leave");
asm ("  ret");
asm ("eq_module_eq_initial_:");
asm ("  push %rbp");
asm ("  movq %rsp,%rbp");
asm ("  subq $16,%rsp");
asm ("  call eq_module.eq_initial_@PLT");
asm ("  xorq %rax,%rax");
asm ("  addq $16,%rsp");
asm ("  leave");
asm ("  ret");
asm ("eq_module_rp_eq_:");
asm ("  push %rbp");
asm ("  movq %rsp,%rbp");
asm ("  subq $16,%rsp");
asm ("  call eq_module.rp_eq_@PLT");
asm ("  xorq %rax,%rax");
asm ("  addq $16,%rsp");
asm ("  leave");
asm ("  ret");
asm ("eq_module_eq_rp_:");
asm ("  push %rbp");
asm ("  movq %rsp,%rbp");
asm ("  subq $16,%rsp");
asm ("  call eq_module.eq_rp_@PLT");
asm ("  xorq %rax,%rax");
asm ("  addq $16,%rsp");
asm ("  leave");
asm ("  ret");
asm ("eq_module_eq_er_:");
asm ("  push %rbp");
asm ("  movq %rsp,%rbp");
asm ("  subq $16,%rsp");
asm ("  call eq_module.eq_er_@PLT");
asm ("  xorq %rax,%rax");
asm ("  addq $16,%rsp");
asm ("  leave");
asm ("  ret");
asm ("eq_module_er_eq_:");
asm ("  push %rbp");
asm ("  movq %rsp,%rbp");
asm ("  subq $16,%rsp");
asm ("  call eq_module.er_eq_@PLT");
asm ("  xorq %rax,%rax");
asm ("  addq $16,%rsp");
asm ("  leave");
asm ("  ret");
asm ("eq_module_rp_er_:");
asm ("  push %rbp");
asm ("  movq %rsp,%rbp");
asm ("  subq $16,%rsp");
asm ("  call eq_module.rp_er_@PLT");
asm ("  xorq %rax,%rax");
asm ("  addq $16,%rsp");
asm ("  leave");
asm ("  ret");
asm ("eq_module_er_rp_:");
asm ("  push %rbp");
asm ("  movq %rsp,%rbp");
asm ("  subq $16,%rsp");
asm ("  call eq_module.er_rp_@PLT");
asm ("  xorq %rax,%rax");
asm ("  addq $16,%rsp");
asm ("  leave");
asm ("  ret");
asm ("eq_module_eq_dphi_eq_:");
asm ("  push %rbp");
asm ("  movq %rsp,%rbp");
asm ("  subq $16,%rsp");
asm ("  call eq_module.eq_dphi_eq_@PLT");
asm ("  xorq %rax,%rax");
asm ("  addq $16,%rsp");
asm ("  leave");
asm ("  ret");
asm ("eq_module_eq_raddrad_eq_:");
asm ("  push %rbp");
asm ("  movq %rsp,%rbp");
asm ("  subq $16,%rsp");
asm ("  call eq_module.eq_raddrad_eq_@PLT");
asm ("  xorq %rax,%rax");
asm ("  addq $16,%rsp");
asm ("  leave");
asm ("  ret");
asm ("eq_module_er_lapla_eq_:");
asm ("  push %rbp");
asm ("  movq %rsp,%rbp");
asm ("  subq $16,%rsp");
asm ("  call eq_module.er_lapla_eq_@PLT");
asm ("  xorq %rax,%rax");
asm ("  addq $16,%rsp");
asm ("  leave");
asm ("  ret");
asm ("eq_module_eq_lapla_eq_:");
asm ("  push %rbp");
asm ("  movq %rsp,%rbp");
asm ("  subq $16,%rsp");
asm ("  call eq_module.eq_lapla_eq_@PLT");
asm ("  xorq %rax,%rax");
asm ("  addq $16,%rsp");
asm ("  leave");
asm ("  ret");
asm ("eq_module_eq_jacobian_eq_eq_:");
asm ("  push %rbp");
asm ("  movq %rsp,%rbp");
asm ("  subq $16,%rsp");
asm ("  call eq_module.eq_jacobian_eq_eq_@PLT");
asm ("  xorq %rax,%rax");
asm ("  addq $16,%rsp");
asm ("  leave");
asm ("  ret");
asm ("eq_module_eq_boundary_:");
asm ("  push %rbp");
asm ("  movq %rsp,%rbp");
asm ("  subq $16,%rsp");
asm ("  call eq_module.eq_boundary_@PLT");
asm ("  xorq %rax,%rax");
asm ("  addq $16,%rsp");
asm ("  leave");
asm ("  ret");
asm ("eq_module_eq_laplainv_eq_:");
asm ("  push %rbp");
asm ("  movq %rsp,%rbp");
asm ("  subq $16,%rsp");
asm ("  call eq_module.eq_laplainv_eq_@PLT");
asm ("  xorq %rax,%rax");
asm ("  addq $16,%rsp");
asm ("  leave");
asm ("  ret");
asm ("eq_module_eq_vor2strm_eq_:");
asm ("  push %rbp");
asm ("  movq %rsp,%rbp");
asm ("  subq $16,%rsp");
asm ("  call eq_module.eq_vor2strm_eq_@PLT");
asm ("  xorq %rax,%rax");
asm ("  addq $16,%rsp");
asm ("  leave");
asm ("  ret");
asm ("eq_module_intradphi_rp_:");
asm ("  push %rbp");
asm ("  movq %rsp,%rbp");
asm ("  subq $16,%rsp");
asm ("  call eq_module.intradphi_rp_@PLT");
asm ("  xorq %rax,%rax");
asm ("  addq $16,%rsp");
asm ("  leave");
asm ("  ret");
asm ("eq_module_r_intphi_rp_:");
asm ("  push %rbp");
asm ("  movq %rsp,%rbp");
asm ("  subq $16,%rsp");
asm ("  call eq_module.r_intphi_rp_@PLT");
asm ("  xorq %rax,%rax");
asm ("  addq $16,%rsp");
asm ("  leave");
asm ("  ret");
asm ("eq_module_p_intrad_rp_:");
asm ("  push %rbp");
asm ("  movq %rsp,%rbp");
asm ("  subq $16,%rsp");
asm ("  call eq_module.p_intrad_rp_@PLT");
asm ("  xorq %rax,%rax");
asm ("  addq $16,%rsp");
asm ("  leave");
asm ("  ret");
asm ("eq_module_intphi_p_:");
asm ("  push %rbp");
asm ("  movq %rsp,%rbp");
asm ("  subq $16,%rsp");
asm ("  call eq_module.intphi_p_@PLT");
asm ("  xorq %rax,%rax");
asm ("  addq $16,%rsp");
asm ("  leave");
asm ("  ret");
asm ("eq_module_intrad_r_:");
asm ("  push %rbp");
asm ("  movq %rsp,%rbp");
asm ("  subq $16,%rsp");
asm ("  call eq_module.intrad_r_@PLT");
asm ("  xorq %rax,%rax");
asm ("  addq $16,%rsp");
asm ("  leave");
asm ("  ret");
asm ("eq_module_avrradphi_rp_:");
asm ("  push %rbp");
asm ("  movq %rsp,%rbp");
asm ("  subq $16,%rsp");
asm ("  call eq_module.avrradphi_rp_@PLT");
asm ("  xorq %rax,%rax");
asm ("  addq $16,%rsp");
asm ("  leave");
asm ("  ret");
asm ("eq_module_r_avrphi_rp_:");
asm ("  push %rbp");
asm ("  movq %rsp,%rbp");
asm ("  subq $16,%rsp");
asm ("  call eq_module.r_avrphi_rp_@PLT");
asm ("  xorq %rax,%rax");
asm ("  addq $16,%rsp");
asm ("  leave");
asm ("  ret");
asm ("eq_module_p_avrrad_rp_:");
asm ("  push %rbp");
asm ("  movq %rsp,%rbp");
asm ("  subq $16,%rsp");
asm ("  call eq_module.p_avrrad_rp_@PLT");
asm ("  xorq %rax,%rax");
asm ("  addq $16,%rsp");
asm ("  leave");
asm ("  ret");
asm ("eq_module_avrphi_p_:");
asm ("  push %rbp");
asm ("  movq %rsp,%rbp");
asm ("  subq $16,%rsp");
asm ("  call eq_module.avrphi_p_@PLT");
asm ("  xorq %rax,%rax");
asm ("  addq $16,%rsp");
asm ("  leave");
asm ("  ret");
asm ("eq_module_avrrad_r_:");
asm ("  push %rbp");
asm ("  movq %rsp,%rbp");
asm ("  subq $16,%rsp");
asm ("  call eq_module.avrrad_r_@PLT");
asm ("  xorq %rax,%rax");
asm ("  addq $16,%rsp");
asm ("  leave");
asm ("  ret");
#endif
#if defined(FFC32) || defined(FFC64)
extern double* eq_module_rp_phi_();
extern double* eq_module_rp_rad_();
extern double* eq_module_er_rad_();
extern void eq_module_eq_initial_(int*, int*, int*, int*, double*);
extern struct farray* eq_module_rp_eq_(struct farray*, double*);
extern struct farray* eq_module_eq_rp_(struct farray*, double*);
extern struct farray* eq_module_eq_er_(struct farray*, double*);
extern struct farray* eq_module_er_eq_(struct farray*, double*);
extern struct farray* eq_module_rp_er_(struct farray*, double*);
extern struct farray* eq_module_er_rp_(struct farray*, double*);
extern struct farray* eq_module_eq_dphi_eq_(struct farray*, double*);
extern struct farray* eq_module_eq_raddrad_eq_(struct farray*, double*);
extern struct farray* eq_module_er_lapla_eq_(struct farray*, double*);
extern struct farray* eq_module_eq_lapla_eq_(struct farray*, double*);
extern struct farray* eq_module_eq_jacobian_eq_eq_(struct farray*, double*, double*);
extern void eq_module_eq_boundary_(double*, double*, char*);
extern struct farray* eq_module_eq_laplainv_eq_(struct farray*, double*, double*);
extern struct farray* eq_module_eq_vor2strm_eq_(struct farray*, double*, double*, char*, int*);
extern double eq_module_intradphi_rp_(double*);
extern struct farray* eq_module_r_intphi_rp_(struct farray*, double*);
extern struct farray* eq_module_p_intrad_rp_(struct farray*, double*);
extern double eq_module_intphi_p_(double*);
extern double eq_module_intrad_r_(double*);
extern double eq_module_avrradphi_rp_(double*);
extern struct farray* eq_module_r_avrphi_rp_(struct farray*, double*);
extern struct farray* eq_module_p_avrrad_rp_(struct farray*, double*);
extern double eq_module_avrphi_p_(double*);
extern double eq_module_avrrad_r_(double*);
#endif


static int im;
static int jm = 8;
static int km;
static int lm = 5;


static VALUE
rbspml_rp_Phi(int argc, VALUE *argv, VALUE self)
{
  VALUE out;
  double* cout;

  rb_scan_args(argc, argv, "00");

#if defined IFORT
  cout = (double*)eq_module_mp_rp_phi_;
#elif defined GFORTRAN
  cout = (double*)__eq_module_MOD_rp_phi;
#elif defined(FFC32) || defined(FFC64)
  cout = (double*)eq_module_rp_phi_();
#endif

{
  int shape[2];
  shape[0] = jm;
  shape[1] = (im-1) - (0) + 1;
  out = na_make_object(NA_DFLOAT, 2, shape, cNArray);
  double* cnout = NA_PTR_TYPE(out,double*);
  int i;
  for (i=0;i<NA_TOTAL(out);i++)
    cnout[i] = cout[i];
};
  return out;
}

static VALUE
rbspml_rp_Rad(int argc, VALUE *argv, VALUE self)
{
  VALUE out;
  double* cout;

  rb_scan_args(argc, argv, "00");

#if defined IFORT
  cout = (double*)eq_module_mp_rp_rad_;
#elif defined GFORTRAN
  cout = (double*)__eq_module_MOD_rp_rad;
#elif defined(FFC32) || defined(FFC64)
  cout = (double*)eq_module_rp_rad_();
#endif

{
  int shape[2];
  shape[0] = jm;
  shape[1] = (im-1) - (0) + 1;
  out = na_make_object(NA_DFLOAT, 2, shape, cNArray);
  double* cnout = NA_PTR_TYPE(out,double*);
  int i;
  for (i=0;i<NA_TOTAL(out);i++)
    cnout[i] = cout[i];
};
  return out;
}

static VALUE
rbspml_er_Rad(int argc, VALUE *argv, VALUE self)
{
  VALUE out;
  double* cout;

  rb_scan_args(argc, argv, "00");

#if defined IFORT
  cout = (double*)eq_module_mp_er_rad_;
#elif defined GFORTRAN
  cout = (double*)__eq_module_MOD_er_rad;
#elif defined(FFC32) || defined(FFC64)
  cout = (double*)eq_module_er_rad_();
#endif

{
  int shape[2];
  shape[0] = (km) - (-km) + 1;
  shape[1] = jm;
  out = na_make_object(NA_DFLOAT, 2, shape, cNArray);
  double* cnout = NA_PTR_TYPE(out,double*);
  int i;
  for (i=0;i<NA_TOTAL(out);i++)
    cnout[i] = cout[i];
};
  return out;
}

static VALUE
rbspml_eq_Initial(int argc, VALUE *argv, VALUE self)
{
  VALUE i, j, k, l, ra_in;
  int ci;
  int cj;
  int ck;
  int cl;
  double cra_in;

  rb_scan_args(argc, argv, "50", &i, &j, &k, &l, &ra_in);
  ci = NUM2INT(i);
  cj = NUM2INT(j);
  ck = NUM2INT(k);
  cl = NUM2INT(l);
  cra_in = NUM2DBL(ra_in);
  im = ci;
  jm = cj;
  km = ck;
  lm = cl;

#if defined IFORT
  eq_module_mp_eq_initial_(&ci, &cj, &ck, &cl, &cra_in);
#elif defined GFORTRAN
  __eq_module_MOD_eq_initial(&ci, &cj, &ck, &cl, &cra_in);
#elif defined(FFC32) || defined(FFC64)
  eq_module_eq_initial_(&ci, &cj, &ck, &cl, &cra_in);
#endif

  return Qnil;
}

static VALUE
rbspml_rp_eq(int argc, VALUE *argv, VALUE self)
{
  VALUE eq, out;
  double* ceq;
  struct farray* cout;

  rb_scan_args(argc, argv, "10", &eq);
  eq = na_cast_object(eq, NA_DFLOAT);
  ceq = NA_PTR_TYPE(eq, double*);
{
  int shape[2];
  shape[0] = jm;
  shape[1] = (im-1) - (0) + 1;
  out = na_make_object(NA_DFLOAT, 2, shape, cNArray);
  cout = (struct farray*) xmalloc(sizeof(struct farray)+sizeof(struct fshape)*2);
#if defined(IFORT) || defined(GFORTRAN)
{
  int i,j=1,offset=1;
  for (i=0;i<1;i++) {
    j = j*NA_STRUCT(out)->shape[i];
    offset += j;
  }
  cout->offset = -offset;
}
#endif
#if defined IFORT
  cout->vsize = sizeof(double);
{
  long type = 10;
  cout->type = ((type<<(sizeof(void*)*6)) | 1);
}
  cout->rank = 2;
#elif defined GFORTRAN
{
  cout->flag = (2 | (1<<4) | (sizeof(double)<<6));
}
#elif defined(FFC32) || defined(FFC64)
  cout->total = NA_STRUCT(out)->total;
  cout->total_byte = cout->total*sizeof(double);
#endif
{
  int step=1, len, i;
  struct fshape* fs;
  for (i=0;i<2;i++) {
    len = NA_STRUCT(out)->shape[i];
    fs = (struct fshape*)(cout+1)+i;
#if defined(IFORT) || defined(FFC32) || defined(FFC64)
    fs->step = 8*step;
    fs->length = len;
    fs->flag = 1;
#endif
#if defined(FFC32) || defined(FFC64)
    fs->length2 = len;
#endif
#ifdef GFORTRAN
    fs->step = step;
    fs->start = 1;
    fs->end = len;
#endif
    step *= len;
  }
}

  cout->array = NA_PTR_TYPE(out, void*);
};

#if defined IFORT
  eq_module_mp_rp_eq_(cout, ceq);
#elif defined GFORTRAN
  __eq_module_MOD_rp_eq(cout, ceq);
#elif defined(FFC32) || defined(FFC64)
  eq_module_rp_eq_(cout, ceq);
#endif

#if defined(FFC32) || defined(FFC64)
{
  double* cnout = NA_PTR_TYPE(out,double*);
  int i;
  for (i=0;i<NA_TOTAL(out);i++)
    cnout[i] = ((double*)cout->array)[i];
}
#endif
  free(cout);
  return out;
}

static VALUE
rbspml_eq_rp(int argc, VALUE *argv, VALUE self)
{
  VALUE rp, out;
  double* crp;
  struct farray* cout;

  rb_scan_args(argc, argv, "10", &rp);
  rp = na_cast_object(rp, NA_DFLOAT);
  crp = NA_PTR_TYPE(rp, double*);
{
  int shape[2];
  shape[0] = (km) - (-km) + 1;
  shape[1] = (lm) - (0) + 1;
  out = na_make_object(NA_DFLOAT, 2, shape, cNArray);
  cout = (struct farray*) xmalloc(sizeof(struct farray)+sizeof(struct fshape)*2);
#if defined(IFORT) || defined(GFORTRAN)
{
  int i,j=1,offset=1;
  for (i=0;i<1;i++) {
    j = j*NA_STRUCT(out)->shape[i];
    offset += j;
  }
  cout->offset = -offset;
}
#endif
#if defined IFORT
  cout->vsize = sizeof(double);
{
  long type = 10;
  cout->type = ((type<<(sizeof(void*)*6)) | 1);
}
  cout->rank = 2;
#elif defined GFORTRAN
{
  cout->flag = (2 | (1<<4) | (sizeof(double)<<6));
}
#elif defined(FFC32) || defined(FFC64)
  cout->total = NA_STRUCT(out)->total;
  cout->total_byte = cout->total*sizeof(double);
#endif
{
  int step=1, len, i;
  struct fshape* fs;
  for (i=0;i<2;i++) {
    len = NA_STRUCT(out)->shape[i];
    fs = (struct fshape*)(cout+1)+i;
#if defined(IFORT) || defined(FFC32) || defined(FFC64)
    fs->step = 8*step;
    fs->length = len;
    fs->flag = 1;
#endif
#if defined(FFC32) || defined(FFC64)
    fs->length2 = len;
#endif
#ifdef GFORTRAN
    fs->step = step;
    fs->start = 1;
    fs->end = len;
#endif
    step *= len;
  }
}

  cout->array = NA_PTR_TYPE(out, void*);
};

#if defined IFORT
  eq_module_mp_eq_rp_(cout, crp);
#elif defined GFORTRAN
  __eq_module_MOD_eq_rp(cout, crp);
#elif defined(FFC32) || defined(FFC64)
  eq_module_eq_rp_(cout, crp);
#endif

#if defined(FFC32) || defined(FFC64)
{
  double* cnout = NA_PTR_TYPE(out,double*);
  int i;
  for (i=0;i<NA_TOTAL(out);i++)
    cnout[i] = ((double*)cout->array)[i];
}
#endif
  free(cout);
  return out;
}

static VALUE
rbspml_eq_er(int argc, VALUE *argv, VALUE self)
{
  VALUE er, out;
  double* cer;
  struct farray* cout;

  rb_scan_args(argc, argv, "10", &er);
  er = na_cast_object(er, NA_DFLOAT);
  cer = NA_PTR_TYPE(er, double*);
{
  int shape[2];
  shape[0] = (km) - (-km) + 1;
  shape[1] = (lm) - (0) + 1;
  out = na_make_object(NA_DFLOAT, 2, shape, cNArray);
  cout = (struct farray*) xmalloc(sizeof(struct farray)+sizeof(struct fshape)*2);
#if defined(IFORT) || defined(GFORTRAN)
{
  int i,j=1,offset=1;
  for (i=0;i<1;i++) {
    j = j*NA_STRUCT(out)->shape[i];
    offset += j;
  }
  cout->offset = -offset;
}
#endif
#if defined IFORT
  cout->vsize = sizeof(double);
{
  long type = 10;
  cout->type = ((type<<(sizeof(void*)*6)) | 1);
}
  cout->rank = 2;
#elif defined GFORTRAN
{
  cout->flag = (2 | (1<<4) | (sizeof(double)<<6));
}
#elif defined(FFC32) || defined(FFC64)
  cout->total = NA_STRUCT(out)->total;
  cout->total_byte = cout->total*sizeof(double);
#endif
{
  int step=1, len, i;
  struct fshape* fs;
  for (i=0;i<2;i++) {
    len = NA_STRUCT(out)->shape[i];
    fs = (struct fshape*)(cout+1)+i;
#if defined(IFORT) || defined(FFC32) || defined(FFC64)
    fs->step = 8*step;
    fs->length = len;
    fs->flag = 1;
#endif
#if defined(FFC32) || defined(FFC64)
    fs->length2 = len;
#endif
#ifdef GFORTRAN
    fs->step = step;
    fs->start = 1;
    fs->end = len;
#endif
    step *= len;
  }
}

  cout->array = NA_PTR_TYPE(out, void*);
};

#if defined IFORT
  eq_module_mp_eq_er_(cout, cer);
#elif defined GFORTRAN
  __eq_module_MOD_eq_er(cout, cer);
#elif defined(FFC32) || defined(FFC64)
  eq_module_eq_er_(cout, cer);
#endif

#if defined(FFC32) || defined(FFC64)
{
  double* cnout = NA_PTR_TYPE(out,double*);
  int i;
  for (i=0;i<NA_TOTAL(out);i++)
    cnout[i] = ((double*)cout->array)[i];
}
#endif
  free(cout);
  return out;
}

static VALUE
rbspml_er_eq(int argc, VALUE *argv, VALUE self)
{
  VALUE eq, out;
  double* ceq;
  struct farray* cout;

  rb_scan_args(argc, argv, "10", &eq);
  eq = na_cast_object(eq, NA_DFLOAT);
  ceq = NA_PTR_TYPE(eq, double*);
{
  int shape[2];
  shape[0] = (km) - (-km) + 1;
  shape[1] = jm;
  out = na_make_object(NA_DFLOAT, 2, shape, cNArray);
  cout = (struct farray*) xmalloc(sizeof(struct farray)+sizeof(struct fshape)*2);
#if defined(IFORT) || defined(GFORTRAN)
{
  int i,j=1,offset=1;
  for (i=0;i<1;i++) {
    j = j*NA_STRUCT(out)->shape[i];
    offset += j;
  }
  cout->offset = -offset;
}
#endif
#if defined IFORT
  cout->vsize = sizeof(double);
{
  long type = 10;
  cout->type = ((type<<(sizeof(void*)*6)) | 1);
}
  cout->rank = 2;
#elif defined GFORTRAN
{
  cout->flag = (2 | (1<<4) | (sizeof(double)<<6));
}
#elif defined(FFC32) || defined(FFC64)
  cout->total = NA_STRUCT(out)->total;
  cout->total_byte = cout->total*sizeof(double);
#endif
{
  int step=1, len, i;
  struct fshape* fs;
  for (i=0;i<2;i++) {
    len = NA_STRUCT(out)->shape[i];
    fs = (struct fshape*)(cout+1)+i;
#if defined(IFORT) || defined(FFC32) || defined(FFC64)
    fs->step = 8*step;
    fs->length = len;
    fs->flag = 1;
#endif
#if defined(FFC32) || defined(FFC64)
    fs->length2 = len;
#endif
#ifdef GFORTRAN
    fs->step = step;
    fs->start = 1;
    fs->end = len;
#endif
    step *= len;
  }
}

  cout->array = NA_PTR_TYPE(out, void*);
};

#if defined IFORT
  eq_module_mp_er_eq_(cout, ceq);
#elif defined GFORTRAN
  __eq_module_MOD_er_eq(cout, ceq);
#elif defined(FFC32) || defined(FFC64)
  eq_module_er_eq_(cout, ceq);
#endif

#if defined(FFC32) || defined(FFC64)
{
  double* cnout = NA_PTR_TYPE(out,double*);
  int i;
  for (i=0;i<NA_TOTAL(out);i++)
    cnout[i] = ((double*)cout->array)[i];
}
#endif
  free(cout);
  return out;
}

static VALUE
rbspml_rp_er(int argc, VALUE *argv, VALUE self)
{
  VALUE er, out;
  double* cer;
  struct farray* cout;

  rb_scan_args(argc, argv, "10", &er);
  er = na_cast_object(er, NA_DFLOAT);
  cer = NA_PTR_TYPE(er, double*);
{
  int shape[2];
  shape[0] = jm;
  shape[1] = (im-1) - (0) + 1;
  out = na_make_object(NA_DFLOAT, 2, shape, cNArray);
  cout = (struct farray*) xmalloc(sizeof(struct farray)+sizeof(struct fshape)*2);
#if defined(IFORT) || defined(GFORTRAN)
{
  int i,j=1,offset=1;
  for (i=0;i<1;i++) {
    j = j*NA_STRUCT(out)->shape[i];
    offset += j;
  }
  cout->offset = -offset;
}
#endif
#if defined IFORT
  cout->vsize = sizeof(double);
{
  long type = 10;
  cout->type = ((type<<(sizeof(void*)*6)) | 1);
}
  cout->rank = 2;
#elif defined GFORTRAN
{
  cout->flag = (2 | (1<<4) | (sizeof(double)<<6));
}
#elif defined(FFC32) || defined(FFC64)
  cout->total = NA_STRUCT(out)->total;
  cout->total_byte = cout->total*sizeof(double);
#endif
{
  int step=1, len, i;
  struct fshape* fs;
  for (i=0;i<2;i++) {
    len = NA_STRUCT(out)->shape[i];
    fs = (struct fshape*)(cout+1)+i;
#if defined(IFORT) || defined(FFC32) || defined(FFC64)
    fs->step = 8*step;
    fs->length = len;
    fs->flag = 1;
#endif
#if defined(FFC32) || defined(FFC64)
    fs->length2 = len;
#endif
#ifdef GFORTRAN
    fs->step = step;
    fs->start = 1;
    fs->end = len;
#endif
    step *= len;
  }
}

  cout->array = NA_PTR_TYPE(out, void*);
};

#if defined IFORT
  eq_module_mp_rp_er_(cout, cer);
#elif defined GFORTRAN
  __eq_module_MOD_rp_er(cout, cer);
#elif defined(FFC32) || defined(FFC64)
  eq_module_rp_er_(cout, cer);
#endif

#if defined(FFC32) || defined(FFC64)
{
  double* cnout = NA_PTR_TYPE(out,double*);
  int i;
  for (i=0;i<NA_TOTAL(out);i++)
    cnout[i] = ((double*)cout->array)[i];
}
#endif
  free(cout);
  return out;
}

static VALUE
rbspml_er_rp(int argc, VALUE *argv, VALUE self)
{
  VALUE rp, out;
  double* crp;
  struct farray* cout;

  rb_scan_args(argc, argv, "10", &rp);
  rp = na_cast_object(rp, NA_DFLOAT);
  crp = NA_PTR_TYPE(rp, double*);
{
  int shape[2];
  shape[0] = (km) - (-km) + 1;
  shape[1] = jm;
  out = na_make_object(NA_DFLOAT, 2, shape, cNArray);
  cout = (struct farray*) xmalloc(sizeof(struct farray)+sizeof(struct fshape)*2);
#if defined(IFORT) || defined(GFORTRAN)
{
  int i,j=1,offset=1;
  for (i=0;i<1;i++) {
    j = j*NA_STRUCT(out)->shape[i];
    offset += j;
  }
  cout->offset = -offset;
}
#endif
#if defined IFORT
  cout->vsize = sizeof(double);
{
  long type = 10;
  cout->type = ((type<<(sizeof(void*)*6)) | 1);
}
  cout->rank = 2;
#elif defined GFORTRAN
{
  cout->flag = (2 | (1<<4) | (sizeof(double)<<6));
}
#elif defined(FFC32) || defined(FFC64)
  cout->total = NA_STRUCT(out)->total;
  cout->total_byte = cout->total*sizeof(double);
#endif
{
  int step=1, len, i;
  struct fshape* fs;
  for (i=0;i<2;i++) {
    len = NA_STRUCT(out)->shape[i];
    fs = (struct fshape*)(cout+1)+i;
#if defined(IFORT) || defined(FFC32) || defined(FFC64)
    fs->step = 8*step;
    fs->length = len;
    fs->flag = 1;
#endif
#if defined(FFC32) || defined(FFC64)
    fs->length2 = len;
#endif
#ifdef GFORTRAN
    fs->step = step;
    fs->start = 1;
    fs->end = len;
#endif
    step *= len;
  }
}

  cout->array = NA_PTR_TYPE(out, void*);
};

#if defined IFORT
  eq_module_mp_er_rp_(cout, crp);
#elif defined GFORTRAN
  __eq_module_MOD_er_rp(cout, crp);
#elif defined(FFC32) || defined(FFC64)
  eq_module_er_rp_(cout, crp);
#endif

#if defined(FFC32) || defined(FFC64)
{
  double* cnout = NA_PTR_TYPE(out,double*);
  int i;
  for (i=0;i<NA_TOTAL(out);i++)
    cnout[i] = ((double*)cout->array)[i];
}
#endif
  free(cout);
  return out;
}

static VALUE
rbspml_eq_DPhi_eq(int argc, VALUE *argv, VALUE self)
{
  VALUE eq, out;
  double* ceq;
  struct farray* cout;

  rb_scan_args(argc, argv, "10", &eq);
  eq = na_cast_object(eq, NA_DFLOAT);
  ceq = NA_PTR_TYPE(eq, double*);
{
  int shape[2];
  shape[0] = (km) - (-km) + 1;
  shape[1] = (lm) - (0) + 1;
  out = na_make_object(NA_DFLOAT, 2, shape, cNArray);
  cout = (struct farray*) xmalloc(sizeof(struct farray)+sizeof(struct fshape)*2);
#if defined(IFORT) || defined(GFORTRAN)
{
  int i,j=1,offset=1;
  for (i=0;i<1;i++) {
    j = j*NA_STRUCT(out)->shape[i];
    offset += j;
  }
  cout->offset = -offset;
}
#endif
#if defined IFORT
  cout->vsize = sizeof(double);
{
  long type = 10;
  cout->type = ((type<<(sizeof(void*)*6)) | 1);
}
  cout->rank = 2;
#elif defined GFORTRAN
{
  cout->flag = (2 | (1<<4) | (sizeof(double)<<6));
}
#elif defined(FFC32) || defined(FFC64)
  cout->total = NA_STRUCT(out)->total;
  cout->total_byte = cout->total*sizeof(double);
#endif
{
  int step=1, len, i;
  struct fshape* fs;
  for (i=0;i<2;i++) {
    len = NA_STRUCT(out)->shape[i];
    fs = (struct fshape*)(cout+1)+i;
#if defined(IFORT) || defined(FFC32) || defined(FFC64)
    fs->step = 8*step;
    fs->length = len;
    fs->flag = 1;
#endif
#if defined(FFC32) || defined(FFC64)
    fs->length2 = len;
#endif
#ifdef GFORTRAN
    fs->step = step;
    fs->start = 1;
    fs->end = len;
#endif
    step *= len;
  }
}

  cout->array = NA_PTR_TYPE(out, void*);
};

#if defined IFORT
  eq_module_mp_eq_dphi_eq_(cout, ceq);
#elif defined GFORTRAN
  __eq_module_MOD_eq_dphi_eq(cout, ceq);
#elif defined(FFC32) || defined(FFC64)
  eq_module_eq_dphi_eq_(cout, ceq);
#endif

#if defined(FFC32) || defined(FFC64)
{
  double* cnout = NA_PTR_TYPE(out,double*);
  int i;
  for (i=0;i<NA_TOTAL(out);i++)
    cnout[i] = ((double*)cout->array)[i];
}
#endif
  free(cout);
  return out;
}

static VALUE
rbspml_eq_RadDRad_eq(int argc, VALUE *argv, VALUE self)
{
  VALUE eq, out;
  double* ceq;
  struct farray* cout;

  rb_scan_args(argc, argv, "10", &eq);
  eq = na_cast_object(eq, NA_DFLOAT);
  ceq = NA_PTR_TYPE(eq, double*);
{
  int shape[2];
  shape[0] = (km) - (-km) + 1;
  shape[1] = (lm) - (0) + 1;
  out = na_make_object(NA_DFLOAT, 2, shape, cNArray);
  cout = (struct farray*) xmalloc(sizeof(struct farray)+sizeof(struct fshape)*2);
#if defined(IFORT) || defined(GFORTRAN)
{
  int i,j=1,offset=1;
  for (i=0;i<1;i++) {
    j = j*NA_STRUCT(out)->shape[i];
    offset += j;
  }
  cout->offset = -offset;
}
#endif
#if defined IFORT
  cout->vsize = sizeof(double);
{
  long type = 10;
  cout->type = ((type<<(sizeof(void*)*6)) | 1);
}
  cout->rank = 2;
#elif defined GFORTRAN
{
  cout->flag = (2 | (1<<4) | (sizeof(double)<<6));
}
#elif defined(FFC32) || defined(FFC64)
  cout->total = NA_STRUCT(out)->total;
  cout->total_byte = cout->total*sizeof(double);
#endif
{
  int step=1, len, i;
  struct fshape* fs;
  for (i=0;i<2;i++) {
    len = NA_STRUCT(out)->shape[i];
    fs = (struct fshape*)(cout+1)+i;
#if defined(IFORT) || defined(FFC32) || defined(FFC64)
    fs->step = 8*step;
    fs->length = len;
    fs->flag = 1;
#endif
#if defined(FFC32) || defined(FFC64)
    fs->length2 = len;
#endif
#ifdef GFORTRAN
    fs->step = step;
    fs->start = 1;
    fs->end = len;
#endif
    step *= len;
  }
}

  cout->array = NA_PTR_TYPE(out, void*);
};

#if defined IFORT
  eq_module_mp_eq_raddrad_eq_(cout, ceq);
#elif defined GFORTRAN
  __eq_module_MOD_eq_raddrad_eq(cout, ceq);
#elif defined(FFC32) || defined(FFC64)
  eq_module_eq_raddrad_eq_(cout, ceq);
#endif

#if defined(FFC32) || defined(FFC64)
{
  double* cnout = NA_PTR_TYPE(out,double*);
  int i;
  for (i=0;i<NA_TOTAL(out);i++)
    cnout[i] = ((double*)cout->array)[i];
}
#endif
  free(cout);
  return out;
}

static VALUE
rbspml_er_Lapla_eq(int argc, VALUE *argv, VALUE self)
{
  VALUE eq, out;
  double* ceq;
  struct farray* cout;

  rb_scan_args(argc, argv, "10", &eq);
  eq = na_cast_object(eq, NA_DFLOAT);
  ceq = NA_PTR_TYPE(eq, double*);
{
  int shape[2];
  shape[0] = (km) - (-km) + 1;
  shape[1] = jm;
  out = na_make_object(NA_DFLOAT, 2, shape, cNArray);
  cout = (struct farray*) xmalloc(sizeof(struct farray)+sizeof(struct fshape)*2);
#if defined(IFORT) || defined(GFORTRAN)
{
  int i,j=1,offset=1;
  for (i=0;i<1;i++) {
    j = j*NA_STRUCT(out)->shape[i];
    offset += j;
  }
  cout->offset = -offset;
}
#endif
#if defined IFORT
  cout->vsize = sizeof(double);
{
  long type = 10;
  cout->type = ((type<<(sizeof(void*)*6)) | 1);
}
  cout->rank = 2;
#elif defined GFORTRAN
{
  cout->flag = (2 | (1<<4) | (sizeof(double)<<6));
}
#elif defined(FFC32) || defined(FFC64)
  cout->total = NA_STRUCT(out)->total;
  cout->total_byte = cout->total*sizeof(double);
#endif
{
  int step=1, len, i;
  struct fshape* fs;
  for (i=0;i<2;i++) {
    len = NA_STRUCT(out)->shape[i];
    fs = (struct fshape*)(cout+1)+i;
#if defined(IFORT) || defined(FFC32) || defined(FFC64)
    fs->step = 8*step;
    fs->length = len;
    fs->flag = 1;
#endif
#if defined(FFC32) || defined(FFC64)
    fs->length2 = len;
#endif
#ifdef GFORTRAN
    fs->step = step;
    fs->start = 1;
    fs->end = len;
#endif
    step *= len;
  }
}

  cout->array = NA_PTR_TYPE(out, void*);
};

#if defined IFORT
  eq_module_mp_er_lapla_eq_(cout, ceq);
#elif defined GFORTRAN
  __eq_module_MOD_er_lapla_eq(cout, ceq);
#elif defined(FFC32) || defined(FFC64)
  eq_module_er_lapla_eq_(cout, ceq);
#endif

#if defined(FFC32) || defined(FFC64)
{
  double* cnout = NA_PTR_TYPE(out,double*);
  int i;
  for (i=0;i<NA_TOTAL(out);i++)
    cnout[i] = ((double*)cout->array)[i];
}
#endif
  free(cout);
  return out;
}

static VALUE
rbspml_eq_Lapla_eq(int argc, VALUE *argv, VALUE self)
{
  VALUE eq, out;
  double* ceq;
  struct farray* cout;

  rb_scan_args(argc, argv, "10", &eq);
  eq = na_cast_object(eq, NA_DFLOAT);
  ceq = NA_PTR_TYPE(eq, double*);
{
  int shape[2];
  shape[0] = (km) - (-km) + 1;
  shape[1] = (lm) - (0) + 1;
  out = na_make_object(NA_DFLOAT, 2, shape, cNArray);
  cout = (struct farray*) xmalloc(sizeof(struct farray)+sizeof(struct fshape)*2);
#if defined(IFORT) || defined(GFORTRAN)
{
  int i,j=1,offset=1;
  for (i=0;i<1;i++) {
    j = j*NA_STRUCT(out)->shape[i];
    offset += j;
  }
  cout->offset = -offset;
}
#endif
#if defined IFORT
  cout->vsize = sizeof(double);
{
  long type = 10;
  cout->type = ((type<<(sizeof(void*)*6)) | 1);
}
  cout->rank = 2;
#elif defined GFORTRAN
{
  cout->flag = (2 | (1<<4) | (sizeof(double)<<6));
}
#elif defined(FFC32) || defined(FFC64)
  cout->total = NA_STRUCT(out)->total;
  cout->total_byte = cout->total*sizeof(double);
#endif
{
  int step=1, len, i;
  struct fshape* fs;
  for (i=0;i<2;i++) {
    len = NA_STRUCT(out)->shape[i];
    fs = (struct fshape*)(cout+1)+i;
#if defined(IFORT) || defined(FFC32) || defined(FFC64)
    fs->step = 8*step;
    fs->length = len;
    fs->flag = 1;
#endif
#if defined(FFC32) || defined(FFC64)
    fs->length2 = len;
#endif
#ifdef GFORTRAN
    fs->step = step;
    fs->start = 1;
    fs->end = len;
#endif
    step *= len;
  }
}

  cout->array = NA_PTR_TYPE(out, void*);
};

#if defined IFORT
  eq_module_mp_eq_lapla_eq_(cout, ceq);
#elif defined GFORTRAN
  __eq_module_MOD_eq_lapla_eq(cout, ceq);
#elif defined(FFC32) || defined(FFC64)
  eq_module_eq_lapla_eq_(cout, ceq);
#endif

#if defined(FFC32) || defined(FFC64)
{
  double* cnout = NA_PTR_TYPE(out,double*);
  int i;
  for (i=0;i<NA_TOTAL(out);i++)
    cnout[i] = ((double*)cout->array)[i];
}
#endif
  free(cout);
  return out;
}

static VALUE
rbspml_eq_Jacobian_eq_eq(int argc, VALUE *argv, VALUE self)
{
  VALUE eq_a, eq_b, out;
  double* ceq_a;
  double* ceq_b;
  struct farray* cout;

  rb_scan_args(argc, argv, "20", &eq_a, &eq_b);
  eq_a = na_cast_object(eq_a, NA_DFLOAT);
  ceq_a = NA_PTR_TYPE(eq_a, double*);
  eq_b = na_cast_object(eq_b, NA_DFLOAT);
  ceq_b = NA_PTR_TYPE(eq_b, double*);
{
  int shape[2];
  shape[0] = (km) - (-km) + 1;
  shape[1] = (lm) - (0) + 1;
  out = na_make_object(NA_DFLOAT, 2, shape, cNArray);
  cout = (struct farray*) xmalloc(sizeof(struct farray)+sizeof(struct fshape)*2);
#if defined(IFORT) || defined(GFORTRAN)
{
  int i,j=1,offset=1;
  for (i=0;i<1;i++) {
    j = j*NA_STRUCT(out)->shape[i];
    offset += j;
  }
  cout->offset = -offset;
}
#endif
#if defined IFORT
  cout->vsize = sizeof(double);
{
  long type = 10;
  cout->type = ((type<<(sizeof(void*)*6)) | 1);
}
  cout->rank = 2;
#elif defined GFORTRAN
{
  cout->flag = (2 | (1<<4) | (sizeof(double)<<6));
}
#elif defined(FFC32) || defined(FFC64)
  cout->total = NA_STRUCT(out)->total;
  cout->total_byte = cout->total*sizeof(double);
#endif
{
  int step=1, len, i;
  struct fshape* fs;
  for (i=0;i<2;i++) {
    len = NA_STRUCT(out)->shape[i];
    fs = (struct fshape*)(cout+1)+i;
#if defined(IFORT) || defined(FFC32) || defined(FFC64)
    fs->step = 8*step;
    fs->length = len;
    fs->flag = 1;
#endif
#if defined(FFC32) || defined(FFC64)
    fs->length2 = len;
#endif
#ifdef GFORTRAN
    fs->step = step;
    fs->start = 1;
    fs->end = len;
#endif
    step *= len;
  }
}

  cout->array = NA_PTR_TYPE(out, void*);
};

#if defined IFORT
  eq_module_mp_eq_jacobian_eq_eq_(cout, ceq_a, ceq_b);
#elif defined GFORTRAN
  __eq_module_MOD_eq_jacobian_eq_eq(cout, ceq_a, ceq_b);
#elif defined(FFC32) || defined(FFC64)
  eq_module_eq_jacobian_eq_eq_(cout, ceq_a, ceq_b);
#endif

#if defined(FFC32) || defined(FFC64)
{
  double* cnout = NA_PTR_TYPE(out,double*);
  int i;
  for (i=0;i<NA_TOTAL(out);i++)
    cnout[i] = ((double*)cout->array)[i];
}
#endif
  free(cout);
  return out;
}

static VALUE
rbspml_eq_Boundary(int argc, VALUE *argv, VALUE self)
{
  VALUE eq, value, cond;
  double* ceq;
  double* cvalue;
  char* ccond;

  rb_scan_args(argc, argv, "12", &eq, &value, &cond);
  eq = na_cast_object(eq, NA_DFLOAT);
  ceq = NA_PTR_TYPE(eq, double*);
  if ( value != Qnil )
    value = na_cast_object(value, NA_DFLOAT);
  cvalue = NA_PTR_TYPE(value, double*);

  if ( cond != Qnil )
    ccond = RSTRING_PTR(cond);

#if defined IFORT
  eq_module_mp_eq_boundary_(ceq, value==Qnil ? NULL : cvalue, cond==Qnil ? NULL : ccond);
#elif defined GFORTRAN
  __eq_module_MOD_eq_boundary(ceq, value==Qnil ? NULL : cvalue, cond==Qnil ? NULL : ccond);
#elif defined(FFC32) || defined(FFC64)
  eq_module_eq_boundary_(ceq, value==Qnil ? NULL : cvalue, cond==Qnil ? NULL : ccond);
#endif

  if ( value != Qnil )
    free(cvalue);
  return eq;
}

static VALUE
rbspml_eq_LaplaInv_eq(int argc, VALUE *argv, VALUE self)
{
  VALUE eq, value, out;
  double* ceq;
  double* cvalue;
  struct farray* cout;

  rb_scan_args(argc, argv, "11", &eq, &value);
  eq = na_cast_object(eq, NA_DFLOAT);
  ceq = NA_PTR_TYPE(eq, double*);
  if ( value != Qnil )
    value = na_cast_object(value, NA_DFLOAT);
  cvalue = NA_PTR_TYPE(value, double*);

{
  int shape[2];
  shape[0] = (km) - (-km) + 1;
  shape[1] = (lm) - (0) + 1;
  out = na_make_object(NA_DFLOAT, 2, shape, cNArray);
  cout = (struct farray*) xmalloc(sizeof(struct farray)+sizeof(struct fshape)*2);
#if defined(IFORT) || defined(GFORTRAN)
{
  int i,j=1,offset=1;
  for (i=0;i<1;i++) {
    j = j*NA_STRUCT(out)->shape[i];
    offset += j;
  }
  cout->offset = -offset;
}
#endif
#if defined IFORT
  cout->vsize = sizeof(double);
{
  long type = 10;
  cout->type = ((type<<(sizeof(void*)*6)) | 1);
}
  cout->rank = 2;
#elif defined GFORTRAN
{
  cout->flag = (2 | (1<<4) | (sizeof(double)<<6));
}
#elif defined(FFC32) || defined(FFC64)
  cout->total = NA_STRUCT(out)->total;
  cout->total_byte = cout->total*sizeof(double);
#endif
{
  int step=1, len, i;
  struct fshape* fs;
  for (i=0;i<2;i++) {
    len = NA_STRUCT(out)->shape[i];
    fs = (struct fshape*)(cout+1)+i;
#if defined(IFORT) || defined(FFC32) || defined(FFC64)
    fs->step = 8*step;
    fs->length = len;
    fs->flag = 1;
#endif
#if defined(FFC32) || defined(FFC64)
    fs->length2 = len;
#endif
#ifdef GFORTRAN
    fs->step = step;
    fs->start = 1;
    fs->end = len;
#endif
    step *= len;
  }
}

  cout->array = NA_PTR_TYPE(out, void*);
};

#if defined IFORT
  eq_module_mp_eq_laplainv_eq_(cout, ceq, value==Qnil ? NULL : cvalue);
#elif defined GFORTRAN
  __eq_module_MOD_eq_laplainv_eq(cout, ceq, value==Qnil ? NULL : cvalue);
#elif defined(FFC32) || defined(FFC64)
  eq_module_eq_laplainv_eq_(cout, ceq, value==Qnil ? NULL : cvalue);
#endif

  if ( value != Qnil )
    free(cvalue);
#if defined(FFC32) || defined(FFC64)
{
  double* cnout = NA_PTR_TYPE(out,double*);
  int i;
  for (i=0;i<NA_TOTAL(out);i++)
    cnout[i] = ((double*)cout->array)[i];
}
#endif
  free(cout);
  return out;
}

static VALUE
rbspml_eq_Vor2Strm_eq(int argc, VALUE *argv, VALUE self)
{
  VALUE eq, value, cond, new, out;
  double* ceq;
  double cvalue;
  char* ccond;
  int cnew;
  struct farray* cout;

  rb_scan_args(argc, argv, "13", &eq, &value, &cond, &new);
  eq = na_cast_object(eq, NA_DFLOAT);
  ceq = NA_PTR_TYPE(eq, double*);
  if ( value != Qnil )
    cvalue = NUM2DBL(value);
  if ( cond != Qnil )
    ccond = RSTRING_PTR(cond);
  if ( new != Qnil )
    cnew = (new==Qtrue);
{
  int shape[2];
  shape[0] = (km) - (-km) + 1;
  shape[1] = (lm) - (0) + 1;
  out = na_make_object(NA_DFLOAT, 2, shape, cNArray);
  cout = (struct farray*) xmalloc(sizeof(struct farray)+sizeof(struct fshape)*2);
#if defined(IFORT) || defined(GFORTRAN)
{
  int i,j=1,offset=1;
  for (i=0;i<1;i++) {
    j = j*NA_STRUCT(out)->shape[i];
    offset += j;
  }
  cout->offset = -offset;
}
#endif
#if defined IFORT
  cout->vsize = sizeof(double);
{
  long type = 10;
  cout->type = ((type<<(sizeof(void*)*6)) | 1);
}
  cout->rank = 2;
#elif defined GFORTRAN
{
  cout->flag = (2 | (1<<4) | (sizeof(double)<<6));
}
#elif defined(FFC32) || defined(FFC64)
  cout->total = NA_STRUCT(out)->total;
  cout->total_byte = cout->total*sizeof(double);
#endif
{
  int step=1, len, i;
  struct fshape* fs;
  for (i=0;i<2;i++) {
    len = NA_STRUCT(out)->shape[i];
    fs = (struct fshape*)(cout+1)+i;
#if defined(IFORT) || defined(FFC32) || defined(FFC64)
    fs->step = 8*step;
    fs->length = len;
    fs->flag = 1;
#endif
#if defined(FFC32) || defined(FFC64)
    fs->length2 = len;
#endif
#ifdef GFORTRAN
    fs->step = step;
    fs->start = 1;
    fs->end = len;
#endif
    step *= len;
  }
}

  cout->array = NA_PTR_TYPE(out, void*);
};

#if defined IFORT
  eq_module_mp_eq_vor2strm_eq_(cout, ceq, value==Qnil ? NULL : &cvalue, cond==Qnil ? NULL : ccond, new==Qnil ? NULL : &cnew);
#elif defined GFORTRAN
  __eq_module_MOD_eq_vor2strm_eq(cout, ceq, value==Qnil ? NULL : &cvalue, cond==Qnil ? NULL : ccond, new==Qnil ? NULL : &cnew);
#elif defined(FFC32) || defined(FFC64)
  eq_module_eq_vor2strm_eq_(cout, ceq, value==Qnil ? NULL : &cvalue, cond==Qnil ? NULL : ccond, new==Qnil ? NULL : &cnew);
#endif

#if defined(FFC32) || defined(FFC64)
{
  double* cnout = NA_PTR_TYPE(out,double*);
  int i;
  for (i=0;i<NA_TOTAL(out);i++)
    cnout[i] = ((double*)cout->array)[i];
}
#endif
  free(cout);
  return out;
}

static VALUE
rbspml_IntRadPhi_rp(int argc, VALUE *argv, VALUE self)
{
  VALUE rp, out;
  double* crp;
  double cout;

  rb_scan_args(argc, argv, "10", &rp);
  rp = na_cast_object(rp, NA_DFLOAT);
  crp = NA_PTR_TYPE(rp, double*);

#if defined IFORT
  cout = eq_module_mp_intradphi_rp_(crp);
#elif defined GFORTRAN
  cout = __eq_module_MOD_intradphi_rp(crp);
#elif defined(FFC32) || defined(FFC64)
  cout = eq_module_intradphi_rp_(crp);
#endif

  out = rb_float_new(cout);
  return out;
}

static VALUE
rbspml_r_IntPhi_rp(int argc, VALUE *argv, VALUE self)
{
  VALUE rp, out;
  double* crp;
  struct farray* cout;

  rb_scan_args(argc, argv, "10", &rp);
  rp = na_cast_object(rp, NA_DFLOAT);
  crp = NA_PTR_TYPE(rp, double*);
{
  int shape[1];
  shape[0] = jm;
  out = na_make_object(NA_DFLOAT, 1, shape, cNArray);
  cout = (struct farray*) xmalloc(sizeof(struct farray)+sizeof(struct fshape)*1);
#if defined(IFORT) || defined(GFORTRAN)
{
  int i,j=1,offset=1;
  for (i=0;i<0;i++) {
    j = j*NA_STRUCT(out)->shape[i];
    offset += j;
  }
  cout->offset = -offset;
}
#endif
#if defined IFORT
  cout->vsize = sizeof(double);
{
  long type = 10;
  cout->type = ((type<<(sizeof(void*)*6)) | 1);
}
  cout->rank = 1;
#elif defined GFORTRAN
{
  cout->flag = (1 | (1<<4) | (sizeof(double)<<6));
}
#elif defined(FFC32) || defined(FFC64)
  cout->total = NA_STRUCT(out)->total;
  cout->total_byte = cout->total*sizeof(double);
#endif
{
  int step=1, len, i;
  struct fshape* fs;
  for (i=0;i<1;i++) {
    len = NA_STRUCT(out)->shape[i];
    fs = (struct fshape*)(cout+1)+i;
#if defined(IFORT) || defined(FFC32) || defined(FFC64)
    fs->step = 8*step;
    fs->length = len;
    fs->flag = 1;
#endif
#if defined(FFC32) || defined(FFC64)
    fs->length2 = len;
#endif
#ifdef GFORTRAN
    fs->step = step;
    fs->start = 1;
    fs->end = len;
#endif
    step *= len;
  }
}

  cout->array = NA_PTR_TYPE(out, void*);
};

#if defined IFORT
  eq_module_mp_r_intphi_rp_(cout, crp);
#elif defined GFORTRAN
  __eq_module_MOD_r_intphi_rp(cout, crp);
#elif defined(FFC32) || defined(FFC64)
  eq_module_r_intphi_rp_(cout, crp);
#endif

#if defined(FFC32) || defined(FFC64)
{
  double* cnout = NA_PTR_TYPE(out,double*);
  int i;
  for (i=0;i<NA_TOTAL(out);i++)
    cnout[i] = ((double*)cout->array)[i];
}
#endif
  free(cout);
  return out;
}

static VALUE
rbspml_p_IntRad_rp(int argc, VALUE *argv, VALUE self)
{
  VALUE rp, out;
  double* crp;
  struct farray* cout;

  rb_scan_args(argc, argv, "10", &rp);
  rp = na_cast_object(rp, NA_DFLOAT);
  crp = NA_PTR_TYPE(rp, double*);
{
  int shape[1];
  shape[0] = (im-1) - (0) + 1;
  out = na_make_object(NA_DFLOAT, 1, shape, cNArray);
  cout = (struct farray*) xmalloc(sizeof(struct farray)+sizeof(struct fshape)*1);
#if defined(IFORT) || defined(GFORTRAN)
{
  int i,j=1,offset=1;
  for (i=0;i<0;i++) {
    j = j*NA_STRUCT(out)->shape[i];
    offset += j;
  }
  cout->offset = -offset;
}
#endif
#if defined IFORT
  cout->vsize = sizeof(double);
{
  long type = 10;
  cout->type = ((type<<(sizeof(void*)*6)) | 1);
}
  cout->rank = 1;
#elif defined GFORTRAN
{
  cout->flag = (1 | (1<<4) | (sizeof(double)<<6));
}
#elif defined(FFC32) || defined(FFC64)
  cout->total = NA_STRUCT(out)->total;
  cout->total_byte = cout->total*sizeof(double);
#endif
{
  int step=1, len, i;
  struct fshape* fs;
  for (i=0;i<1;i++) {
    len = NA_STRUCT(out)->shape[i];
    fs = (struct fshape*)(cout+1)+i;
#if defined(IFORT) || defined(FFC32) || defined(FFC64)
    fs->step = 8*step;
    fs->length = len;
    fs->flag = 1;
#endif
#if defined(FFC32) || defined(FFC64)
    fs->length2 = len;
#endif
#ifdef GFORTRAN
    fs->step = step;
    fs->start = 1;
    fs->end = len;
#endif
    step *= len;
  }
}

  cout->array = NA_PTR_TYPE(out, void*);
};

#if defined IFORT
  eq_module_mp_p_intrad_rp_(cout, crp);
#elif defined GFORTRAN
  __eq_module_MOD_p_intrad_rp(cout, crp);
#elif defined(FFC32) || defined(FFC64)
  eq_module_p_intrad_rp_(cout, crp);
#endif

#if defined(FFC32) || defined(FFC64)
{
  double* cnout = NA_PTR_TYPE(out,double*);
  int i;
  for (i=0;i<NA_TOTAL(out);i++)
    cnout[i] = ((double*)cout->array)[i];
}
#endif
  free(cout);
  return out;
}

static VALUE
rbspml_IntPhi_p(int argc, VALUE *argv, VALUE self)
{
  VALUE p, out;
  double* cp;
  double cout;

  rb_scan_args(argc, argv, "10", &p);
  p = na_cast_object(p, NA_DFLOAT);
  cp = NA_PTR_TYPE(p, double*);

#if defined IFORT
  cout = eq_module_mp_intphi_p_(cp);
#elif defined GFORTRAN
  cout = __eq_module_MOD_intphi_p(cp);
#elif defined(FFC32) || defined(FFC64)
  cout = eq_module_intphi_p_(cp);
#endif

  out = rb_float_new(cout);
  return out;
}

static VALUE
rbspml_IntRad_r(int argc, VALUE *argv, VALUE self)
{
  VALUE r, out;
  double* cr;
  double cout;

  rb_scan_args(argc, argv, "10", &r);
  r = na_cast_object(r, NA_DFLOAT);
  cr = NA_PTR_TYPE(r, double*);

#if defined IFORT
  cout = eq_module_mp_intrad_r_(cr);
#elif defined GFORTRAN
  cout = __eq_module_MOD_intrad_r(cr);
#elif defined(FFC32) || defined(FFC64)
  cout = eq_module_intrad_r_(cr);
#endif

  out = rb_float_new(cout);
  return out;
}

static VALUE
rbspml_AvrRadPhi_rp(int argc, VALUE *argv, VALUE self)
{
  VALUE rp, out;
  double* crp;
  double cout;

  rb_scan_args(argc, argv, "10", &rp);
  rp = na_cast_object(rp, NA_DFLOAT);
  crp = NA_PTR_TYPE(rp, double*);

#if defined IFORT
  cout = eq_module_mp_avrradphi_rp_(crp);
#elif defined GFORTRAN
  cout = __eq_module_MOD_avrradphi_rp(crp);
#elif defined(FFC32) || defined(FFC64)
  cout = eq_module_avrradphi_rp_(crp);
#endif

  out = rb_float_new(cout);
  return out;
}

static VALUE
rbspml_r_AvrPhi_rp(int argc, VALUE *argv, VALUE self)
{
  VALUE rp, out;
  double* crp;
  struct farray* cout;

  rb_scan_args(argc, argv, "10", &rp);
  rp = na_cast_object(rp, NA_DFLOAT);
  crp = NA_PTR_TYPE(rp, double*);
{
  int shape[1];
  shape[0] = jm;
  out = na_make_object(NA_DFLOAT, 1, shape, cNArray);
  cout = (struct farray*) xmalloc(sizeof(struct farray)+sizeof(struct fshape)*1);
#if defined(IFORT) || defined(GFORTRAN)
{
  int i,j=1,offset=1;
  for (i=0;i<0;i++) {
    j = j*NA_STRUCT(out)->shape[i];
    offset += j;
  }
  cout->offset = -offset;
}
#endif
#if defined IFORT
  cout->vsize = sizeof(double);
{
  long type = 10;
  cout->type = ((type<<(sizeof(void*)*6)) | 1);
}
  cout->rank = 1;
#elif defined GFORTRAN
{
  cout->flag = (1 | (1<<4) | (sizeof(double)<<6));
}
#elif defined(FFC32) || defined(FFC64)
  cout->total = NA_STRUCT(out)->total;
  cout->total_byte = cout->total*sizeof(double);
#endif
{
  int step=1, len, i;
  struct fshape* fs;
  for (i=0;i<1;i++) {
    len = NA_STRUCT(out)->shape[i];
    fs = (struct fshape*)(cout+1)+i;
#if defined(IFORT) || defined(FFC32) || defined(FFC64)
    fs->step = 8*step;
    fs->length = len;
    fs->flag = 1;
#endif
#if defined(FFC32) || defined(FFC64)
    fs->length2 = len;
#endif
#ifdef GFORTRAN
    fs->step = step;
    fs->start = 1;
    fs->end = len;
#endif
    step *= len;
  }
}

  cout->array = NA_PTR_TYPE(out, void*);
};

#if defined IFORT
  eq_module_mp_r_avrphi_rp_(cout, crp);
#elif defined GFORTRAN
  __eq_module_MOD_r_avrphi_rp(cout, crp);
#elif defined(FFC32) || defined(FFC64)
  eq_module_r_avrphi_rp_(cout, crp);
#endif

#if defined(FFC32) || defined(FFC64)
{
  double* cnout = NA_PTR_TYPE(out,double*);
  int i;
  for (i=0;i<NA_TOTAL(out);i++)
    cnout[i] = ((double*)cout->array)[i];
}
#endif
  free(cout);
  return out;
}

static VALUE
rbspml_p_AvrRad_rp(int argc, VALUE *argv, VALUE self)
{
  VALUE rp, out;
  double* crp;
  struct farray* cout;

  rb_scan_args(argc, argv, "10", &rp);
  rp = na_cast_object(rp, NA_DFLOAT);
  crp = NA_PTR_TYPE(rp, double*);
{
  int shape[1];
  shape[0] = (im-1) - (0) + 1;
  out = na_make_object(NA_DFLOAT, 1, shape, cNArray);
  cout = (struct farray*) xmalloc(sizeof(struct farray)+sizeof(struct fshape)*1);
#if defined(IFORT) || defined(GFORTRAN)
{
  int i,j=1,offset=1;
  for (i=0;i<0;i++) {
    j = j*NA_STRUCT(out)->shape[i];
    offset += j;
  }
  cout->offset = -offset;
}
#endif
#if defined IFORT
  cout->vsize = sizeof(double);
{
  long type = 10;
  cout->type = ((type<<(sizeof(void*)*6)) | 1);
}
  cout->rank = 1;
#elif defined GFORTRAN
{
  cout->flag = (1 | (1<<4) | (sizeof(double)<<6));
}
#elif defined(FFC32) || defined(FFC64)
  cout->total = NA_STRUCT(out)->total;
  cout->total_byte = cout->total*sizeof(double);
#endif
{
  int step=1, len, i;
  struct fshape* fs;
  for (i=0;i<1;i++) {
    len = NA_STRUCT(out)->shape[i];
    fs = (struct fshape*)(cout+1)+i;
#if defined(IFORT) || defined(FFC32) || defined(FFC64)
    fs->step = 8*step;
    fs->length = len;
    fs->flag = 1;
#endif
#if defined(FFC32) || defined(FFC64)
    fs->length2 = len;
#endif
#ifdef GFORTRAN
    fs->step = step;
    fs->start = 1;
    fs->end = len;
#endif
    step *= len;
  }
}

  cout->array = NA_PTR_TYPE(out, void*);
};

#if defined IFORT
  eq_module_mp_p_avrrad_rp_(cout, crp);
#elif defined GFORTRAN
  __eq_module_MOD_p_avrrad_rp(cout, crp);
#elif defined(FFC32) || defined(FFC64)
  eq_module_p_avrrad_rp_(cout, crp);
#endif

#if defined(FFC32) || defined(FFC64)
{
  double* cnout = NA_PTR_TYPE(out,double*);
  int i;
  for (i=0;i<NA_TOTAL(out);i++)
    cnout[i] = ((double*)cout->array)[i];
}
#endif
  free(cout);
  return out;
}

static VALUE
rbspml_AvrPhi_p(int argc, VALUE *argv, VALUE self)
{
  VALUE p, out;
  double* cp;
  double cout;

  rb_scan_args(argc, argv, "10", &p);
  p = na_cast_object(p, NA_DFLOAT);
  cp = NA_PTR_TYPE(p, double*);

#if defined IFORT
  cout = eq_module_mp_avrphi_p_(cp);
#elif defined GFORTRAN
  cout = __eq_module_MOD_avrphi_p(cp);
#elif defined(FFC32) || defined(FFC64)
  cout = eq_module_avrphi_p_(cp);
#endif

  out = rb_float_new(cout);
  return out;
}

static VALUE
rbspml_AvrRad_r(int argc, VALUE *argv, VALUE self)
{
  VALUE r, out;
  double* cr;
  double cout;

  rb_scan_args(argc, argv, "10", &r);
  r = na_cast_object(r, NA_DFLOAT);
  cr = NA_PTR_TYPE(r, double*);

#if defined IFORT
  cout = eq_module_mp_avrrad_r_(cr);
#elif defined GFORTRAN
  cout = __eq_module_MOD_avrrad_r(cr);
#elif defined(FFC32) || defined(FFC64)
  cout = eq_module_avrrad_r_(cr);
#endif

  out = rb_float_new(cout);
  return out;
}


void init_eq_module(VALUE mSPML)
{
  VALUE mEQ;

  mEQ = rb_define_module_under(mSPML, "EQ");

  rb_define_module_function(mEQ, "rp_Phi", rbspml_rp_Phi, -1);
  rb_define_method(mEQ, "rp_Phi", rbspml_rp_Phi, -1);
  rb_define_module_function(mEQ, "rp_Rad", rbspml_rp_Rad, -1);
  rb_define_method(mEQ, "rp_Rad", rbspml_rp_Rad, -1);
  rb_define_module_function(mEQ, "er_Rad", rbspml_er_Rad, -1);
  rb_define_method(mEQ, "er_Rad", rbspml_er_Rad, -1);
  rb_define_module_function(mEQ, "initial", rbspml_eq_Initial, -1);
  rb_define_method(mEQ, "initial", rbspml_eq_Initial, -1);
  rb_define_module_function(mEQ, "rp_eq", rbspml_rp_eq, -1);
  rb_define_method(mEQ, "rp_eq", rbspml_rp_eq, -1);
  rb_define_module_function(mEQ, "eq_rp", rbspml_eq_rp, -1);
  rb_define_method(mEQ, "eq_rp", rbspml_eq_rp, -1);
  rb_define_module_function(mEQ, "eq_er", rbspml_eq_er, -1);
  rb_define_method(mEQ, "eq_er", rbspml_eq_er, -1);
  rb_define_module_function(mEQ, "er_eq", rbspml_er_eq, -1);
  rb_define_method(mEQ, "er_eq", rbspml_er_eq, -1);
  rb_define_module_function(mEQ, "rp_er", rbspml_rp_er, -1);
  rb_define_method(mEQ, "rp_er", rbspml_rp_er, -1);
  rb_define_module_function(mEQ, "er_rp", rbspml_er_rp, -1);
  rb_define_method(mEQ, "er_rp", rbspml_er_rp, -1);
  rb_define_module_function(mEQ, "eq_DPhi_eq", rbspml_eq_DPhi_eq, -1);
  rb_define_method(mEQ, "eq_DPhi_eq", rbspml_eq_DPhi_eq, -1);
  rb_define_module_function(mEQ, "eq_RadDRad_eq", rbspml_eq_RadDRad_eq, -1);
  rb_define_method(mEQ, "eq_RadDRad_eq", rbspml_eq_RadDRad_eq, -1);
  rb_define_module_function(mEQ, "er_Lapla_eq", rbspml_er_Lapla_eq, -1);
  rb_define_method(mEQ, "er_Lapla_eq", rbspml_er_Lapla_eq, -1);
  rb_define_module_function(mEQ, "eq_Lapla_eq", rbspml_eq_Lapla_eq, -1);
  rb_define_method(mEQ, "eq_Lapla_eq", rbspml_eq_Lapla_eq, -1);
  rb_define_module_function(mEQ, "eq_Jacobian_eq_eq", rbspml_eq_Jacobian_eq_eq, -1);
  rb_define_method(mEQ, "eq_Jacobian_eq_eq", rbspml_eq_Jacobian_eq_eq, -1);
  rb_define_module_function(mEQ, "eq_Boundary", rbspml_eq_Boundary, -1);
  rb_define_method(mEQ, "eq_Boundary", rbspml_eq_Boundary, -1);
  rb_define_module_function(mEQ, "eq_LaplaInv_eq", rbspml_eq_LaplaInv_eq, -1);
  rb_define_method(mEQ, "eq_LaplaInv_eq", rbspml_eq_LaplaInv_eq, -1);
  rb_define_module_function(mEQ, "eq_Vor2Strm_eq", rbspml_eq_Vor2Strm_eq, -1);
  rb_define_method(mEQ, "eq_Vor2Strm_eq", rbspml_eq_Vor2Strm_eq, -1);
  rb_define_module_function(mEQ, "IntRadPhi_rp", rbspml_IntRadPhi_rp, -1);
  rb_define_method(mEQ, "IntRadPhi_rp", rbspml_IntRadPhi_rp, -1);
  rb_define_module_function(mEQ, "r_IntPhi_rp", rbspml_r_IntPhi_rp, -1);
  rb_define_method(mEQ, "r_IntPhi_rp", rbspml_r_IntPhi_rp, -1);
  rb_define_module_function(mEQ, "p_IntRad_rp", rbspml_p_IntRad_rp, -1);
  rb_define_method(mEQ, "p_IntRad_rp", rbspml_p_IntRad_rp, -1);
  rb_define_module_function(mEQ, "IntPhi_p", rbspml_IntPhi_p, -1);
  rb_define_method(mEQ, "IntPhi_p", rbspml_IntPhi_p, -1);
  rb_define_module_function(mEQ, "IntRad_r", rbspml_IntRad_r, -1);
  rb_define_method(mEQ, "IntRad_r", rbspml_IntRad_r, -1);
  rb_define_module_function(mEQ, "AvrRadPhi_rp", rbspml_AvrRadPhi_rp, -1);
  rb_define_method(mEQ, "AvrRadPhi_rp", rbspml_AvrRadPhi_rp, -1);
  rb_define_module_function(mEQ, "r_AvrPhi_rp", rbspml_r_AvrPhi_rp, -1);
  rb_define_method(mEQ, "r_AvrPhi_rp", rbspml_r_AvrPhi_rp, -1);
  rb_define_module_function(mEQ, "p_AvrRad_rp", rbspml_p_AvrRad_rp, -1);
  rb_define_method(mEQ, "p_AvrRad_rp", rbspml_p_AvrRad_rp, -1);
  rb_define_module_function(mEQ, "AvrPhi_p", rbspml_AvrPhi_p, -1);
  rb_define_method(mEQ, "AvrPhi_p", rbspml_AvrPhi_p, -1);
  rb_define_module_function(mEQ, "AvrRad_r", rbspml_AvrRad_r, -1);
  rb_define_method(mEQ, "AvrRad_r", rbspml_AvrRad_r, -1);
}
