#include "ruby.h"
#include "narray.h"

void init_ae_module(VALUE);
void init_aq_module(VALUE);
void init_at_module(VALUE);
void init_au_module(VALUE);
void init_ee_module(VALUE);
void init_eee_module(VALUE);
void init_eq_module(VALUE);
void init_esc_module(VALUE);
void init_et_galerkin_module(VALUE);
void init_et_module(VALUE);
void init_l_module(VALUE);
void init_la_module(VALUE);
void init_w_base_module(VALUE);
void init_w_deriv_module(VALUE);
void init_w_integral_module(VALUE);
void init_w_interpolate_module(VALUE);
void init_w_module(VALUE);
void init_w_spectrum_module(VALUE);
void init_w_zonal_module(VALUE);
void init_wa_base_module(VALUE);
void init_wa_deriv_module(VALUE);
void init_wa_integral_module(VALUE);
void init_wa_interpolate_module(VALUE);
void init_wa_module(VALUE);
void init_wa_spectrum_module(VALUE);
void init_wa_zonal_module(VALUE);
void init_wq_module(VALUE);
void init_wt_galerkin_module(VALUE);
void init_wt_module(VALUE);
void init_wt_zonal_module(VALUE);
void init_wtu_module(VALUE);
void init_wu_module(VALUE);
void Init_spml(){
  VALUE mNumRu, mSPML;

  mNumRu = rb_define_module("NumRu");
  mSPML = rb_define_module_under(mNumRu, "SPML");

  init_ae_module(mSPML);
  init_aq_module(mSPML);
  init_at_module(mSPML);
  init_au_module(mSPML);
  init_ee_module(mSPML);
  init_eee_module(mSPML);
  init_eq_module(mSPML);
  init_esc_module(mSPML);
  init_et_galerkin_module(mSPML);
  init_et_module(mSPML);
  init_l_module(mSPML);
  init_la_module(mSPML);
  init_w_base_module(mSPML);
  init_w_deriv_module(mSPML);
  init_w_integral_module(mSPML);
  init_w_interpolate_module(mSPML);
  init_w_module(mSPML);
  init_w_spectrum_module(mSPML);
  init_w_zonal_module(mSPML);
  init_wa_base_module(mSPML);
  init_wa_deriv_module(mSPML);
  init_wa_integral_module(mSPML);
  init_wa_interpolate_module(mSPML);
  init_wa_module(mSPML);
  init_wa_spectrum_module(mSPML);
  init_wa_zonal_module(mSPML);
  init_wq_module(mSPML);
  init_wt_galerkin_module(mSPML);
  init_wt_module(mSPML);
  init_wt_zonal_module(mSPML);
  init_wtu_module(mSPML);
  init_wu_module(mSPML);
}
int abort_(){
  rb_raise(rb_eRuntimeError, "Error occured in the Fortran");
}
