#include <stdlib.h>
#include "ruby.h"
#include "narray.h"

struct fshape {
#if defined IFORT
  long length;
  long step;
  long flag;
#elif defined GFORTRAN
  long step;
  long start;
  long end;
#elif defined(FFC32) || defined(FFC64)
  long flag;
  long length;
  long step;
  long length2;
#endif
};
struct farray {
#ifdef IFORT
  void* array;
  long vsize;
  long offset;
  long type;
  long rank;
  long dummy;
#elif defined GFORTRAN
  void *array;
  long offset;
  long flag;
#elif defined(FFC32) || defined(FFC64)
  void* array;
  long total_byte;
  long total;
#endif
};
