#include "ruby-spml.h"

#ifdef IFORT
extern void wt_galerkin_module_mp_wt_galerkin_initial_(int*, int*, int*, int*, int*, double*, double*, int*, int*, int*, int*, char*, double*, double*, double*, double*, double*, double*, double*, double*, int*);
extern struct farray* wt_galerkin_module_mp_wq_laplapol2pol_wt_(struct farray*, double*);
#endif
#ifdef GFORTRAN
extern void __wt_galerkin_module_MOD_wt_galerkin_initial(int*, int*, int*, int*, int*, double*, double*, int*, int*, int*, int*, char*, double*, double*, double*, double*, double*, double*, double*, double*, int*);
extern struct farray* __wt_galerkin_module_MOD_wq_laplapol2pol_wt(struct farray*, double*);
#endif
#ifdef FFC32
asm ("wt_galerkin_module_wt_galerkin_initial_:");
asm ("  pushl %ebp");
asm ("  movl %esp,%ebp");
asm ("  movl 88(%ebp), %eax");
asm ("  pushl %eax");
asm ("  movl 84(%ebp), %eax");
asm ("  pushl %eax");
asm ("  movl 80(%ebp), %eax");
asm ("  pushl %eax");
asm ("  movl 76(%ebp), %eax");
asm ("  pushl %eax");
asm ("  movl 72(%ebp), %eax");
asm ("  pushl %eax");
asm ("  movl 68(%ebp), %eax");
asm ("  pushl %eax");
asm ("  movl 64(%ebp), %eax");
asm ("  pushl %eax");
asm ("  movl 60(%ebp), %eax");
asm ("  pushl %eax");
asm ("  movl 56(%ebp), %eax");
asm ("  pushl %eax");
asm ("  movl 52(%ebp), %eax");
asm ("  pushl %eax");
asm ("  movl 48(%ebp), %eax");
asm ("  pushl %eax");
asm ("  movl 44(%ebp), %eax");
asm ("  pushl %eax");
asm ("  movl 40(%ebp), %eax");
asm ("  pushl %eax");
asm ("  movl 36(%ebp), %eax");
asm ("  pushl %eax");
asm ("  movl 32(%ebp), %eax");
asm ("  pushl %eax");
asm ("  movl 28(%ebp), %eax");
asm ("  pushl %eax");
asm ("  movl 24(%ebp), %eax");
asm ("  pushl %eax");
asm ("  movl 20(%ebp), %eax");
asm ("  pushl %eax");
asm ("  movl 16(%ebp), %eax");
asm ("  pushl %eax");
asm ("  movl 12(%ebp), %eax");
asm ("  pushl %eax");
asm ("  movl 8(%ebp), %eax");
asm ("  pushl %eax");
asm ("  call wt_galerkin_module.wt_galerkin_initial_");
asm ("  leave");
asm ("  ret");
asm ("wt_galerkin_module_wq_laplapol2pol_wt_:");
asm ("  pushl %ebp");
asm ("  movl %esp,%ebp");
asm ("  movl 12(%ebp), %eax");
asm ("  pushl %eax");
asm ("  movl 8(%ebp), %eax");
asm ("  pushl %eax");
asm ("  call wt_galerkin_module.wq_laplapol2pol_wt_");
asm ("  leave");
asm ("  ret");
#endif
#ifdef FFC64
asm ("wt_galerkin_module_wt_galerkin_initial_:");
asm ("  push %rbp");
asm ("  movq %rsp,%rbp");
asm ("  subq $256,%rsp");
asm ("  movq %rbx,-8(%rbp)");
asm ("  movq 16(%rbp),%r10");
asm ("  movq %r10,0(%rsp)");
asm ("  movq 24(%rbp),%r10");
asm ("  movq %r10,8(%rsp)");
asm ("  movq 32(%rbp),%r10");
asm ("  movq %r10,16(%rsp)");
asm ("  movq 40(%rbp),%r10");
asm ("  movq %r10,24(%rsp)");
asm ("  movq 48(%rbp),%r10");
asm ("  movq %r10,32(%rsp)");
asm ("  movq 56(%rbp),%r10");
asm ("  movq %r10,40(%rsp)");
asm ("  movq 64(%rbp),%r10");
asm ("  movq %r10,48(%rsp)");
asm ("  movq 72(%rbp),%r10");
asm ("  movq %r10,56(%rsp)");
asm ("  movq 80(%rbp),%r10");
asm ("  movq %r10,64(%rsp)");
asm ("  movq 88(%rbp),%r10");
asm ("  movq %r10,72(%rsp)");
asm ("  movq 96(%rbp),%r10");
asm ("  movq %r10,80(%rsp)");
asm ("  movq 104(%rbp),%r10");
asm ("  movq %r10,88(%rsp)");
asm ("  movq 112(%rbp),%r10");
asm ("  movq %r10,96(%rsp)");
asm ("  movq 120(%rbp),%r10");
asm ("  movq %r10,104(%rsp)");
asm ("  movq 128(%rbp),%r10");
asm ("  movq %r10,112(%rsp)");
asm ("  call wt_galerkin_module.wt_galerkin_initial_@PLT");
asm ("  movq -8(%rbp),%rbx");
asm ("  xorq %rax,%rax");
asm ("  addq $256,%rsp");
asm ("  leave");
asm ("  ret");
asm ("wt_galerkin_module_wq_laplapol2pol_wt_:");
asm ("  push %rbp");
asm ("  movq %rsp,%rbp");
asm ("  subq $16,%rsp");
asm ("  call wt_galerkin_module.wq_laplapol2pol_wt_@PLT");
asm ("  xorq %rax,%rax");
asm ("  addq $16,%rsp");
asm ("  leave");
asm ("  ret");
#endif
#if defined(FFC32) || defined(FFC64)
extern void wt_galerkin_module_wt_galerkin_initial_(int*, int*, int*, int*, int*, double*, double*, int*, int*, int*, int*, char*, double*, double*, double*, double*, double*, double*, double*, double*, int*);
extern struct farray* wt_galerkin_module_wq_laplapol2pol_wt_(struct farray*, double*);
#endif


static int nm;
static int lm = 16;


static VALUE
rbspml_wt_galerkin_Initial(int argc, VALUE *argv, VALUE self)
{
  VALUE i, j, k, n, l, r_in, r_out, dd, nn, dn, nd, velbc, mm_cfdx0_ri, mm_cfdx1_ri, mm_cfdx0_ro, mm_cfdx1_ro, mmex_cfdx0_ri, mmex_cfdx1_ri, mmex_cfdx0_ro, mmex_cfdx1_ro, np;
  int ci;
  int cj;
  int ck;
  int cn;
  int cl;
  double cr_in;
  double cr_out;
  int cdd;
  int cnn;
  int cdn;
  int cnd;
  char* cvelbc;
  double cmm_cfdx0_ri;
  double cmm_cfdx1_ri;
  double cmm_cfdx0_ro;
  double cmm_cfdx1_ro;
  double* cmmex_cfdx0_ri;
  double* cmmex_cfdx1_ri;
  double* cmmex_cfdx0_ro;
  double* cmmex_cfdx1_ro;
  int cnp;

  rb_scan_args(argc, argv, "714", &i, &j, &k, &n, &l, &r_in, &r_out, &dd, &nn, &dn, &nd, &velbc, &mm_cfdx0_ri, &mm_cfdx1_ri, &mm_cfdx0_ro, &mm_cfdx1_ro, &mmex_cfdx0_ri, &mmex_cfdx1_ri, &mmex_cfdx0_ro, &mmex_cfdx1_ro, &np);
  ci = NUM2INT(i);
  cj = NUM2INT(j);
  ck = NUM2INT(k);
  cn = NUM2INT(n);
  cl = NUM2INT(l);
  cr_in = NUM2DBL(r_in);
  cr_out = NUM2DBL(r_out);
  if ( dd != Qnil )
    cdd = (dd==Qtrue);
  if ( nn != Qnil )
    cnn = (nn==Qtrue);
  if ( dn != Qnil )
    cdn = (dn==Qtrue);
  if ( nd != Qnil )
    cnd = (nd==Qtrue);
  if ( velbc != Qnil )
    cvelbc = RSTRING_PTR(velbc);
  if ( mm_cfdx0_ri != Qnil )
    cmm_cfdx0_ri = NUM2DBL(mm_cfdx0_ri);
  if ( mm_cfdx1_ri != Qnil )
    cmm_cfdx1_ri = NUM2DBL(mm_cfdx1_ri);
  if ( mm_cfdx0_ro != Qnil )
    cmm_cfdx0_ro = NUM2DBL(mm_cfdx0_ro);
  if ( mm_cfdx1_ro != Qnil )
    cmm_cfdx1_ro = NUM2DBL(mm_cfdx1_ro);
  if ( mmex_cfdx0_ri != Qnil )
    mmex_cfdx0_ri = na_cast_object(mmex_cfdx0_ri, NA_DFLOAT);
  cmmex_cfdx0_ri = NA_PTR_TYPE(mmex_cfdx0_ri, double*);

  if ( mmex_cfdx1_ri != Qnil )
    mmex_cfdx1_ri = na_cast_object(mmex_cfdx1_ri, NA_DFLOAT);
  cmmex_cfdx1_ri = NA_PTR_TYPE(mmex_cfdx1_ri, double*);

  if ( mmex_cfdx0_ro != Qnil )
    mmex_cfdx0_ro = na_cast_object(mmex_cfdx0_ro, NA_DFLOAT);
  cmmex_cfdx0_ro = NA_PTR_TYPE(mmex_cfdx0_ro, double*);

  if ( mmex_cfdx1_ro != Qnil )
    mmex_cfdx1_ro = na_cast_object(mmex_cfdx1_ro, NA_DFLOAT);
  cmmex_cfdx1_ro = NA_PTR_TYPE(mmex_cfdx1_ro, double*);

  if ( np != Qnil )
    cnp = NUM2INT(np);
  nm = cn;
  lm = cl;

#if defined IFORT
  wt_galerkin_module_mp_wt_galerkin_initial_(&ci, &cj, &ck, &cn, &cl, &cr_in, &cr_out, dd==Qnil ? NULL : &cdd, nn==Qnil ? NULL : &cnn, dn==Qnil ? NULL : &cdn, nd==Qnil ? NULL : &cnd, velbc==Qnil ? NULL : cvelbc, mm_cfdx0_ri==Qnil ? NULL : &cmm_cfdx0_ri, mm_cfdx1_ri==Qnil ? NULL : &cmm_cfdx1_ri, mm_cfdx0_ro==Qnil ? NULL : &cmm_cfdx0_ro, mm_cfdx1_ro==Qnil ? NULL : &cmm_cfdx1_ro, mmex_cfdx0_ri==Qnil ? NULL : cmmex_cfdx0_ri, mmex_cfdx1_ri==Qnil ? NULL : cmmex_cfdx1_ri, mmex_cfdx0_ro==Qnil ? NULL : cmmex_cfdx0_ro, mmex_cfdx1_ro==Qnil ? NULL : cmmex_cfdx1_ro, np==Qnil ? NULL : &cnp);
#elif defined GFORTRAN
  __wt_galerkin_module_MOD_wt_galerkin_initial(&ci, &cj, &ck, &cn, &cl, &cr_in, &cr_out, dd==Qnil ? NULL : &cdd, nn==Qnil ? NULL : &cnn, dn==Qnil ? NULL : &cdn, nd==Qnil ? NULL : &cnd, velbc==Qnil ? NULL : cvelbc, mm_cfdx0_ri==Qnil ? NULL : &cmm_cfdx0_ri, mm_cfdx1_ri==Qnil ? NULL : &cmm_cfdx1_ri, mm_cfdx0_ro==Qnil ? NULL : &cmm_cfdx0_ro, mm_cfdx1_ro==Qnil ? NULL : &cmm_cfdx1_ro, mmex_cfdx0_ri==Qnil ? NULL : cmmex_cfdx0_ri, mmex_cfdx1_ri==Qnil ? NULL : cmmex_cfdx1_ri, mmex_cfdx0_ro==Qnil ? NULL : cmmex_cfdx0_ro, mmex_cfdx1_ro==Qnil ? NULL : cmmex_cfdx1_ro, np==Qnil ? NULL : &cnp);
#elif defined(FFC32) || defined(FFC64)
  wt_galerkin_module_wt_galerkin_initial_(&ci, &cj, &ck, &cn, &cl, &cr_in, &cr_out, dd==Qnil ? NULL : &cdd, nn==Qnil ? NULL : &cnn, dn==Qnil ? NULL : &cdn, nd==Qnil ? NULL : &cnd, velbc==Qnil ? NULL : cvelbc, mm_cfdx0_ri==Qnil ? NULL : &cmm_cfdx0_ri, mm_cfdx1_ri==Qnil ? NULL : &cmm_cfdx1_ri, mm_cfdx0_ro==Qnil ? NULL : &cmm_cfdx0_ro, mm_cfdx1_ro==Qnil ? NULL : &cmm_cfdx1_ro, mmex_cfdx0_ri==Qnil ? NULL : cmmex_cfdx0_ri, mmex_cfdx1_ri==Qnil ? NULL : cmmex_cfdx1_ri, mmex_cfdx0_ro==Qnil ? NULL : cmmex_cfdx0_ro, mmex_cfdx1_ro==Qnil ? NULL : cmmex_cfdx1_ro, np==Qnil ? NULL : &cnp);
#endif

  if ( mmex_cfdx0_ri != Qnil )
    free(cmmex_cfdx0_ri);
  if ( mmex_cfdx1_ri != Qnil )
    free(cmmex_cfdx1_ri);
  if ( mmex_cfdx0_ro != Qnil )
    free(cmmex_cfdx0_ro);
  if ( mmex_cfdx1_ro != Qnil )
    free(cmmex_cfdx1_ro);
  return Qnil;
}

static VALUE
rbspml_wq_LaplaPol2Pol_wt(int argc, VALUE *argv, VALUE self)
{
  VALUE wt_laplapolvel, out;
  double* cwt_laplapolvel;
  struct farray* cout;

  rb_scan_args(argc, argv, "10", &wt_laplapolvel);
  wt_laplapolvel = na_cast_object(wt_laplapolvel, NA_DFLOAT);
  cwt_laplapolvel = NA_PTR_TYPE(wt_laplapolvel, double*);
{
  int shape[2];
  shape[0] = (nm+1)*(nm+1);
  shape[1] = (lm) - (4) + 1;
  out = na_make_object(NA_DFLOAT, 2, shape, cNArray);
  cout = (struct farray*) xmalloc(sizeof(struct farray)+sizeof(struct fshape)*2);
#if defined(IFORT) || defined(GFORTRAN)
{
  int i,j=1,offset=1;
  for (i=0;i<1;i++) {
    j = j*NA_STRUCT(out)->shape[i];
    offset += j;
  }
  cout->offset = -offset;
}
#endif
#if defined IFORT
  cout->vsize = sizeof(double);
{
  long type = 10;
  cout->type = ((type<<(sizeof(void*)*6)) | 1);
}
  cout->rank = 2;
#elif defined GFORTRAN
{
  cout->flag = (2 | (1<<4) | (sizeof(double)<<6));
}
#elif defined(FFC32) || defined(FFC64)
  cout->total = NA_STRUCT(out)->total;
  cout->total_byte = cout->total*sizeof(double);
#endif
{
  int step=1, len, i;
  struct fshape* fs;
  for (i=0;i<2;i++) {
    len = NA_STRUCT(out)->shape[i];
    fs = (struct fshape*)(cout+1)+i;
#if defined(IFORT) || defined(FFC32) || defined(FFC64)
    fs->step = 8*step;
    fs->length = len;
    fs->flag = 1;
#endif
#if defined(FFC32) || defined(FFC64)
    fs->length2 = len;
#endif
#ifdef GFORTRAN
    fs->step = step;
    fs->start = 1;
    fs->end = len;
#endif
    step *= len;
  }
}

  cout->array = NA_PTR_TYPE(out, void*);
};

#if defined IFORT
  wt_galerkin_module_mp_wq_laplapol2pol_wt_(cout, cwt_laplapolvel);
#elif defined GFORTRAN
  __wt_galerkin_module_MOD_wq_laplapol2pol_wt(cout, cwt_laplapolvel);
#elif defined(FFC32) || defined(FFC64)
  wt_galerkin_module_wq_laplapol2pol_wt_(cout, cwt_laplapolvel);
#endif

#if defined(FFC32) || defined(FFC64)
{
  double* cnout = NA_PTR_TYPE(out,double*);
  int i;
  for (i=0;i<NA_TOTAL(out);i++)
    cnout[i] = ((double*)cout->array)[i];
}
#endif
  free(cout);
  return out;
}


void init_wt_galerkin_module(VALUE mSPML)
{
  VALUE mWT_GALERKIN;

  mWT_GALERKIN = rb_define_module_under(mSPML, "WT_GALERKIN");

  rb_define_module_function(mWT_GALERKIN, "initial", rbspml_wt_galerkin_Initial, -1);
  rb_define_method(mWT_GALERKIN, "initial", rbspml_wt_galerkin_Initial, -1);
  rb_define_module_function(mWT_GALERKIN, "wq_LaplaPol2Pol_wt", rbspml_wq_LaplaPol2Pol_wt, -1);
  rb_define_method(mWT_GALERKIN, "wq_LaplaPol2Pol_wt", rbspml_wq_LaplaPol2Pol_wt, -1);
}
