#include "ruby-spml.h"

#ifdef IFORT
extern void wtu_module_mp_wtu_initial_(int*, int*, int*, int*, int*, int*, int*, double*, double*, int*);
extern void wtu_module_mp_wtu_tormagboundariestau_(double*, double*, double*, double*, int*);
extern void wtu_module_mp_wtu_tormagboundariesgrid_(double*, double*, double*, double*, int*);
extern void wtu_module_mp_wtu_polmagboundariestau_(double*, double*, int*);
extern void wtu_module_mp_wtu_polmagboundariesgrid_(double*, double*, int*);
#endif
#ifdef GFORTRAN
extern void __wtu_module_MOD_wtu_initial(int*, int*, int*, int*, int*, int*, int*, double*, double*, int*);
extern void __wtu_module_MOD_wtu_tormagboundariestau(double*, double*, double*, double*, int*);
extern void __wtu_module_MOD_wtu_tormagboundariesgrid(double*, double*, double*, double*, int*);
extern void __wtu_module_MOD_wtu_polmagboundariestau(double*, double*, int*);
extern void __wtu_module_MOD_wtu_polmagboundariesgrid(double*, double*, int*);
#endif
#ifdef FFC32
asm ("wtu_module_wtu_initial_:");
asm ("  pushl %ebp");
asm ("  movl %esp,%ebp");
asm ("  movl 44(%ebp), %eax");
asm ("  pushl %eax");
asm ("  movl 40(%ebp), %eax");
asm ("  pushl %eax");
asm ("  movl 36(%ebp), %eax");
asm ("  pushl %eax");
asm ("  movl 32(%ebp), %eax");
asm ("  pushl %eax");
asm ("  movl 28(%ebp), %eax");
asm ("  pushl %eax");
asm ("  movl 24(%ebp), %eax");
asm ("  pushl %eax");
asm ("  movl 20(%ebp), %eax");
asm ("  pushl %eax");
asm ("  movl 16(%ebp), %eax");
asm ("  pushl %eax");
asm ("  movl 12(%ebp), %eax");
asm ("  pushl %eax");
asm ("  movl 8(%ebp), %eax");
asm ("  pushl %eax");
asm ("  call wtu_module.wtu_initial_");
asm ("  leave");
asm ("  ret");
asm ("wtu_module_wtu_tormagboundariesgrid_:");
asm ("  pushl %ebp");
asm ("  movl %esp,%ebp");
asm ("  movl 24(%ebp), %eax");
asm ("  pushl %eax");
asm ("  movl 20(%ebp), %eax");
asm ("  pushl %eax");
asm ("  movl 16(%ebp), %eax");
asm ("  pushl %eax");
asm ("  movl 12(%ebp), %eax");
asm ("  pushl %eax");
asm ("  movl 8(%ebp), %eax");
asm ("  pushl %eax");
asm ("  call wtu_module.wtu_tormagboundariesgrid_");
asm ("  leave");
asm ("  ret");
asm ("wtu_module_wtu_polmagboundariesgrid_:");
asm ("  pushl %ebp");
asm ("  movl %esp,%ebp");
asm ("  movl 16(%ebp), %eax");
asm ("  pushl %eax");
asm ("  movl 12(%ebp), %eax");
asm ("  pushl %eax");
asm ("  movl 8(%ebp), %eax");
asm ("  pushl %eax");
asm ("  call wtu_module.wtu_polmagboundariesgrid_");
asm ("  leave");
asm ("  ret");
#endif
#ifdef FFC64
asm ("wtu_module_wtu_initial_:");
asm ("  push %rbp");
asm ("  movq %rsp,%rbp");
asm ("  subq $64,%rsp");
asm ("  movq %rbx,-8(%rbp)");
asm ("  movq 16(%rbp),%r10");
asm ("  movq %r10,0(%rsp)");
asm ("  movq 24(%rbp),%r10");
asm ("  movq %r10,8(%rsp)");
asm ("  movq 32(%rbp),%r10");
asm ("  movq %r10,16(%rsp)");
asm ("  movq 40(%rbp),%r10");
asm ("  movq %r10,24(%rsp)");
asm ("  call wtu_module.wtu_initial_@PLT");
asm ("  movq -8(%rbp),%rbx");
asm ("  xorq %rax,%rax");
asm ("  addq $64,%rsp");
asm ("  leave");
asm ("  ret");
asm ("wtu_module_wtu_tormagboundariesgrid_:");
asm ("  push %rbp");
asm ("  movq %rsp,%rbp");
asm ("  subq $16,%rsp");
asm ("  call wtu_module.wtu_tormagboundariesgrid_@PLT");
asm ("  xorq %rax,%rax");
asm ("  addq $16,%rsp");
asm ("  leave");
asm ("  ret");
asm ("wtu_module_wtu_polmagboundariesgrid_:");
asm ("  push %rbp");
asm ("  movq %rsp,%rbp");
asm ("  subq $16,%rsp");
asm ("  call wtu_module.wtu_polmagboundariesgrid_@PLT");
asm ("  xorq %rax,%rax");
asm ("  addq $16,%rsp");
asm ("  leave");
asm ("  ret");
#endif
#if defined(FFC32) || defined(FFC64)
extern void wtu_module_wtu_initial_(int*, int*, int*, int*, int*, int*, int*, double*, double*, int*);
extern void wtu_module_wtu_tormagboundariesgrid_(double*, double*, double*, double*, int*);
extern void wtu_module_wtu_polmagboundariesgrid_(double*, double*, int*);
#endif


static int nm = 21;
static int lmo;
static int lmi = 16;


static VALUE
rbspml_wtu_Initial(int argc, VALUE *argv, VALUE self)
{
  VALUE i, j, ki, ko, n, li, lo, r_in, r_out, np;
  int ci;
  int cj;
  int cki;
  int cko;
  int cn;
  int cli;
  int clo;
  double cr_in;
  double cr_out;
  int cnp;

  rb_scan_args(argc, argv, "91", &i, &j, &ki, &ko, &n, &li, &lo, &r_in, &r_out, &np);
  ci = NUM2INT(i);
  cj = NUM2INT(j);
  cki = NUM2INT(ki);
  cko = NUM2INT(ko);
  cn = NUM2INT(n);
  cli = NUM2INT(li);
  clo = NUM2INT(lo);
  cr_in = NUM2DBL(r_in);
  cr_out = NUM2DBL(r_out);
  if ( np != Qnil )
    cnp = NUM2INT(np);
  nm = cn;
  lmo = clo;
  lmi = cli;

#if defined IFORT
  wtu_module_mp_wtu_initial_(&ci, &cj, &cki, &cko, &cn, &cli, &clo, &cr_in, &cr_out, np==Qnil ? NULL : &cnp);
#elif defined GFORTRAN
  __wtu_module_MOD_wtu_initial(&ci, &cj, &cki, &cko, &cn, &cli, &clo, &cr_in, &cr_out, np==Qnil ? NULL : &cnp);
#elif defined(FFC32) || defined(FFC64)
  wtu_module_wtu_initial_(&ci, &cj, &cki, &cko, &cn, &cli, &clo, &cr_in, &cr_out, np==Qnil ? NULL : &cnp);
#endif

  return Qnil;
}

static VALUE
rbspml_wtu_TormagBoundariesTau(int argc, VALUE *argv, VALUE self)
{
  VALUE wt_tor, wu_tor, pmo, pmi, new;
  double* cwt_tor;
  double* cwu_tor;
  double cpmo;
  double cpmi;
  int cnew;

  rb_scan_args(argc, argv, "41", &wt_tor, &wu_tor, &pmo, &pmi, &new);
  wt_tor = na_cast_object(wt_tor, NA_DFLOAT);
  cwt_tor = NA_PTR_TYPE(wt_tor, double*);
  wu_tor = na_cast_object(wu_tor, NA_DFLOAT);
  cwu_tor = NA_PTR_TYPE(wu_tor, double*);
  cpmo = NUM2DBL(pmo);
  cpmi = NUM2DBL(pmi);
  if ( new != Qnil )
    cnew = (new==Qtrue);

#if defined IFORT
  wtu_module_mp_wtu_tormagboundariestau_(cwt_tor, cwu_tor, &cpmo, &cpmi, new==Qnil ? NULL : &cnew);
#elif defined GFORTRAN
  __wtu_module_MOD_wtu_tormagboundariestau(cwt_tor, cwu_tor, &cpmo, &cpmi, new==Qnil ? NULL : &cnew);
#elif defined(FFC32) || defined(FFC64)
  rb_raise(rb_eRuntimeError, "wtu_TormagBoundariesTau is not supported for FFC comilar");
#endif

  return rb_ary_new3(2, wt_tor, wu_tor);
}

static VALUE
rbspml_wtu_TormagBoundariesGrid(int argc, VALUE *argv, VALUE self)
{
  VALUE wt_tor, wu_tor, pmo, pmi, new;
  double* cwt_tor;
  double* cwu_tor;
  double cpmo;
  double cpmi;
  int cnew;

  rb_scan_args(argc, argv, "41", &wt_tor, &wu_tor, &pmo, &pmi, &new);
  wt_tor = na_cast_object(wt_tor, NA_DFLOAT);
  cwt_tor = NA_PTR_TYPE(wt_tor, double*);
  wu_tor = na_cast_object(wu_tor, NA_DFLOAT);
  cwu_tor = NA_PTR_TYPE(wu_tor, double*);
  cpmo = NUM2DBL(pmo);
  cpmi = NUM2DBL(pmi);
  if ( new != Qnil )
    cnew = (new==Qtrue);

#if defined IFORT
  wtu_module_mp_wtu_tormagboundariesgrid_(cwt_tor, cwu_tor, &cpmo, &cpmi, new==Qnil ? NULL : &cnew);
#elif defined GFORTRAN
  __wtu_module_MOD_wtu_tormagboundariesgrid(cwt_tor, cwu_tor, &cpmo, &cpmi, new==Qnil ? NULL : &cnew);
#elif defined(FFC32) || defined(FFC64)
  wtu_module_wtu_tormagboundariesgrid_(cwt_tor, cwu_tor, &cpmo, &cpmi, new==Qnil ? NULL : &cnew);
#endif

  return rb_ary_new3(2, wt_tor, wu_tor);
}

static VALUE
rbspml_wtu_PolmagBoundariesTau(int argc, VALUE *argv, VALUE self)
{
  VALUE wt_pol, wu_pol, new;
  double* cwt_pol;
  double* cwu_pol;
  int cnew;

  rb_scan_args(argc, argv, "21", &wt_pol, &wu_pol, &new);
  wt_pol = na_cast_object(wt_pol, NA_DFLOAT);
  cwt_pol = NA_PTR_TYPE(wt_pol, double*);
  wu_pol = na_cast_object(wu_pol, NA_DFLOAT);
  cwu_pol = NA_PTR_TYPE(wu_pol, double*);
  if ( new != Qnil )
    cnew = (new==Qtrue);

#if defined IFORT
  wtu_module_mp_wtu_polmagboundariestau_(cwt_pol, cwu_pol, new==Qnil ? NULL : &cnew);
#elif defined GFORTRAN
  __wtu_module_MOD_wtu_polmagboundariestau(cwt_pol, cwu_pol, new==Qnil ? NULL : &cnew);
#elif defined(FFC32) || defined(FFC64)
  rb_raise(rb_eRuntimeError, "wtu_PolmagBoundariesTau is not supported for FFC comilar");
#endif

  return rb_ary_new3(2, wt_pol, wu_pol);
}

static VALUE
rbspml_wtu_PolmagBoundariesGrid(int argc, VALUE *argv, VALUE self)
{
  VALUE wt_pol, wu_pol, new;
  double* cwt_pol;
  double* cwu_pol;
  int cnew;

  rb_scan_args(argc, argv, "21", &wt_pol, &wu_pol, &new);
  wt_pol = na_cast_object(wt_pol, NA_DFLOAT);
  cwt_pol = NA_PTR_TYPE(wt_pol, double*);
  wu_pol = na_cast_object(wu_pol, NA_DFLOAT);
  cwu_pol = NA_PTR_TYPE(wu_pol, double*);
  if ( new != Qnil )
    cnew = (new==Qtrue);

#if defined IFORT
  wtu_module_mp_wtu_polmagboundariesgrid_(cwt_pol, cwu_pol, new==Qnil ? NULL : &cnew);
#elif defined GFORTRAN
  __wtu_module_MOD_wtu_polmagboundariesgrid(cwt_pol, cwu_pol, new==Qnil ? NULL : &cnew);
#elif defined(FFC32) || defined(FFC64)
  wtu_module_wtu_polmagboundariesgrid_(cwt_pol, cwu_pol, new==Qnil ? NULL : &cnew);
#endif

  return rb_ary_new3(2, wt_pol, wu_pol);
}


void init_wtu_module(VALUE mSPML)
{
  VALUE mWTU;

  mWTU = rb_define_module_under(mSPML, "WTU");

  rb_define_module_function(mWTU, "initial", rbspml_wtu_Initial, -1);
  rb_define_method(mWTU, "initial", rbspml_wtu_Initial, -1);
  rb_define_module_function(mWTU, "wtu_TormagBoundariesTau", rbspml_wtu_TormagBoundariesTau, -1);
  rb_define_method(mWTU, "wtu_TormagBoundariesTau", rbspml_wtu_TormagBoundariesTau, -1);
  rb_define_module_function(mWTU, "wtu_TormagBoundariesGrid", rbspml_wtu_TormagBoundariesGrid, -1);
  rb_define_method(mWTU, "wtu_TormagBoundariesGrid", rbspml_wtu_TormagBoundariesGrid, -1);
  rb_define_module_function(mWTU, "wtu_PolmagBoundariesTau", rbspml_wtu_PolmagBoundariesTau, -1);
  rb_define_method(mWTU, "wtu_PolmagBoundariesTau", rbspml_wtu_PolmagBoundariesTau, -1);
  rb_define_module_function(mWTU, "wtu_PolmagBoundariesGrid", rbspml_wtu_PolmagBoundariesGrid, -1);
  rb_define_method(mWTU, "wtu_PolmagBoundariesGrid", rbspml_wtu_PolmagBoundariesGrid, -1);
}
