#include "ruby-spml.h"

#ifdef IFORT
extern double* aq_module_mp_g_r_;
extern double* aq_module_mp_g_r_weight_;
extern void aq_module_mp_aq_initial_(int*, int*, double*, double*, double*, struct farray*);
extern struct farray* aq_module_mp_ag_aq_(struct farray*, struct farray*);
extern struct farray* aq_module_mp_g_q_(struct farray*, struct farray*);
extern struct farray* aq_module_mp_aq_ag_(struct farray*, struct farray*);
extern struct farray* aq_module_mp_q_g_(struct farray*, struct farray*);
extern struct farray* aq_module_mp_aq_rdr_aq_(struct farray*, struct farray*);
extern struct farray* aq_module_mp_q_rdr_q_(struct farray*, struct farray*);
extern struct farray* aq_module_mp_aq_r2_aq_(struct farray*, struct farray*);
extern struct farray* aq_module_mp_q_r2_q_(struct farray*, struct farray*);
extern struct farray* aq_module_mp_aq_r2inv_aq_(struct farray*, struct farray*);
extern struct farray* aq_module_mp_q_r2inv_q_(struct farray*, struct farray*);
extern struct farray* aq_module_mp_a_int_ag_(struct farray*, struct farray*);
extern double aq_module_mp_int_g_(double*);
extern struct farray* aq_module_mp_a_avr_ag_(struct farray*, struct farray*);
extern double aq_module_mp_avr_g_(double*);
extern void aq_module_mp_aq_boundarytau_d_2d_(struct farray*, struct farray*);
extern void aq_module_mp_aq_boundarytau_d_1d_(double*, double*);
extern void aq_module_mp_aq_boundarytau_n_2d_(struct farray*, struct farray*);
extern void aq_module_mp_aq_boundarytau_n_1d_(double*, double*);
extern void aq_module_mp_ag_boundarygrid_d_2d_(struct farray*, struct farray*);
extern void aq_module_mp_ag_boundarygrid_d_1d_(double*, double*);
extern void aq_module_mp_ag_boundarygrid_n_2d_(struct farray*, struct farray*);
extern void aq_module_mp_ag_boundarygrid_n_1d_(double*, double*);
#endif
#ifdef GFORTRAN
extern double* __aq_module_MOD_g_r;
extern double* __aq_module_MOD_g_r_weight;
extern void __aq_module_MOD_aq_initial(int*, int*, double*, double*, double*, struct farray*);
extern struct farray* __aq_module_MOD_ag_aq(struct farray*, struct farray*);
extern struct farray* __aq_module_MOD_g_q(struct farray*, struct farray*);
extern struct farray* __aq_module_MOD_aq_ag(struct farray*, struct farray*);
extern struct farray* __aq_module_MOD_q_g(struct farray*, struct farray*);
extern struct farray* __aq_module_MOD_aq_rdr_aq(struct farray*, struct farray*);
extern struct farray* __aq_module_MOD_q_rdr_q(struct farray*, struct farray*);
extern struct farray* __aq_module_MOD_aq_r2_aq(struct farray*, struct farray*);
extern struct farray* __aq_module_MOD_q_r2_q(struct farray*, struct farray*);
extern struct farray* __aq_module_MOD_aq_r2inv_aq(struct farray*, struct farray*);
extern struct farray* __aq_module_MOD_q_r2inv_q(struct farray*, struct farray*);
extern struct farray* __aq_module_MOD_a_int_ag(struct farray*, struct farray*);
extern double __aq_module_MOD_int_g(double*);
extern struct farray* __aq_module_MOD_a_avr_ag(struct farray*, struct farray*);
extern double __aq_module_MOD_avr_g(double*);
extern void __aq_module_MOD_aq_boundarytau_d_2d(struct farray*, struct farray*);
extern void __aq_module_MOD_aq_boundarytau_d_1d(double*, double*);
extern void __aq_module_MOD_aq_boundarytau_n_2d(struct farray*, struct farray*);
extern void __aq_module_MOD_aq_boundarytau_n_1d(double*, double*);
extern void __aq_module_MOD_ag_boundarygrid_d_2d(struct farray*, struct farray*);
extern void __aq_module_MOD_ag_boundarygrid_d_1d(double*, double*);
extern void __aq_module_MOD_ag_boundarygrid_n_2d(struct farray*, struct farray*);
extern void __aq_module_MOD_ag_boundarygrid_n_1d(double*, double*);
#endif
#ifdef FFC32
asm ("aq_module_g_r_:");
asm ("  pushl %ebp");
asm ("  movl %esp, %ebp");
asm ("  movl MODULE.aq_module_+0, %eax");
asm ("  leave");
asm ("  ret");
asm ("aq_module_g_r_weight_:");
asm ("  pushl %ebp");
asm ("  movl %esp, %ebp");
asm ("  movl MODULE.aq_module_+28, %eax");
asm ("  leave");
asm ("  ret");
asm ("aq_module_aq_initial_:");
asm ("  pushl %ebp");
asm ("  movl %esp,%ebp");
asm ("  movl 28(%ebp), %eax");
asm ("  pushl %eax");
asm ("  movl 24(%ebp), %eax");
asm ("  pushl %eax");
asm ("  movl 20(%ebp), %eax");
asm ("  pushl %eax");
asm ("  movl 16(%ebp), %eax");
asm ("  pushl %eax");
asm ("  movl 12(%ebp), %eax");
asm ("  pushl %eax");
asm ("  movl 8(%ebp), %eax");
asm ("  pushl %eax");
asm ("  call aq_module.aq_initial_");
asm ("  leave");
asm ("  ret");
asm ("aq_module_ag_aq_:");
asm ("  pushl %ebp");
asm ("  movl %esp,%ebp");
asm ("  movl 12(%ebp), %eax");
asm ("  pushl %eax");
asm ("  movl 8(%ebp), %eax");
asm ("  pushl %eax");
asm ("  call aq_module.ag_aq_");
asm ("  leave");
asm ("  ret");
asm ("aq_module_g_q_:");
asm ("  pushl %ebp");
asm ("  movl %esp,%ebp");
asm ("  movl 12(%ebp), %eax");
asm ("  pushl %eax");
asm ("  movl 8(%ebp), %eax");
asm ("  pushl %eax");
asm ("  call aq_module.g_q_");
asm ("  leave");
asm ("  ret");
asm ("aq_module_aq_ag_:");
asm ("  pushl %ebp");
asm ("  movl %esp,%ebp");
asm ("  movl 12(%ebp), %eax");
asm ("  pushl %eax");
asm ("  movl 8(%ebp), %eax");
asm ("  pushl %eax");
asm ("  call aq_module.aq_ag_");
asm ("  leave");
asm ("  ret");
asm ("aq_module_q_g_:");
asm ("  pushl %ebp");
asm ("  movl %esp,%ebp");
asm ("  movl 12(%ebp), %eax");
asm ("  pushl %eax");
asm ("  movl 8(%ebp), %eax");
asm ("  pushl %eax");
asm ("  call aq_module.q_g_");
asm ("  leave");
asm ("  ret");
asm ("aq_module_aq_rdr_aq_:");
asm ("  pushl %ebp");
asm ("  movl %esp,%ebp");
asm ("  movl 12(%ebp), %eax");
asm ("  pushl %eax");
asm ("  movl 8(%ebp), %eax");
asm ("  pushl %eax");
asm ("  call aq_module.aq_rdr_aq_");
asm ("  leave");
asm ("  ret");
asm ("aq_module_q_rdr_q_:");
asm ("  pushl %ebp");
asm ("  movl %esp,%ebp");
asm ("  movl 12(%ebp), %eax");
asm ("  pushl %eax");
asm ("  movl 8(%ebp), %eax");
asm ("  pushl %eax");
asm ("  call aq_module.q_rdr_q_");
asm ("  leave");
asm ("  ret");
asm ("aq_module_aq_r2_aq_:");
asm ("  pushl %ebp");
asm ("  movl %esp,%ebp");
asm ("  movl 12(%ebp), %eax");
asm ("  pushl %eax");
asm ("  movl 8(%ebp), %eax");
asm ("  pushl %eax");
asm ("  call aq_module.aq_r2_aq_");
asm ("  leave");
asm ("  ret");
asm ("aq_module_q_r2_q_:");
asm ("  pushl %ebp");
asm ("  movl %esp,%ebp");
asm ("  movl 12(%ebp), %eax");
asm ("  pushl %eax");
asm ("  movl 8(%ebp), %eax");
asm ("  pushl %eax");
asm ("  call aq_module.q_r2_q_");
asm ("  leave");
asm ("  ret");
asm ("aq_module_aq_r2inv_aq_:");
asm ("  pushl %ebp");
asm ("  movl %esp,%ebp");
asm ("  movl 12(%ebp), %eax");
asm ("  pushl %eax");
asm ("  movl 8(%ebp), %eax");
asm ("  pushl %eax");
asm ("  call aq_module.aq_r2inv_aq_");
asm ("  leave");
asm ("  ret");
asm ("aq_module_q_r2inv_q_:");
asm ("  pushl %ebp");
asm ("  movl %esp,%ebp");
asm ("  movl 12(%ebp), %eax");
asm ("  pushl %eax");
asm ("  movl 8(%ebp), %eax");
asm ("  pushl %eax");
asm ("  call aq_module.q_r2inv_q_");
asm ("  leave");
asm ("  ret");
asm ("aq_module_a_int_ag_:");
asm ("  pushl %ebp");
asm ("  movl %esp,%ebp");
asm ("  movl 12(%ebp), %eax");
asm ("  pushl %eax");
asm ("  movl 8(%ebp), %eax");
asm ("  pushl %eax");
asm ("  call aq_module.a_int_ag_");
asm ("  leave");
asm ("  ret");
asm ("aq_module_int_g_:");
asm ("  pushl %ebp");
asm ("  movl %esp,%ebp");
asm ("  movl 8(%ebp), %eax");
asm ("  pushl %eax");
asm ("  call aq_module.int_g_");
asm ("  leave");
asm ("  ret");
asm ("aq_module_a_avr_ag_:");
asm ("  pushl %ebp");
asm ("  movl %esp,%ebp");
asm ("  movl 12(%ebp), %eax");
asm ("  pushl %eax");
asm ("  movl 8(%ebp), %eax");
asm ("  pushl %eax");
asm ("  call aq_module.a_avr_ag_");
asm ("  leave");
asm ("  ret");
asm ("aq_module_avr_g_:");
asm ("  pushl %ebp");
asm ("  movl %esp,%ebp");
asm ("  movl 8(%ebp), %eax");
asm ("  pushl %eax");
asm ("  call aq_module.avr_g_");
asm ("  leave");
asm ("  ret");
#endif
#ifdef FFC64
asm ("aq_module_g_r_:");
asm ("  push %rbp");
asm ("  movq %rsp, %rbp");
asm ("  leaq MODULE.aq_module_@GOTPCREL(%rip), %rax");
asm ("  movq 0(%rax), %r10");
asm ("  movq (%r10), %rax");
asm ("  leave");
asm ("  ret");
asm ("aq_module_g_r_weight_:");
asm ("  push %rbp");
asm ("  movq %rsp, %rbp");
asm ("  leaq MODULE.aq_module_@GOTPCREL(%rip), %rax");
asm ("  movq 56(%rax), %r10");
asm ("  movq (%r10), %rax");
asm ("  leave");
asm ("  ret");
asm ("aq_module_aq_initial_:");
asm ("  push %rbp");
asm ("  movq %rsp,%rbp");
asm ("  subq $16,%rsp");
asm ("  call aq_module.aq_initial_@PLT");
asm ("  xorq %rax,%rax");
asm ("  addq $16,%rsp");
asm ("  leave");
asm ("  ret");
asm ("aq_module_ag_aq_:");
asm ("  push %rbp");
asm ("  movq %rsp,%rbp");
asm ("  subq $16,%rsp");
asm ("  call aq_module.ag_aq_@PLT");
asm ("  xorq %rax,%rax");
asm ("  addq $16,%rsp");
asm ("  leave");
asm ("  ret");
asm ("aq_module_g_q_:");
asm ("  push %rbp");
asm ("  movq %rsp,%rbp");
asm ("  subq $16,%rsp");
asm ("  call aq_module.g_q_@PLT");
asm ("  xorq %rax,%rax");
asm ("  addq $16,%rsp");
asm ("  leave");
asm ("  ret");
asm ("aq_module_aq_ag_:");
asm ("  push %rbp");
asm ("  movq %rsp,%rbp");
asm ("  subq $16,%rsp");
asm ("  call aq_module.aq_ag_@PLT");
asm ("  xorq %rax,%rax");
asm ("  addq $16,%rsp");
asm ("  leave");
asm ("  ret");
asm ("aq_module_q_g_:");
asm ("  push %rbp");
asm ("  movq %rsp,%rbp");
asm ("  subq $16,%rsp");
asm ("  call aq_module.q_g_@PLT");
asm ("  xorq %rax,%rax");
asm ("  addq $16,%rsp");
asm ("  leave");
asm ("  ret");
asm ("aq_module_aq_rdr_aq_:");
asm ("  push %rbp");
asm ("  movq %rsp,%rbp");
asm ("  subq $16,%rsp");
asm ("  call aq_module.aq_rdr_aq_@PLT");
asm ("  xorq %rax,%rax");
asm ("  addq $16,%rsp");
asm ("  leave");
asm ("  ret");
asm ("aq_module_q_rdr_q_:");
asm ("  push %rbp");
asm ("  movq %rsp,%rbp");
asm ("  subq $16,%rsp");
asm ("  call aq_module.q_rdr_q_@PLT");
asm ("  xorq %rax,%rax");
asm ("  addq $16,%rsp");
asm ("  leave");
asm ("  ret");
asm ("aq_module_aq_r2_aq_:");
asm ("  push %rbp");
asm ("  movq %rsp,%rbp");
asm ("  subq $16,%rsp");
asm ("  call aq_module.aq_r2_aq_@PLT");
asm ("  xorq %rax,%rax");
asm ("  addq $16,%rsp");
asm ("  leave");
asm ("  ret");
asm ("aq_module_q_r2_q_:");
asm ("  push %rbp");
asm ("  movq %rsp,%rbp");
asm ("  subq $16,%rsp");
asm ("  call aq_module.q_r2_q_@PLT");
asm ("  xorq %rax,%rax");
asm ("  addq $16,%rsp");
asm ("  leave");
asm ("  ret");
asm ("aq_module_aq_r2inv_aq_:");
asm ("  push %rbp");
asm ("  movq %rsp,%rbp");
asm ("  subq $16,%rsp");
asm ("  call aq_module.aq_r2inv_aq_@PLT");
asm ("  xorq %rax,%rax");
asm ("  addq $16,%rsp");
asm ("  leave");
asm ("  ret");
asm ("aq_module_q_r2inv_q_:");
asm ("  push %rbp");
asm ("  movq %rsp,%rbp");
asm ("  subq $16,%rsp");
asm ("  call aq_module.q_r2inv_q_@PLT");
asm ("  xorq %rax,%rax");
asm ("  addq $16,%rsp");
asm ("  leave");
asm ("  ret");
asm ("aq_module_a_int_ag_:");
asm ("  push %rbp");
asm ("  movq %rsp,%rbp");
asm ("  subq $16,%rsp");
asm ("  call aq_module.a_int_ag_@PLT");
asm ("  xorq %rax,%rax");
asm ("  addq $16,%rsp");
asm ("  leave");
asm ("  ret");
asm ("aq_module_int_g_:");
asm ("  push %rbp");
asm ("  movq %rsp,%rbp");
asm ("  subq $16,%rsp");
asm ("  call aq_module.int_g_@PLT");
asm ("  xorq %rax,%rax");
asm ("  addq $16,%rsp");
asm ("  leave");
asm ("  ret");
asm ("aq_module_a_avr_ag_:");
asm ("  push %rbp");
asm ("  movq %rsp,%rbp");
asm ("  subq $16,%rsp");
asm ("  call aq_module.a_avr_ag_@PLT");
asm ("  xorq %rax,%rax");
asm ("  addq $16,%rsp");
asm ("  leave");
asm ("  ret");
asm ("aq_module_avr_g_:");
asm ("  push %rbp");
asm ("  movq %rsp,%rbp");
asm ("  subq $16,%rsp");
asm ("  call aq_module.avr_g_@PLT");
asm ("  xorq %rax,%rax");
asm ("  addq $16,%rsp");
asm ("  leave");
asm ("  ret");
#endif
#if defined(FFC32) || defined(FFC64)
extern double* aq_module_g_r_();
extern double* aq_module_g_r_weight_();
extern void aq_module_aq_initial_(int*, int*, double*, double*, double*, struct farray*);
extern struct farray* aq_module_ag_aq_(struct farray*, struct farray*);
extern struct farray* aq_module_g_q_(struct farray*, struct farray*);
extern struct farray* aq_module_aq_ag_(struct farray*, struct farray*);
extern struct farray* aq_module_q_g_(struct farray*, struct farray*);
extern struct farray* aq_module_aq_rdr_aq_(struct farray*, struct farray*);
extern struct farray* aq_module_q_rdr_q_(struct farray*, struct farray*);
extern struct farray* aq_module_aq_r2_aq_(struct farray*, struct farray*);
extern struct farray* aq_module_q_r2_q_(struct farray*, struct farray*);
extern struct farray* aq_module_aq_r2inv_aq_(struct farray*, struct farray*);
extern struct farray* aq_module_q_r2inv_q_(struct farray*, struct farray*);
extern struct farray* aq_module_a_int_ag_(struct farray*, struct farray*);
extern double aq_module_int_g_(double*);
extern struct farray* aq_module_a_avr_ag_(struct farray*, struct farray*);
extern double aq_module_avr_g_(double*);
#endif


static int im;
static int km;


static VALUE
rbspml_g_R(int argc, VALUE *argv, VALUE self)
{
  VALUE out;
  double* cout;

  rb_scan_args(argc, argv, "00");

#if defined IFORT
  cout = (double*)aq_module_mp_g_r_;
#elif defined GFORTRAN
  cout = (double*)__aq_module_MOD_g_r;
#elif defined(FFC32) || defined(FFC64)
  cout = (double*)aq_module_g_r_();
#endif

{
  int shape[1];
  shape[0] = im;
  out = na_make_object(NA_DFLOAT, 1, shape, cNArray);
  double* cnout = NA_PTR_TYPE(out,double*);
  int i;
  for (i=0;i<NA_TOTAL(out);i++)
    cnout[i] = cout[i];
};
  return out;
}

static VALUE
rbspml_g_R_Weight(int argc, VALUE *argv, VALUE self)
{
  VALUE out;
  double* cout;

  rb_scan_args(argc, argv, "00");

#if defined IFORT
  cout = (double*)aq_module_mp_g_r_weight_;
#elif defined GFORTRAN
  cout = (double*)__aq_module_MOD_g_r_weight;
#elif defined(FFC32) || defined(FFC64)
  cout = (double*)aq_module_g_r_weight_();
#endif

{
  int shape[1];
  shape[0] = im;
  out = na_make_object(NA_DFLOAT, 1, shape, cNArray);
  double* cnout = NA_PTR_TYPE(out,double*);
  int i;
  for (i=0;i<NA_TOTAL(out);i++)
    cnout[i] = cout[i];
};
  return out;
}

static VALUE
rbspml_aq_initial(int argc, VALUE *argv, VALUE self)
{
  VALUE i_in, k_in, r_in, alpha_in, beta_in, md_in;
  int ci_in;
  int ck_in;
  double cr_in;
  double calpha_in;
  double cbeta_in;
  struct farray* cmd_in;

  rb_scan_args(argc, argv, "60", &i_in, &k_in, &r_in, &alpha_in, &beta_in, &md_in);
  ci_in = NUM2INT(i_in);
  ck_in = NUM2INT(k_in);
  cr_in = NUM2DBL(r_in);
  calpha_in = NUM2DBL(alpha_in);
  cbeta_in = NUM2DBL(beta_in);
  md_in = na_cast_object(md_in, NA_LINT);
  cmd_in = (struct farray*) xmalloc(sizeof(struct farray)+sizeof(struct fshape)*1);
#if defined(IFORT) || defined(GFORTRAN)
{
  int i,j=1,offset=1;
  for (i=0;i<0;i++) {
    j = j*NA_STRUCT(md_in)->shape[i];
    offset += j;
  }
  cmd_in->offset = -offset;
}
#endif
#if defined IFORT
  cmd_in->vsize = sizeof(int);
{
  long type = 3;
  cmd_in->type = ((type<<(sizeof(void*)*6)) | 1);
}
  cmd_in->rank = 1;
#elif defined GFORTRAN
{
  cmd_in->flag = (1 | (0<<4) | (sizeof(int)<<6));
}
#elif defined(FFC32) || defined(FFC64)
  cmd_in->total = NA_STRUCT(md_in)->total;
  cmd_in->total_byte = cmd_in->total*sizeof(int);
#endif
{
  int step=1, len, i;
  struct fshape* fs;
  for (i=0;i<1;i++) {
    len = NA_STRUCT(md_in)->shape[i];
    fs = (struct fshape*)(cmd_in+1)+i;
#if defined(IFORT) || defined(FFC32) || defined(FFC64)
    fs->step = 8*step;
    fs->length = len;
    fs->flag = 1;
#endif
#if defined(FFC32) || defined(FFC64)
    fs->length2 = len;
#endif
#ifdef GFORTRAN
    fs->step = step;
    fs->start = 1;
    fs->end = len;
#endif
    step *= len;
  }
}

  cmd_in->array = NA_PTR_TYPE(md_in, void*);
  im = ci_in;
  km = ck_in;

#if defined IFORT
  aq_module_mp_aq_initial_(&ci_in, &ck_in, &cr_in, &calpha_in, &cbeta_in, cmd_in);
#elif defined GFORTRAN
  __aq_module_MOD_aq_initial(&ci_in, &ck_in, &cr_in, &calpha_in, &cbeta_in, cmd_in);
#elif defined(FFC32) || defined(FFC64)
  aq_module_aq_initial_(&ci_in, &ck_in, &cr_in, &calpha_in, &cbeta_in, cmd_in);
#endif

  free(cmd_in);
  return Qnil;
}

static VALUE
rbspml_ag_aq(int argc, VALUE *argv, VALUE self)
{
  VALUE aq_data, out;
  struct farray* caq_data;
  struct farray* cout;

  rb_scan_args(argc, argv, "10", &aq_data);
  aq_data = na_cast_object(aq_data, NA_DFLOAT);
  caq_data = (struct farray*) xmalloc(sizeof(struct farray)+sizeof(struct fshape)*2);
#if defined(IFORT) || defined(GFORTRAN)
{
  int i,j=1,offset=1;
  for (i=0;i<1;i++) {
    j = j*NA_STRUCT(aq_data)->shape[i];
    offset += j;
  }
  caq_data->offset = -offset;
}
#endif
#if defined IFORT
  caq_data->vsize = sizeof(double);
{
  long type = 10;
  caq_data->type = ((type<<(sizeof(void*)*6)) | 1);
}
  caq_data->rank = 2;
#elif defined GFORTRAN
{
  caq_data->flag = (2 | (1<<4) | (sizeof(double)<<6));
}
#elif defined(FFC32) || defined(FFC64)
  caq_data->total = NA_STRUCT(aq_data)->total;
  caq_data->total_byte = caq_data->total*sizeof(double);
#endif
{
  int step=1, len, i;
  struct fshape* fs;
  for (i=0;i<2;i++) {
    len = NA_STRUCT(aq_data)->shape[i];
    fs = (struct fshape*)(caq_data+1)+i;
#if defined(IFORT) || defined(FFC32) || defined(FFC64)
    fs->step = 8*step;
    fs->length = len;
    fs->flag = 1;
#endif
#if defined(FFC32) || defined(FFC64)
    fs->length2 = len;
#endif
#ifdef GFORTRAN
    fs->step = step;
    fs->start = 1;
    fs->end = len;
#endif
    step *= len;
  }
}

  caq_data->array = NA_PTR_TYPE(aq_data, void*);
{
  int shape[2];
  shape[0] = (NA_STRUCT(aq_data)->shape[1]);
  shape[1] = im;
  out = na_make_object(NA_DFLOAT, 2, shape, cNArray);
  cout = (struct farray*) xmalloc(sizeof(struct farray)+sizeof(struct fshape)*2);
#if defined(IFORT) || defined(GFORTRAN)
{
  int i,j=1,offset=1;
  for (i=0;i<1;i++) {
    j = j*NA_STRUCT(out)->shape[i];
    offset += j;
  }
  cout->offset = -offset;
}
#endif
#if defined IFORT
  cout->vsize = sizeof(double);
{
  long type = 10;
  cout->type = ((type<<(sizeof(void*)*6)) | 1);
}
  cout->rank = 2;
#elif defined GFORTRAN
{
  cout->flag = (2 | (1<<4) | (sizeof(double)<<6));
}
#elif defined(FFC32) || defined(FFC64)
  cout->total = NA_STRUCT(out)->total;
  cout->total_byte = cout->total*sizeof(double);
#endif
{
  int step=1, len, i;
  struct fshape* fs;
  for (i=0;i<2;i++) {
    len = NA_STRUCT(out)->shape[i];
    fs = (struct fshape*)(cout+1)+i;
#if defined(IFORT) || defined(FFC32) || defined(FFC64)
    fs->step = 8*step;
    fs->length = len;
    fs->flag = 1;
#endif
#if defined(FFC32) || defined(FFC64)
    fs->length2 = len;
#endif
#ifdef GFORTRAN
    fs->step = step;
    fs->start = 1;
    fs->end = len;
#endif
    step *= len;
  }
}

  cout->array = NA_PTR_TYPE(out, void*);
};

#if defined IFORT
  aq_module_mp_ag_aq_(cout, caq_data);
#elif defined GFORTRAN
  __aq_module_MOD_ag_aq(cout, caq_data);
#elif defined(FFC32) || defined(FFC64)
  aq_module_ag_aq_(cout, caq_data);
#endif

  free(caq_data);
#if defined(FFC32) || defined(FFC64)
{
  double* cnout = NA_PTR_TYPE(out,double*);
  int i;
  for (i=0;i<NA_TOTAL(out);i++)
    cnout[i] = ((double*)cout->array)[i];
}
#endif
  free(cout);
  return out;
}

static VALUE
rbspml_g_q(int argc, VALUE *argv, VALUE self)
{
  VALUE q_data, out;
  struct farray* cq_data;
  struct farray* cout;

  rb_scan_args(argc, argv, "10", &q_data);
  q_data = na_cast_object(q_data, NA_DFLOAT);
  cq_data = (struct farray*) xmalloc(sizeof(struct farray)+sizeof(struct fshape)*1);
#if defined(IFORT) || defined(GFORTRAN)
{
  int i,j=1,offset=1;
  for (i=0;i<0;i++) {
    j = j*NA_STRUCT(q_data)->shape[i];
    offset += j;
  }
  cq_data->offset = -offset;
}
#endif
#if defined IFORT
  cq_data->vsize = sizeof(double);
{
  long type = 10;
  cq_data->type = ((type<<(sizeof(void*)*6)) | 1);
}
  cq_data->rank = 1;
#elif defined GFORTRAN
{
  cq_data->flag = (1 | (1<<4) | (sizeof(double)<<6));
}
#elif defined(FFC32) || defined(FFC64)
  cq_data->total = NA_STRUCT(q_data)->total;
  cq_data->total_byte = cq_data->total*sizeof(double);
#endif
{
  int step=1, len, i;
  struct fshape* fs;
  for (i=0;i<1;i++) {
    len = NA_STRUCT(q_data)->shape[i];
    fs = (struct fshape*)(cq_data+1)+i;
#if defined(IFORT) || defined(FFC32) || defined(FFC64)
    fs->step = 8*step;
    fs->length = len;
    fs->flag = 1;
#endif
#if defined(FFC32) || defined(FFC64)
    fs->length2 = len;
#endif
#ifdef GFORTRAN
    fs->step = step;
    fs->start = 1;
    fs->end = len;
#endif
    step *= len;
  }
}

  cq_data->array = NA_PTR_TYPE(q_data, void*);
{
  int shape[1];
  shape[0] = im;
  out = na_make_object(NA_DFLOAT, 1, shape, cNArray);
  cout = (struct farray*) xmalloc(sizeof(struct farray)+sizeof(struct fshape)*1);
#if defined(IFORT) || defined(GFORTRAN)
{
  int i,j=1,offset=1;
  for (i=0;i<0;i++) {
    j = j*NA_STRUCT(out)->shape[i];
    offset += j;
  }
  cout->offset = -offset;
}
#endif
#if defined IFORT
  cout->vsize = sizeof(double);
{
  long type = 10;
  cout->type = ((type<<(sizeof(void*)*6)) | 1);
}
  cout->rank = 1;
#elif defined GFORTRAN
{
  cout->flag = (1 | (1<<4) | (sizeof(double)<<6));
}
#elif defined(FFC32) || defined(FFC64)
  cout->total = NA_STRUCT(out)->total;
  cout->total_byte = cout->total*sizeof(double);
#endif
{
  int step=1, len, i;
  struct fshape* fs;
  for (i=0;i<1;i++) {
    len = NA_STRUCT(out)->shape[i];
    fs = (struct fshape*)(cout+1)+i;
#if defined(IFORT) || defined(FFC32) || defined(FFC64)
    fs->step = 8*step;
    fs->length = len;
    fs->flag = 1;
#endif
#if defined(FFC32) || defined(FFC64)
    fs->length2 = len;
#endif
#ifdef GFORTRAN
    fs->step = step;
    fs->start = 1;
    fs->end = len;
#endif
    step *= len;
  }
}

  cout->array = NA_PTR_TYPE(out, void*);
};

#if defined IFORT
  aq_module_mp_g_q_(cout, cq_data);
#elif defined GFORTRAN
  __aq_module_MOD_g_q(cout, cq_data);
#elif defined(FFC32) || defined(FFC64)
  aq_module_g_q_(cout, cq_data);
#endif

  free(cq_data);
#if defined(FFC32) || defined(FFC64)
{
  double* cnout = NA_PTR_TYPE(out,double*);
  int i;
  for (i=0;i<NA_TOTAL(out);i++)
    cnout[i] = ((double*)cout->array)[i];
}
#endif
  free(cout);
  return out;
}

static VALUE
rbspml_aq_ag(int argc, VALUE *argv, VALUE self)
{
  VALUE ag_data, out;
  struct farray* cag_data;
  struct farray* cout;

  rb_scan_args(argc, argv, "10", &ag_data);
  ag_data = na_cast_object(ag_data, NA_DFLOAT);
  cag_data = (struct farray*) xmalloc(sizeof(struct farray)+sizeof(struct fshape)*2);
#if defined(IFORT) || defined(GFORTRAN)
{
  int i,j=1,offset=1;
  for (i=0;i<1;i++) {
    j = j*NA_STRUCT(ag_data)->shape[i];
    offset += j;
  }
  cag_data->offset = -offset;
}
#endif
#if defined IFORT
  cag_data->vsize = sizeof(double);
{
  long type = 10;
  cag_data->type = ((type<<(sizeof(void*)*6)) | 1);
}
  cag_data->rank = 2;
#elif defined GFORTRAN
{
  cag_data->flag = (2 | (1<<4) | (sizeof(double)<<6));
}
#elif defined(FFC32) || defined(FFC64)
  cag_data->total = NA_STRUCT(ag_data)->total;
  cag_data->total_byte = cag_data->total*sizeof(double);
#endif
{
  int step=1, len, i;
  struct fshape* fs;
  for (i=0;i<2;i++) {
    len = NA_STRUCT(ag_data)->shape[i];
    fs = (struct fshape*)(cag_data+1)+i;
#if defined(IFORT) || defined(FFC32) || defined(FFC64)
    fs->step = 8*step;
    fs->length = len;
    fs->flag = 1;
#endif
#if defined(FFC32) || defined(FFC64)
    fs->length2 = len;
#endif
#ifdef GFORTRAN
    fs->step = step;
    fs->start = 1;
    fs->end = len;
#endif
    step *= len;
  }
}

  cag_data->array = NA_PTR_TYPE(ag_data, void*);
{
  int shape[2];
  shape[0] = (NA_STRUCT(ag_data)->shape[1]);
  shape[1] = (km) - (0) + 1;
  out = na_make_object(NA_DFLOAT, 2, shape, cNArray);
  cout = (struct farray*) xmalloc(sizeof(struct farray)+sizeof(struct fshape)*2);
#if defined(IFORT) || defined(GFORTRAN)
{
  int i,j=1,offset=1;
  for (i=0;i<1;i++) {
    j = j*NA_STRUCT(out)->shape[i];
    offset += j;
  }
  cout->offset = -offset;
}
#endif
#if defined IFORT
  cout->vsize = sizeof(double);
{
  long type = 10;
  cout->type = ((type<<(sizeof(void*)*6)) | 1);
}
  cout->rank = 2;
#elif defined GFORTRAN
{
  cout->flag = (2 | (1<<4) | (sizeof(double)<<6));
}
#elif defined(FFC32) || defined(FFC64)
  cout->total = NA_STRUCT(out)->total;
  cout->total_byte = cout->total*sizeof(double);
#endif
{
  int step=1, len, i;
  struct fshape* fs;
  for (i=0;i<2;i++) {
    len = NA_STRUCT(out)->shape[i];
    fs = (struct fshape*)(cout+1)+i;
#if defined(IFORT) || defined(FFC32) || defined(FFC64)
    fs->step = 8*step;
    fs->length = len;
    fs->flag = 1;
#endif
#if defined(FFC32) || defined(FFC64)
    fs->length2 = len;
#endif
#ifdef GFORTRAN
    fs->step = step;
    fs->start = 1;
    fs->end = len;
#endif
    step *= len;
  }
}

  cout->array = NA_PTR_TYPE(out, void*);
};

#if defined IFORT
  aq_module_mp_aq_ag_(cout, cag_data);
#elif defined GFORTRAN
  __aq_module_MOD_aq_ag(cout, cag_data);
#elif defined(FFC32) || defined(FFC64)
  aq_module_aq_ag_(cout, cag_data);
#endif

  free(cag_data);
#if defined(FFC32) || defined(FFC64)
{
  double* cnout = NA_PTR_TYPE(out,double*);
  int i;
  for (i=0;i<NA_TOTAL(out);i++)
    cnout[i] = ((double*)cout->array)[i];
}
#endif
  free(cout);
  return out;
}

static VALUE
rbspml_q_g(int argc, VALUE *argv, VALUE self)
{
  VALUE g_data, out;
  struct farray* cg_data;
  struct farray* cout;

  rb_scan_args(argc, argv, "10", &g_data);
  g_data = na_cast_object(g_data, NA_DFLOAT);
  cg_data = (struct farray*) xmalloc(sizeof(struct farray)+sizeof(struct fshape)*1);
#if defined(IFORT) || defined(GFORTRAN)
{
  int i,j=1,offset=1;
  for (i=0;i<0;i++) {
    j = j*NA_STRUCT(g_data)->shape[i];
    offset += j;
  }
  cg_data->offset = -offset;
}
#endif
#if defined IFORT
  cg_data->vsize = sizeof(double);
{
  long type = 10;
  cg_data->type = ((type<<(sizeof(void*)*6)) | 1);
}
  cg_data->rank = 1;
#elif defined GFORTRAN
{
  cg_data->flag = (1 | (1<<4) | (sizeof(double)<<6));
}
#elif defined(FFC32) || defined(FFC64)
  cg_data->total = NA_STRUCT(g_data)->total;
  cg_data->total_byte = cg_data->total*sizeof(double);
#endif
{
  int step=1, len, i;
  struct fshape* fs;
  for (i=0;i<1;i++) {
    len = NA_STRUCT(g_data)->shape[i];
    fs = (struct fshape*)(cg_data+1)+i;
#if defined(IFORT) || defined(FFC32) || defined(FFC64)
    fs->step = 8*step;
    fs->length = len;
    fs->flag = 1;
#endif
#if defined(FFC32) || defined(FFC64)
    fs->length2 = len;
#endif
#ifdef GFORTRAN
    fs->step = step;
    fs->start = 1;
    fs->end = len;
#endif
    step *= len;
  }
}

  cg_data->array = NA_PTR_TYPE(g_data, void*);
{
  int shape[1];
  shape[0] = (km) - (0) + 1;
  out = na_make_object(NA_DFLOAT, 1, shape, cNArray);
  cout = (struct farray*) xmalloc(sizeof(struct farray)+sizeof(struct fshape)*1);
#if defined(IFORT) || defined(GFORTRAN)
{
  int i,j=1,offset=1;
  for (i=0;i<0;i++) {
    j = j*NA_STRUCT(out)->shape[i];
    offset += j;
  }
  cout->offset = -offset;
}
#endif
#if defined IFORT
  cout->vsize = sizeof(double);
{
  long type = 10;
  cout->type = ((type<<(sizeof(void*)*6)) | 1);
}
  cout->rank = 1;
#elif defined GFORTRAN
{
  cout->flag = (1 | (1<<4) | (sizeof(double)<<6));
}
#elif defined(FFC32) || defined(FFC64)
  cout->total = NA_STRUCT(out)->total;
  cout->total_byte = cout->total*sizeof(double);
#endif
{
  int step=1, len, i;
  struct fshape* fs;
  for (i=0;i<1;i++) {
    len = NA_STRUCT(out)->shape[i];
    fs = (struct fshape*)(cout+1)+i;
#if defined(IFORT) || defined(FFC32) || defined(FFC64)
    fs->step = 8*step;
    fs->length = len;
    fs->flag = 1;
#endif
#if defined(FFC32) || defined(FFC64)
    fs->length2 = len;
#endif
#ifdef GFORTRAN
    fs->step = step;
    fs->start = 1;
    fs->end = len;
#endif
    step *= len;
  }
}

  cout->array = NA_PTR_TYPE(out, void*);
};

#if defined IFORT
  aq_module_mp_q_g_(cout, cg_data);
#elif defined GFORTRAN
  __aq_module_MOD_q_g(cout, cg_data);
#elif defined(FFC32) || defined(FFC64)
  aq_module_q_g_(cout, cg_data);
#endif

  free(cg_data);
#if defined(FFC32) || defined(FFC64)
{
  double* cnout = NA_PTR_TYPE(out,double*);
  int i;
  for (i=0;i<NA_TOTAL(out);i++)
    cnout[i] = ((double*)cout->array)[i];
}
#endif
  free(cout);
  return out;
}

static VALUE
rbspml_aq_rDr_aq(int argc, VALUE *argv, VALUE self)
{
  VALUE aq_data, out;
  struct farray* caq_data;
  struct farray* cout;

  rb_scan_args(argc, argv, "10", &aq_data);
  aq_data = na_cast_object(aq_data, NA_DFLOAT);
  caq_data = (struct farray*) xmalloc(sizeof(struct farray)+sizeof(struct fshape)*2);
#if defined(IFORT) || defined(GFORTRAN)
{
  int i,j=1,offset=1;
  for (i=0;i<1;i++) {
    j = j*NA_STRUCT(aq_data)->shape[i];
    offset += j;
  }
  caq_data->offset = -offset;
}
#endif
#if defined IFORT
  caq_data->vsize = sizeof(double);
{
  long type = 10;
  caq_data->type = ((type<<(sizeof(void*)*6)) | 1);
}
  caq_data->rank = 2;
#elif defined GFORTRAN
{
  caq_data->flag = (2 | (1<<4) | (sizeof(double)<<6));
}
#elif defined(FFC32) || defined(FFC64)
  caq_data->total = NA_STRUCT(aq_data)->total;
  caq_data->total_byte = caq_data->total*sizeof(double);
#endif
{
  int step=1, len, i;
  struct fshape* fs;
  for (i=0;i<2;i++) {
    len = NA_STRUCT(aq_data)->shape[i];
    fs = (struct fshape*)(caq_data+1)+i;
#if defined(IFORT) || defined(FFC32) || defined(FFC64)
    fs->step = 8*step;
    fs->length = len;
    fs->flag = 1;
#endif
#if defined(FFC32) || defined(FFC64)
    fs->length2 = len;
#endif
#ifdef GFORTRAN
    fs->step = step;
    fs->start = 1;
    fs->end = len;
#endif
    step *= len;
  }
}

  caq_data->array = NA_PTR_TYPE(aq_data, void*);
{
  int shape[2];
  shape[0] = (NA_STRUCT(aq_data)->shape[1]);
  shape[1] = ((NA_STRUCT(aq_data)->shape[2])-1) - (0) + 1;
  out = na_make_object(NA_DFLOAT, 2, shape, cNArray);
  cout = (struct farray*) xmalloc(sizeof(struct farray)+sizeof(struct fshape)*2);
#if defined(IFORT) || defined(GFORTRAN)
{
  int i,j=1,offset=1;
  for (i=0;i<1;i++) {
    j = j*NA_STRUCT(out)->shape[i];
    offset += j;
  }
  cout->offset = -offset;
}
#endif
#if defined IFORT
  cout->vsize = sizeof(double);
{
  long type = 10;
  cout->type = ((type<<(sizeof(void*)*6)) | 1);
}
  cout->rank = 2;
#elif defined GFORTRAN
{
  cout->flag = (2 | (1<<4) | (sizeof(double)<<6));
}
#elif defined(FFC32) || defined(FFC64)
  cout->total = NA_STRUCT(out)->total;
  cout->total_byte = cout->total*sizeof(double);
#endif
{
  int step=1, len, i;
  struct fshape* fs;
  for (i=0;i<2;i++) {
    len = NA_STRUCT(out)->shape[i];
    fs = (struct fshape*)(cout+1)+i;
#if defined(IFORT) || defined(FFC32) || defined(FFC64)
    fs->step = 8*step;
    fs->length = len;
    fs->flag = 1;
#endif
#if defined(FFC32) || defined(FFC64)
    fs->length2 = len;
#endif
#ifdef GFORTRAN
    fs->step = step;
    fs->start = 1;
    fs->end = len;
#endif
    step *= len;
  }
}

  cout->array = NA_PTR_TYPE(out, void*);
};

#if defined IFORT
  aq_module_mp_aq_rdr_aq_(cout, caq_data);
#elif defined GFORTRAN
  __aq_module_MOD_aq_rdr_aq(cout, caq_data);
#elif defined(FFC32) || defined(FFC64)
  aq_module_aq_rdr_aq_(cout, caq_data);
#endif

  free(caq_data);
#if defined(FFC32) || defined(FFC64)
{
  double* cnout = NA_PTR_TYPE(out,double*);
  int i;
  for (i=0;i<NA_TOTAL(out);i++)
    cnout[i] = ((double*)cout->array)[i];
}
#endif
  free(cout);
  return out;
}

static VALUE
rbspml_q_rDr_q(int argc, VALUE *argv, VALUE self)
{
  VALUE q_data, out;
  struct farray* cq_data;
  struct farray* cout;

  rb_scan_args(argc, argv, "10", &q_data);
  q_data = na_cast_object(q_data, NA_DFLOAT);
  cq_data = (struct farray*) xmalloc(sizeof(struct farray)+sizeof(struct fshape)*1);
#if defined(IFORT) || defined(GFORTRAN)
{
  int i,j=1,offset=1;
  for (i=0;i<0;i++) {
    j = j*NA_STRUCT(q_data)->shape[i];
    offset += j;
  }
  cq_data->offset = -offset;
}
#endif
#if defined IFORT
  cq_data->vsize = sizeof(double);
{
  long type = 10;
  cq_data->type = ((type<<(sizeof(void*)*6)) | 1);
}
  cq_data->rank = 1;
#elif defined GFORTRAN
{
  cq_data->flag = (1 | (1<<4) | (sizeof(double)<<6));
}
#elif defined(FFC32) || defined(FFC64)
  cq_data->total = NA_STRUCT(q_data)->total;
  cq_data->total_byte = cq_data->total*sizeof(double);
#endif
{
  int step=1, len, i;
  struct fshape* fs;
  for (i=0;i<1;i++) {
    len = NA_STRUCT(q_data)->shape[i];
    fs = (struct fshape*)(cq_data+1)+i;
#if defined(IFORT) || defined(FFC32) || defined(FFC64)
    fs->step = 8*step;
    fs->length = len;
    fs->flag = 1;
#endif
#if defined(FFC32) || defined(FFC64)
    fs->length2 = len;
#endif
#ifdef GFORTRAN
    fs->step = step;
    fs->start = 1;
    fs->end = len;
#endif
    step *= len;
  }
}

  cq_data->array = NA_PTR_TYPE(q_data, void*);
{
  int shape[1];
  shape[0] = (km) - (0) + 1;
  out = na_make_object(NA_DFLOAT, 1, shape, cNArray);
  cout = (struct farray*) xmalloc(sizeof(struct farray)+sizeof(struct fshape)*1);
#if defined(IFORT) || defined(GFORTRAN)
{
  int i,j=1,offset=1;
  for (i=0;i<0;i++) {
    j = j*NA_STRUCT(out)->shape[i];
    offset += j;
  }
  cout->offset = -offset;
}
#endif
#if defined IFORT
  cout->vsize = sizeof(double);
{
  long type = 10;
  cout->type = ((type<<(sizeof(void*)*6)) | 1);
}
  cout->rank = 1;
#elif defined GFORTRAN
{
  cout->flag = (1 | (1<<4) | (sizeof(double)<<6));
}
#elif defined(FFC32) || defined(FFC64)
  cout->total = NA_STRUCT(out)->total;
  cout->total_byte = cout->total*sizeof(double);
#endif
{
  int step=1, len, i;
  struct fshape* fs;
  for (i=0;i<1;i++) {
    len = NA_STRUCT(out)->shape[i];
    fs = (struct fshape*)(cout+1)+i;
#if defined(IFORT) || defined(FFC32) || defined(FFC64)
    fs->step = 8*step;
    fs->length = len;
    fs->flag = 1;
#endif
#if defined(FFC32) || defined(FFC64)
    fs->length2 = len;
#endif
#ifdef GFORTRAN
    fs->step = step;
    fs->start = 1;
    fs->end = len;
#endif
    step *= len;
  }
}

  cout->array = NA_PTR_TYPE(out, void*);
};

#if defined IFORT
  aq_module_mp_q_rdr_q_(cout, cq_data);
#elif defined GFORTRAN
  __aq_module_MOD_q_rdr_q(cout, cq_data);
#elif defined(FFC32) || defined(FFC64)
  aq_module_q_rdr_q_(cout, cq_data);
#endif

  free(cq_data);
#if defined(FFC32) || defined(FFC64)
{
  double* cnout = NA_PTR_TYPE(out,double*);
  int i;
  for (i=0;i<NA_TOTAL(out);i++)
    cnout[i] = ((double*)cout->array)[i];
}
#endif
  free(cout);
  return out;
}

static VALUE
rbspml_aq_r2_aq(int argc, VALUE *argv, VALUE self)
{
  VALUE aq_data, out;
  struct farray* caq_data;
  struct farray* cout;

  rb_scan_args(argc, argv, "10", &aq_data);
  aq_data = na_cast_object(aq_data, NA_DFLOAT);
  caq_data = (struct farray*) xmalloc(sizeof(struct farray)+sizeof(struct fshape)*2);
#if defined(IFORT) || defined(GFORTRAN)
{
  int i,j=1,offset=1;
  for (i=0;i<1;i++) {
    j = j*NA_STRUCT(aq_data)->shape[i];
    offset += j;
  }
  caq_data->offset = -offset;
}
#endif
#if defined IFORT
  caq_data->vsize = sizeof(double);
{
  long type = 10;
  caq_data->type = ((type<<(sizeof(void*)*6)) | 1);
}
  caq_data->rank = 2;
#elif defined GFORTRAN
{
  caq_data->flag = (2 | (1<<4) | (sizeof(double)<<6));
}
#elif defined(FFC32) || defined(FFC64)
  caq_data->total = NA_STRUCT(aq_data)->total;
  caq_data->total_byte = caq_data->total*sizeof(double);
#endif
{
  int step=1, len, i;
  struct fshape* fs;
  for (i=0;i<2;i++) {
    len = NA_STRUCT(aq_data)->shape[i];
    fs = (struct fshape*)(caq_data+1)+i;
#if defined(IFORT) || defined(FFC32) || defined(FFC64)
    fs->step = 8*step;
    fs->length = len;
    fs->flag = 1;
#endif
#if defined(FFC32) || defined(FFC64)
    fs->length2 = len;
#endif
#ifdef GFORTRAN
    fs->step = step;
    fs->start = 1;
    fs->end = len;
#endif
    step *= len;
  }
}

  caq_data->array = NA_PTR_TYPE(aq_data, void*);
{
  int shape[2];
  shape[0] = (NA_STRUCT(aq_data)->shape[1]);
  shape[1] = ((NA_STRUCT(aq_data)->shape[2])-1) - (0) + 1;
  out = na_make_object(NA_DFLOAT, 2, shape, cNArray);
  cout = (struct farray*) xmalloc(sizeof(struct farray)+sizeof(struct fshape)*2);
#if defined(IFORT) || defined(GFORTRAN)
{
  int i,j=1,offset=1;
  for (i=0;i<1;i++) {
    j = j*NA_STRUCT(out)->shape[i];
    offset += j;
  }
  cout->offset = -offset;
}
#endif
#if defined IFORT
  cout->vsize = sizeof(double);
{
  long type = 10;
  cout->type = ((type<<(sizeof(void*)*6)) | 1);
}
  cout->rank = 2;
#elif defined GFORTRAN
{
  cout->flag = (2 | (1<<4) | (sizeof(double)<<6));
}
#elif defined(FFC32) || defined(FFC64)
  cout->total = NA_STRUCT(out)->total;
  cout->total_byte = cout->total*sizeof(double);
#endif
{
  int step=1, len, i;
  struct fshape* fs;
  for (i=0;i<2;i++) {
    len = NA_STRUCT(out)->shape[i];
    fs = (struct fshape*)(cout+1)+i;
#if defined(IFORT) || defined(FFC32) || defined(FFC64)
    fs->step = 8*step;
    fs->length = len;
    fs->flag = 1;
#endif
#if defined(FFC32) || defined(FFC64)
    fs->length2 = len;
#endif
#ifdef GFORTRAN
    fs->step = step;
    fs->start = 1;
    fs->end = len;
#endif
    step *= len;
  }
}

  cout->array = NA_PTR_TYPE(out, void*);
};

#if defined IFORT
  aq_module_mp_aq_r2_aq_(cout, caq_data);
#elif defined GFORTRAN
  __aq_module_MOD_aq_r2_aq(cout, caq_data);
#elif defined(FFC32) || defined(FFC64)
  aq_module_aq_r2_aq_(cout, caq_data);
#endif

  free(caq_data);
#if defined(FFC32) || defined(FFC64)
{
  double* cnout = NA_PTR_TYPE(out,double*);
  int i;
  for (i=0;i<NA_TOTAL(out);i++)
    cnout[i] = ((double*)cout->array)[i];
}
#endif
  free(cout);
  return out;
}

static VALUE
rbspml_q_r2_q(int argc, VALUE *argv, VALUE self)
{
  VALUE q_data, out;
  struct farray* cq_data;
  struct farray* cout;

  rb_scan_args(argc, argv, "10", &q_data);
  q_data = na_cast_object(q_data, NA_DFLOAT);
  cq_data = (struct farray*) xmalloc(sizeof(struct farray)+sizeof(struct fshape)*1);
#if defined(IFORT) || defined(GFORTRAN)
{
  int i,j=1,offset=1;
  for (i=0;i<0;i++) {
    j = j*NA_STRUCT(q_data)->shape[i];
    offset += j;
  }
  cq_data->offset = -offset;
}
#endif
#if defined IFORT
  cq_data->vsize = sizeof(double);
{
  long type = 10;
  cq_data->type = ((type<<(sizeof(void*)*6)) | 1);
}
  cq_data->rank = 1;
#elif defined GFORTRAN
{
  cq_data->flag = (1 | (1<<4) | (sizeof(double)<<6));
}
#elif defined(FFC32) || defined(FFC64)
  cq_data->total = NA_STRUCT(q_data)->total;
  cq_data->total_byte = cq_data->total*sizeof(double);
#endif
{
  int step=1, len, i;
  struct fshape* fs;
  for (i=0;i<1;i++) {
    len = NA_STRUCT(q_data)->shape[i];
    fs = (struct fshape*)(cq_data+1)+i;
#if defined(IFORT) || defined(FFC32) || defined(FFC64)
    fs->step = 8*step;
    fs->length = len;
    fs->flag = 1;
#endif
#if defined(FFC32) || defined(FFC64)
    fs->length2 = len;
#endif
#ifdef GFORTRAN
    fs->step = step;
    fs->start = 1;
    fs->end = len;
#endif
    step *= len;
  }
}

  cq_data->array = NA_PTR_TYPE(q_data, void*);
{
  int shape[1];
  shape[0] = (km) - (0) + 1;
  out = na_make_object(NA_DFLOAT, 1, shape, cNArray);
  cout = (struct farray*) xmalloc(sizeof(struct farray)+sizeof(struct fshape)*1);
#if defined(IFORT) || defined(GFORTRAN)
{
  int i,j=1,offset=1;
  for (i=0;i<0;i++) {
    j = j*NA_STRUCT(out)->shape[i];
    offset += j;
  }
  cout->offset = -offset;
}
#endif
#if defined IFORT
  cout->vsize = sizeof(double);
{
  long type = 10;
  cout->type = ((type<<(sizeof(void*)*6)) | 1);
}
  cout->rank = 1;
#elif defined GFORTRAN
{
  cout->flag = (1 | (1<<4) | (sizeof(double)<<6));
}
#elif defined(FFC32) || defined(FFC64)
  cout->total = NA_STRUCT(out)->total;
  cout->total_byte = cout->total*sizeof(double);
#endif
{
  int step=1, len, i;
  struct fshape* fs;
  for (i=0;i<1;i++) {
    len = NA_STRUCT(out)->shape[i];
    fs = (struct fshape*)(cout+1)+i;
#if defined(IFORT) || defined(FFC32) || defined(FFC64)
    fs->step = 8*step;
    fs->length = len;
    fs->flag = 1;
#endif
#if defined(FFC32) || defined(FFC64)
    fs->length2 = len;
#endif
#ifdef GFORTRAN
    fs->step = step;
    fs->start = 1;
    fs->end = len;
#endif
    step *= len;
  }
}

  cout->array = NA_PTR_TYPE(out, void*);
};

#if defined IFORT
  aq_module_mp_q_r2_q_(cout, cq_data);
#elif defined GFORTRAN
  __aq_module_MOD_q_r2_q(cout, cq_data);
#elif defined(FFC32) || defined(FFC64)
  aq_module_q_r2_q_(cout, cq_data);
#endif

  free(cq_data);
#if defined(FFC32) || defined(FFC64)
{
  double* cnout = NA_PTR_TYPE(out,double*);
  int i;
  for (i=0;i<NA_TOTAL(out);i++)
    cnout[i] = ((double*)cout->array)[i];
}
#endif
  free(cout);
  return out;
}

static VALUE
rbspml_aq_r2Inv_aq(int argc, VALUE *argv, VALUE self)
{
  VALUE aq_data, out;
  struct farray* caq_data;
  struct farray* cout;

  rb_scan_args(argc, argv, "10", &aq_data);
  aq_data = na_cast_object(aq_data, NA_DFLOAT);
  caq_data = (struct farray*) xmalloc(sizeof(struct farray)+sizeof(struct fshape)*2);
#if defined(IFORT) || defined(GFORTRAN)
{
  int i,j=1,offset=1;
  for (i=0;i<1;i++) {
    j = j*NA_STRUCT(aq_data)->shape[i];
    offset += j;
  }
  caq_data->offset = -offset;
}
#endif
#if defined IFORT
  caq_data->vsize = sizeof(double);
{
  long type = 10;
  caq_data->type = ((type<<(sizeof(void*)*6)) | 1);
}
  caq_data->rank = 2;
#elif defined GFORTRAN
{
  caq_data->flag = (2 | (1<<4) | (sizeof(double)<<6));
}
#elif defined(FFC32) || defined(FFC64)
  caq_data->total = NA_STRUCT(aq_data)->total;
  caq_data->total_byte = caq_data->total*sizeof(double);
#endif
{
  int step=1, len, i;
  struct fshape* fs;
  for (i=0;i<2;i++) {
    len = NA_STRUCT(aq_data)->shape[i];
    fs = (struct fshape*)(caq_data+1)+i;
#if defined(IFORT) || defined(FFC32) || defined(FFC64)
    fs->step = 8*step;
    fs->length = len;
    fs->flag = 1;
#endif
#if defined(FFC32) || defined(FFC64)
    fs->length2 = len;
#endif
#ifdef GFORTRAN
    fs->step = step;
    fs->start = 1;
    fs->end = len;
#endif
    step *= len;
  }
}

  caq_data->array = NA_PTR_TYPE(aq_data, void*);
{
  int shape[2];
  shape[0] = (NA_STRUCT(aq_data)->shape[1]);
  shape[1] = ((NA_STRUCT(aq_data)->shape[2])-1) - (0) + 1;
  out = na_make_object(NA_DFLOAT, 2, shape, cNArray);
  cout = (struct farray*) xmalloc(sizeof(struct farray)+sizeof(struct fshape)*2);
#if defined(IFORT) || defined(GFORTRAN)
{
  int i,j=1,offset=1;
  for (i=0;i<1;i++) {
    j = j*NA_STRUCT(out)->shape[i];
    offset += j;
  }
  cout->offset = -offset;
}
#endif
#if defined IFORT
  cout->vsize = sizeof(double);
{
  long type = 10;
  cout->type = ((type<<(sizeof(void*)*6)) | 1);
}
  cout->rank = 2;
#elif defined GFORTRAN
{
  cout->flag = (2 | (1<<4) | (sizeof(double)<<6));
}
#elif defined(FFC32) || defined(FFC64)
  cout->total = NA_STRUCT(out)->total;
  cout->total_byte = cout->total*sizeof(double);
#endif
{
  int step=1, len, i;
  struct fshape* fs;
  for (i=0;i<2;i++) {
    len = NA_STRUCT(out)->shape[i];
    fs = (struct fshape*)(cout+1)+i;
#if defined(IFORT) || defined(FFC32) || defined(FFC64)
    fs->step = 8*step;
    fs->length = len;
    fs->flag = 1;
#endif
#if defined(FFC32) || defined(FFC64)
    fs->length2 = len;
#endif
#ifdef GFORTRAN
    fs->step = step;
    fs->start = 1;
    fs->end = len;
#endif
    step *= len;
  }
}

  cout->array = NA_PTR_TYPE(out, void*);
};

#if defined IFORT
  aq_module_mp_aq_r2inv_aq_(cout, caq_data);
#elif defined GFORTRAN
  __aq_module_MOD_aq_r2inv_aq(cout, caq_data);
#elif defined(FFC32) || defined(FFC64)
  aq_module_aq_r2inv_aq_(cout, caq_data);
#endif

  free(caq_data);
#if defined(FFC32) || defined(FFC64)
{
  double* cnout = NA_PTR_TYPE(out,double*);
  int i;
  for (i=0;i<NA_TOTAL(out);i++)
    cnout[i] = ((double*)cout->array)[i];
}
#endif
  free(cout);
  return out;
}

static VALUE
rbspml_q_r2Inv_q(int argc, VALUE *argv, VALUE self)
{
  VALUE q_data, out;
  struct farray* cq_data;
  struct farray* cout;

  rb_scan_args(argc, argv, "10", &q_data);
  q_data = na_cast_object(q_data, NA_DFLOAT);
  cq_data = (struct farray*) xmalloc(sizeof(struct farray)+sizeof(struct fshape)*1);
#if defined(IFORT) || defined(GFORTRAN)
{
  int i,j=1,offset=1;
  for (i=0;i<0;i++) {
    j = j*NA_STRUCT(q_data)->shape[i];
    offset += j;
  }
  cq_data->offset = -offset;
}
#endif
#if defined IFORT
  cq_data->vsize = sizeof(double);
{
  long type = 10;
  cq_data->type = ((type<<(sizeof(void*)*6)) | 1);
}
  cq_data->rank = 1;
#elif defined GFORTRAN
{
  cq_data->flag = (1 | (1<<4) | (sizeof(double)<<6));
}
#elif defined(FFC32) || defined(FFC64)
  cq_data->total = NA_STRUCT(q_data)->total;
  cq_data->total_byte = cq_data->total*sizeof(double);
#endif
{
  int step=1, len, i;
  struct fshape* fs;
  for (i=0;i<1;i++) {
    len = NA_STRUCT(q_data)->shape[i];
    fs = (struct fshape*)(cq_data+1)+i;
#if defined(IFORT) || defined(FFC32) || defined(FFC64)
    fs->step = 8*step;
    fs->length = len;
    fs->flag = 1;
#endif
#if defined(FFC32) || defined(FFC64)
    fs->length2 = len;
#endif
#ifdef GFORTRAN
    fs->step = step;
    fs->start = 1;
    fs->end = len;
#endif
    step *= len;
  }
}

  cq_data->array = NA_PTR_TYPE(q_data, void*);
{
  int shape[1];
  shape[0] = (km) - (0) + 1;
  out = na_make_object(NA_DFLOAT, 1, shape, cNArray);
  cout = (struct farray*) xmalloc(sizeof(struct farray)+sizeof(struct fshape)*1);
#if defined(IFORT) || defined(GFORTRAN)
{
  int i,j=1,offset=1;
  for (i=0;i<0;i++) {
    j = j*NA_STRUCT(out)->shape[i];
    offset += j;
  }
  cout->offset = -offset;
}
#endif
#if defined IFORT
  cout->vsize = sizeof(double);
{
  long type = 10;
  cout->type = ((type<<(sizeof(void*)*6)) | 1);
}
  cout->rank = 1;
#elif defined GFORTRAN
{
  cout->flag = (1 | (1<<4) | (sizeof(double)<<6));
}
#elif defined(FFC32) || defined(FFC64)
  cout->total = NA_STRUCT(out)->total;
  cout->total_byte = cout->total*sizeof(double);
#endif
{
  int step=1, len, i;
  struct fshape* fs;
  for (i=0;i<1;i++) {
    len = NA_STRUCT(out)->shape[i];
    fs = (struct fshape*)(cout+1)+i;
#if defined(IFORT) || defined(FFC32) || defined(FFC64)
    fs->step = 8*step;
    fs->length = len;
    fs->flag = 1;
#endif
#if defined(FFC32) || defined(FFC64)
    fs->length2 = len;
#endif
#ifdef GFORTRAN
    fs->step = step;
    fs->start = 1;
    fs->end = len;
#endif
    step *= len;
  }
}

  cout->array = NA_PTR_TYPE(out, void*);
};

#if defined IFORT
  aq_module_mp_q_r2inv_q_(cout, cq_data);
#elif defined GFORTRAN
  __aq_module_MOD_q_r2inv_q(cout, cq_data);
#elif defined(FFC32) || defined(FFC64)
  aq_module_q_r2inv_q_(cout, cq_data);
#endif

  free(cq_data);
#if defined(FFC32) || defined(FFC64)
{
  double* cnout = NA_PTR_TYPE(out,double*);
  int i;
  for (i=0;i<NA_TOTAL(out);i++)
    cnout[i] = ((double*)cout->array)[i];
}
#endif
  free(cout);
  return out;
}

static VALUE
rbspml_a_Int_ag(int argc, VALUE *argv, VALUE self)
{
  VALUE ag, out;
  struct farray* cag;
  struct farray* cout;

  rb_scan_args(argc, argv, "10", &ag);
  ag = na_cast_object(ag, NA_DFLOAT);
  cag = (struct farray*) xmalloc(sizeof(struct farray)+sizeof(struct fshape)*2);
#if defined(IFORT) || defined(GFORTRAN)
{
  int i,j=1,offset=1;
  for (i=0;i<1;i++) {
    j = j*NA_STRUCT(ag)->shape[i];
    offset += j;
  }
  cag->offset = -offset;
}
#endif
#if defined IFORT
  cag->vsize = sizeof(double);
{
  long type = 10;
  cag->type = ((type<<(sizeof(void*)*6)) | 1);
}
  cag->rank = 2;
#elif defined GFORTRAN
{
  cag->flag = (2 | (1<<4) | (sizeof(double)<<6));
}
#elif defined(FFC32) || defined(FFC64)
  cag->total = NA_STRUCT(ag)->total;
  cag->total_byte = cag->total*sizeof(double);
#endif
{
  int step=1, len, i;
  struct fshape* fs;
  for (i=0;i<2;i++) {
    len = NA_STRUCT(ag)->shape[i];
    fs = (struct fshape*)(cag+1)+i;
#if defined(IFORT) || defined(FFC32) || defined(FFC64)
    fs->step = 8*step;
    fs->length = len;
    fs->flag = 1;
#endif
#if defined(FFC32) || defined(FFC64)
    fs->length2 = len;
#endif
#ifdef GFORTRAN
    fs->step = step;
    fs->start = 1;
    fs->end = len;
#endif
    step *= len;
  }
}

  cag->array = NA_PTR_TYPE(ag, void*);
{
  int shape[1];
  shape[0] = (NA_STRUCT(ag)->shape[1]);
  out = na_make_object(NA_DFLOAT, 1, shape, cNArray);
  cout = (struct farray*) xmalloc(sizeof(struct farray)+sizeof(struct fshape)*1);
#if defined(IFORT) || defined(GFORTRAN)
{
  int i,j=1,offset=1;
  for (i=0;i<0;i++) {
    j = j*NA_STRUCT(out)->shape[i];
    offset += j;
  }
  cout->offset = -offset;
}
#endif
#if defined IFORT
  cout->vsize = sizeof(double);
{
  long type = 10;
  cout->type = ((type<<(sizeof(void*)*6)) | 1);
}
  cout->rank = 1;
#elif defined GFORTRAN
{
  cout->flag = (1 | (1<<4) | (sizeof(double)<<6));
}
#elif defined(FFC32) || defined(FFC64)
  cout->total = NA_STRUCT(out)->total;
  cout->total_byte = cout->total*sizeof(double);
#endif
{
  int step=1, len, i;
  struct fshape* fs;
  for (i=0;i<1;i++) {
    len = NA_STRUCT(out)->shape[i];
    fs = (struct fshape*)(cout+1)+i;
#if defined(IFORT) || defined(FFC32) || defined(FFC64)
    fs->step = 8*step;
    fs->length = len;
    fs->flag = 1;
#endif
#if defined(FFC32) || defined(FFC64)
    fs->length2 = len;
#endif
#ifdef GFORTRAN
    fs->step = step;
    fs->start = 1;
    fs->end = len;
#endif
    step *= len;
  }
}

  cout->array = NA_PTR_TYPE(out, void*);
};

#if defined IFORT
  aq_module_mp_a_int_ag_(cout, cag);
#elif defined GFORTRAN
  __aq_module_MOD_a_int_ag(cout, cag);
#elif defined(FFC32) || defined(FFC64)
  aq_module_a_int_ag_(cout, cag);
#endif

  free(cag);
#if defined(FFC32) || defined(FFC64)
{
  double* cnout = NA_PTR_TYPE(out,double*);
  int i;
  for (i=0;i<NA_TOTAL(out);i++)
    cnout[i] = ((double*)cout->array)[i];
}
#endif
  free(cout);
  return out;
}

static VALUE
rbspml_Int_g(int argc, VALUE *argv, VALUE self)
{
  VALUE g, out;
  double* cg;
  double cout;

  rb_scan_args(argc, argv, "10", &g);
  g = na_cast_object(g, NA_DFLOAT);
  cg = NA_PTR_TYPE(g, double*);

#if defined IFORT
  cout = aq_module_mp_int_g_(cg);
#elif defined GFORTRAN
  cout = __aq_module_MOD_int_g(cg);
#elif defined(FFC32) || defined(FFC64)
  cout = aq_module_int_g_(cg);
#endif

  out = rb_float_new(cout);
  return out;
}

static VALUE
rbspml_a_Avr_ag(int argc, VALUE *argv, VALUE self)
{
  VALUE ag, out;
  struct farray* cag;
  struct farray* cout;

  rb_scan_args(argc, argv, "10", &ag);
  ag = na_cast_object(ag, NA_DFLOAT);
  cag = (struct farray*) xmalloc(sizeof(struct farray)+sizeof(struct fshape)*2);
#if defined(IFORT) || defined(GFORTRAN)
{
  int i,j=1,offset=1;
  for (i=0;i<1;i++) {
    j = j*NA_STRUCT(ag)->shape[i];
    offset += j;
  }
  cag->offset = -offset;
}
#endif
#if defined IFORT
  cag->vsize = sizeof(double);
{
  long type = 10;
  cag->type = ((type<<(sizeof(void*)*6)) | 1);
}
  cag->rank = 2;
#elif defined GFORTRAN
{
  cag->flag = (2 | (1<<4) | (sizeof(double)<<6));
}
#elif defined(FFC32) || defined(FFC64)
  cag->total = NA_STRUCT(ag)->total;
  cag->total_byte = cag->total*sizeof(double);
#endif
{
  int step=1, len, i;
  struct fshape* fs;
  for (i=0;i<2;i++) {
    len = NA_STRUCT(ag)->shape[i];
    fs = (struct fshape*)(cag+1)+i;
#if defined(IFORT) || defined(FFC32) || defined(FFC64)
    fs->step = 8*step;
    fs->length = len;
    fs->flag = 1;
#endif
#if defined(FFC32) || defined(FFC64)
    fs->length2 = len;
#endif
#ifdef GFORTRAN
    fs->step = step;
    fs->start = 1;
    fs->end = len;
#endif
    step *= len;
  }
}

  cag->array = NA_PTR_TYPE(ag, void*);
{
  int shape[1];
  shape[0] = (NA_STRUCT(ag)->shape[1]);
  out = na_make_object(NA_DFLOAT, 1, shape, cNArray);
  cout = (struct farray*) xmalloc(sizeof(struct farray)+sizeof(struct fshape)*1);
#if defined(IFORT) || defined(GFORTRAN)
{
  int i,j=1,offset=1;
  for (i=0;i<0;i++) {
    j = j*NA_STRUCT(out)->shape[i];
    offset += j;
  }
  cout->offset = -offset;
}
#endif
#if defined IFORT
  cout->vsize = sizeof(double);
{
  long type = 10;
  cout->type = ((type<<(sizeof(void*)*6)) | 1);
}
  cout->rank = 1;
#elif defined GFORTRAN
{
  cout->flag = (1 | (1<<4) | (sizeof(double)<<6));
}
#elif defined(FFC32) || defined(FFC64)
  cout->total = NA_STRUCT(out)->total;
  cout->total_byte = cout->total*sizeof(double);
#endif
{
  int step=1, len, i;
  struct fshape* fs;
  for (i=0;i<1;i++) {
    len = NA_STRUCT(out)->shape[i];
    fs = (struct fshape*)(cout+1)+i;
#if defined(IFORT) || defined(FFC32) || defined(FFC64)
    fs->step = 8*step;
    fs->length = len;
    fs->flag = 1;
#endif
#if defined(FFC32) || defined(FFC64)
    fs->length2 = len;
#endif
#ifdef GFORTRAN
    fs->step = step;
    fs->start = 1;
    fs->end = len;
#endif
    step *= len;
  }
}

  cout->array = NA_PTR_TYPE(out, void*);
};

#if defined IFORT
  aq_module_mp_a_avr_ag_(cout, cag);
#elif defined GFORTRAN
  __aq_module_MOD_a_avr_ag(cout, cag);
#elif defined(FFC32) || defined(FFC64)
  aq_module_a_avr_ag_(cout, cag);
#endif

  free(cag);
#if defined(FFC32) || defined(FFC64)
{
  double* cnout = NA_PTR_TYPE(out,double*);
  int i;
  for (i=0;i<NA_TOTAL(out);i++)
    cnout[i] = ((double*)cout->array)[i];
}
#endif
  free(cout);
  return out;
}

static VALUE
rbspml_Avr_g(int argc, VALUE *argv, VALUE self)
{
  VALUE g, out;
  double* cg;
  double cout;

  rb_scan_args(argc, argv, "10", &g);
  g = na_cast_object(g, NA_DFLOAT);
  cg = NA_PTR_TYPE(g, double*);

#if defined IFORT
  cout = aq_module_mp_avr_g_(cg);
#elif defined GFORTRAN
  cout = __aq_module_MOD_avr_g(cg);
#elif defined(FFC32) || defined(FFC64)
  cout = aq_module_avr_g_(cg);
#endif

  out = rb_float_new(cout);
  return out;
}

static VALUE
rbspml_aq_BoundaryTau_D_2d(int argc, VALUE *argv, VALUE self)
{
  VALUE aq_data, value;
  struct farray* caq_data;
  struct farray* cvalue;

  rb_scan_args(argc, argv, "11", &aq_data, &value);
  aq_data = na_cast_object(aq_data, NA_DFLOAT);
  caq_data = (struct farray*) xmalloc(sizeof(struct farray)+sizeof(struct fshape)*2);
#if defined(IFORT) || defined(GFORTRAN)
{
  int i,j=1,offset=1;
  for (i=0;i<1;i++) {
    j = j*NA_STRUCT(aq_data)->shape[i];
    offset += j;
  }
  caq_data->offset = -offset;
}
#endif
#if defined IFORT
  caq_data->vsize = sizeof(double);
{
  long type = 10;
  caq_data->type = ((type<<(sizeof(void*)*6)) | 1);
}
  caq_data->rank = 2;
#elif defined GFORTRAN
{
  caq_data->flag = (2 | (1<<4) | (sizeof(double)<<6));
}
#elif defined(FFC32) || defined(FFC64)
  caq_data->total = NA_STRUCT(aq_data)->total;
  caq_data->total_byte = caq_data->total*sizeof(double);
#endif
{
  int step=1, len, i;
  struct fshape* fs;
  for (i=0;i<2;i++) {
    len = NA_STRUCT(aq_data)->shape[i];
    fs = (struct fshape*)(caq_data+1)+i;
#if defined(IFORT) || defined(FFC32) || defined(FFC64)
    fs->step = 8*step;
    fs->length = len;
    fs->flag = 1;
#endif
#if defined(FFC32) || defined(FFC64)
    fs->length2 = len;
#endif
#ifdef GFORTRAN
    fs->step = step;
    fs->start = 1;
    fs->end = len;
#endif
    step *= len;
  }
}

  caq_data->array = NA_PTR_TYPE(aq_data, void*);
  if ( value != Qnil )
    value = na_cast_object(value, NA_DFLOAT);
  cvalue = (struct farray*) xmalloc(sizeof(struct farray)+sizeof(struct fshape)*1);
#if defined(IFORT) || defined(GFORTRAN)
{
  int i,j=1,offset=1;
  for (i=0;i<0;i++) {
    j = j*NA_STRUCT(value)->shape[i];
    offset += j;
  }
  cvalue->offset = -offset;
}
#endif
#if defined IFORT
  cvalue->vsize = sizeof(double);
{
  long type = 10;
  cvalue->type = ((type<<(sizeof(void*)*6)) | 1);
}
  cvalue->rank = 1;
#elif defined GFORTRAN
{
  cvalue->flag = (1 | (1<<4) | (sizeof(double)<<6));
}
#elif defined(FFC32) || defined(FFC64)
  cvalue->total = NA_STRUCT(value)->total;
  cvalue->total_byte = cvalue->total*sizeof(double);
#endif
{
  int step=1, len, i;
  struct fshape* fs;
  for (i=0;i<1;i++) {
    len = NA_STRUCT(value)->shape[i];
    fs = (struct fshape*)(cvalue+1)+i;
#if defined(IFORT) || defined(FFC32) || defined(FFC64)
    fs->step = 8*step;
    fs->length = len;
    fs->flag = 1;
#endif
#if defined(FFC32) || defined(FFC64)
    fs->length2 = len;
#endif
#ifdef GFORTRAN
    fs->step = step;
    fs->start = 1;
    fs->end = len;
#endif
    step *= len;
  }
}

  cvalue->array = NA_PTR_TYPE(value, void*);


#if defined IFORT
  aq_module_mp_aq_boundarytau_d_2d_(caq_data, value==Qnil ? NULL : cvalue);
#elif defined GFORTRAN
  __aq_module_MOD_aq_boundarytau_d_2d(caq_data, value==Qnil ? NULL : cvalue);
#elif defined(FFC32) || defined(FFC64)
  rb_raise(rb_eRuntimeError, "aq_BoundaryTau_D_2d is not supported for FFC comilar");
#endif

  free(caq_data);
  if ( value != Qnil )
    free(cvalue);
  return aq_data;
}

static VALUE
rbspml_aq_BoundaryTau_D_1d(int argc, VALUE *argv, VALUE self)
{
  VALUE q_data, value;
  double* cq_data;
  double cvalue;

  rb_scan_args(argc, argv, "11", &q_data, &value);
  q_data = na_cast_object(q_data, NA_DFLOAT);
  cq_data = NA_PTR_TYPE(q_data, double*);
  if ( value != Qnil )
    cvalue = NUM2DBL(value);

#if defined IFORT
  aq_module_mp_aq_boundarytau_d_1d_(cq_data, value==Qnil ? NULL : &cvalue);
#elif defined GFORTRAN
  __aq_module_MOD_aq_boundarytau_d_1d(cq_data, value==Qnil ? NULL : &cvalue);
#elif defined(FFC32) || defined(FFC64)
  rb_raise(rb_eRuntimeError, "aq_BoundaryTau_D_1d is not supported for FFC comilar");
#endif

  return q_data;
}

static VALUE
rbspml_aq_BoundaryTau_N_2d(int argc, VALUE *argv, VALUE self)
{
  VALUE aq_data, value;
  struct farray* caq_data;
  struct farray* cvalue;

  rb_scan_args(argc, argv, "11", &aq_data, &value);
  aq_data = na_cast_object(aq_data, NA_DFLOAT);
  caq_data = (struct farray*) xmalloc(sizeof(struct farray)+sizeof(struct fshape)*2);
#if defined(IFORT) || defined(GFORTRAN)
{
  int i,j=1,offset=1;
  for (i=0;i<1;i++) {
    j = j*NA_STRUCT(aq_data)->shape[i];
    offset += j;
  }
  caq_data->offset = -offset;
}
#endif
#if defined IFORT
  caq_data->vsize = sizeof(double);
{
  long type = 10;
  caq_data->type = ((type<<(sizeof(void*)*6)) | 1);
}
  caq_data->rank = 2;
#elif defined GFORTRAN
{
  caq_data->flag = (2 | (1<<4) | (sizeof(double)<<6));
}
#elif defined(FFC32) || defined(FFC64)
  caq_data->total = NA_STRUCT(aq_data)->total;
  caq_data->total_byte = caq_data->total*sizeof(double);
#endif
{
  int step=1, len, i;
  struct fshape* fs;
  for (i=0;i<2;i++) {
    len = NA_STRUCT(aq_data)->shape[i];
    fs = (struct fshape*)(caq_data+1)+i;
#if defined(IFORT) || defined(FFC32) || defined(FFC64)
    fs->step = 8*step;
    fs->length = len;
    fs->flag = 1;
#endif
#if defined(FFC32) || defined(FFC64)
    fs->length2 = len;
#endif
#ifdef GFORTRAN
    fs->step = step;
    fs->start = 1;
    fs->end = len;
#endif
    step *= len;
  }
}

  caq_data->array = NA_PTR_TYPE(aq_data, void*);
  if ( value != Qnil )
    value = na_cast_object(value, NA_DFLOAT);
  cvalue = (struct farray*) xmalloc(sizeof(struct farray)+sizeof(struct fshape)*1);
#if defined(IFORT) || defined(GFORTRAN)
{
  int i,j=1,offset=1;
  for (i=0;i<0;i++) {
    j = j*NA_STRUCT(value)->shape[i];
    offset += j;
  }
  cvalue->offset = -offset;
}
#endif
#if defined IFORT
  cvalue->vsize = sizeof(double);
{
  long type = 10;
  cvalue->type = ((type<<(sizeof(void*)*6)) | 1);
}
  cvalue->rank = 1;
#elif defined GFORTRAN
{
  cvalue->flag = (1 | (1<<4) | (sizeof(double)<<6));
}
#elif defined(FFC32) || defined(FFC64)
  cvalue->total = NA_STRUCT(value)->total;
  cvalue->total_byte = cvalue->total*sizeof(double);
#endif
{
  int step=1, len, i;
  struct fshape* fs;
  for (i=0;i<1;i++) {
    len = NA_STRUCT(value)->shape[i];
    fs = (struct fshape*)(cvalue+1)+i;
#if defined(IFORT) || defined(FFC32) || defined(FFC64)
    fs->step = 8*step;
    fs->length = len;
    fs->flag = 1;
#endif
#if defined(FFC32) || defined(FFC64)
    fs->length2 = len;
#endif
#ifdef GFORTRAN
    fs->step = step;
    fs->start = 1;
    fs->end = len;
#endif
    step *= len;
  }
}

  cvalue->array = NA_PTR_TYPE(value, void*);


#if defined IFORT
  aq_module_mp_aq_boundarytau_n_2d_(caq_data, value==Qnil ? NULL : cvalue);
#elif defined GFORTRAN
  __aq_module_MOD_aq_boundarytau_n_2d(caq_data, value==Qnil ? NULL : cvalue);
#elif defined(FFC32) || defined(FFC64)
  rb_raise(rb_eRuntimeError, "aq_BoundaryTau_N_2d is not supported for FFC comilar");
#endif

  free(caq_data);
  if ( value != Qnil )
    free(cvalue);
  return aq_data;
}

static VALUE
rbspml_aq_BoundaryTau_N_1d(int argc, VALUE *argv, VALUE self)
{
  VALUE q_data, value;
  double* cq_data;
  double cvalue;

  rb_scan_args(argc, argv, "11", &q_data, &value);
  q_data = na_cast_object(q_data, NA_DFLOAT);
  cq_data = NA_PTR_TYPE(q_data, double*);
  if ( value != Qnil )
    cvalue = NUM2DBL(value);

#if defined IFORT
  aq_module_mp_aq_boundarytau_n_1d_(cq_data, value==Qnil ? NULL : &cvalue);
#elif defined GFORTRAN
  __aq_module_MOD_aq_boundarytau_n_1d(cq_data, value==Qnil ? NULL : &cvalue);
#elif defined(FFC32) || defined(FFC64)
  rb_raise(rb_eRuntimeError, "aq_BoundaryTau_N_1d is not supported for FFC comilar");
#endif

  return q_data;
}

static VALUE
rbspml_ag_BoundaryGrid_D_2d(int argc, VALUE *argv, VALUE self)
{
  VALUE ag_data, value;
  struct farray* cag_data;
  struct farray* cvalue;

  rb_scan_args(argc, argv, "11", &ag_data, &value);
  ag_data = na_cast_object(ag_data, NA_DFLOAT);
  cag_data = (struct farray*) xmalloc(sizeof(struct farray)+sizeof(struct fshape)*2);
#if defined(IFORT) || defined(GFORTRAN)
{
  int i,j=1,offset=1;
  for (i=0;i<1;i++) {
    j = j*NA_STRUCT(ag_data)->shape[i];
    offset += j;
  }
  cag_data->offset = -offset;
}
#endif
#if defined IFORT
  cag_data->vsize = sizeof(double);
{
  long type = 10;
  cag_data->type = ((type<<(sizeof(void*)*6)) | 1);
}
  cag_data->rank = 2;
#elif defined GFORTRAN
{
  cag_data->flag = (2 | (1<<4) | (sizeof(double)<<6));
}
#elif defined(FFC32) || defined(FFC64)
  cag_data->total = NA_STRUCT(ag_data)->total;
  cag_data->total_byte = cag_data->total*sizeof(double);
#endif
{
  int step=1, len, i;
  struct fshape* fs;
  for (i=0;i<2;i++) {
    len = NA_STRUCT(ag_data)->shape[i];
    fs = (struct fshape*)(cag_data+1)+i;
#if defined(IFORT) || defined(FFC32) || defined(FFC64)
    fs->step = 8*step;
    fs->length = len;
    fs->flag = 1;
#endif
#if defined(FFC32) || defined(FFC64)
    fs->length2 = len;
#endif
#ifdef GFORTRAN
    fs->step = step;
    fs->start = 1;
    fs->end = len;
#endif
    step *= len;
  }
}

  cag_data->array = NA_PTR_TYPE(ag_data, void*);
  if ( value != Qnil )
    value = na_cast_object(value, NA_DFLOAT);
  cvalue = (struct farray*) xmalloc(sizeof(struct farray)+sizeof(struct fshape)*1);
#if defined(IFORT) || defined(GFORTRAN)
{
  int i,j=1,offset=1;
  for (i=0;i<0;i++) {
    j = j*NA_STRUCT(value)->shape[i];
    offset += j;
  }
  cvalue->offset = -offset;
}
#endif
#if defined IFORT
  cvalue->vsize = sizeof(double);
{
  long type = 10;
  cvalue->type = ((type<<(sizeof(void*)*6)) | 1);
}
  cvalue->rank = 1;
#elif defined GFORTRAN
{
  cvalue->flag = (1 | (1<<4) | (sizeof(double)<<6));
}
#elif defined(FFC32) || defined(FFC64)
  cvalue->total = NA_STRUCT(value)->total;
  cvalue->total_byte = cvalue->total*sizeof(double);
#endif
{
  int step=1, len, i;
  struct fshape* fs;
  for (i=0;i<1;i++) {
    len = NA_STRUCT(value)->shape[i];
    fs = (struct fshape*)(cvalue+1)+i;
#if defined(IFORT) || defined(FFC32) || defined(FFC64)
    fs->step = 8*step;
    fs->length = len;
    fs->flag = 1;
#endif
#if defined(FFC32) || defined(FFC64)
    fs->length2 = len;
#endif
#ifdef GFORTRAN
    fs->step = step;
    fs->start = 1;
    fs->end = len;
#endif
    step *= len;
  }
}

  cvalue->array = NA_PTR_TYPE(value, void*);


#if defined IFORT
  aq_module_mp_ag_boundarygrid_d_2d_(cag_data, value==Qnil ? NULL : cvalue);
#elif defined GFORTRAN
  __aq_module_MOD_ag_boundarygrid_d_2d(cag_data, value==Qnil ? NULL : cvalue);
#elif defined(FFC32) || defined(FFC64)
  rb_raise(rb_eRuntimeError, "ag_BoundaryGrid_D_2d is not supported for FFC comilar");
#endif

  free(cag_data);
  if ( value != Qnil )
    free(cvalue);
  return ag_data;
}

static VALUE
rbspml_ag_BoundaryGrid_D_1d(int argc, VALUE *argv, VALUE self)
{
  VALUE g_data, value;
  double* cg_data;
  double cvalue;

  rb_scan_args(argc, argv, "11", &g_data, &value);
  g_data = na_cast_object(g_data, NA_DFLOAT);
  cg_data = NA_PTR_TYPE(g_data, double*);
  if ( value != Qnil )
    cvalue = NUM2DBL(value);

#if defined IFORT
  aq_module_mp_ag_boundarygrid_d_1d_(cg_data, value==Qnil ? NULL : &cvalue);
#elif defined GFORTRAN
  __aq_module_MOD_ag_boundarygrid_d_1d(cg_data, value==Qnil ? NULL : &cvalue);
#elif defined(FFC32) || defined(FFC64)
  rb_raise(rb_eRuntimeError, "ag_BoundaryGrid_D_1d is not supported for FFC comilar");
#endif

  return g_data;
}

static VALUE
rbspml_ag_BoundaryGrid_N_2d(int argc, VALUE *argv, VALUE self)
{
  VALUE ag_data, value;
  struct farray* cag_data;
  struct farray* cvalue;

  rb_scan_args(argc, argv, "11", &ag_data, &value);
  ag_data = na_cast_object(ag_data, NA_DFLOAT);
  cag_data = (struct farray*) xmalloc(sizeof(struct farray)+sizeof(struct fshape)*2);
#if defined(IFORT) || defined(GFORTRAN)
{
  int i,j=1,offset=1;
  for (i=0;i<1;i++) {
    j = j*NA_STRUCT(ag_data)->shape[i];
    offset += j;
  }
  cag_data->offset = -offset;
}
#endif
#if defined IFORT
  cag_data->vsize = sizeof(double);
{
  long type = 10;
  cag_data->type = ((type<<(sizeof(void*)*6)) | 1);
}
  cag_data->rank = 2;
#elif defined GFORTRAN
{
  cag_data->flag = (2 | (1<<4) | (sizeof(double)<<6));
}
#elif defined(FFC32) || defined(FFC64)
  cag_data->total = NA_STRUCT(ag_data)->total;
  cag_data->total_byte = cag_data->total*sizeof(double);
#endif
{
  int step=1, len, i;
  struct fshape* fs;
  for (i=0;i<2;i++) {
    len = NA_STRUCT(ag_data)->shape[i];
    fs = (struct fshape*)(cag_data+1)+i;
#if defined(IFORT) || defined(FFC32) || defined(FFC64)
    fs->step = 8*step;
    fs->length = len;
    fs->flag = 1;
#endif
#if defined(FFC32) || defined(FFC64)
    fs->length2 = len;
#endif
#ifdef GFORTRAN
    fs->step = step;
    fs->start = 1;
    fs->end = len;
#endif
    step *= len;
  }
}

  cag_data->array = NA_PTR_TYPE(ag_data, void*);
  if ( value != Qnil )
    value = na_cast_object(value, NA_DFLOAT);
  cvalue = (struct farray*) xmalloc(sizeof(struct farray)+sizeof(struct fshape)*1);
#if defined(IFORT) || defined(GFORTRAN)
{
  int i,j=1,offset=1;
  for (i=0;i<0;i++) {
    j = j*NA_STRUCT(value)->shape[i];
    offset += j;
  }
  cvalue->offset = -offset;
}
#endif
#if defined IFORT
  cvalue->vsize = sizeof(double);
{
  long type = 10;
  cvalue->type = ((type<<(sizeof(void*)*6)) | 1);
}
  cvalue->rank = 1;
#elif defined GFORTRAN
{
  cvalue->flag = (1 | (1<<4) | (sizeof(double)<<6));
}
#elif defined(FFC32) || defined(FFC64)
  cvalue->total = NA_STRUCT(value)->total;
  cvalue->total_byte = cvalue->total*sizeof(double);
#endif
{
  int step=1, len, i;
  struct fshape* fs;
  for (i=0;i<1;i++) {
    len = NA_STRUCT(value)->shape[i];
    fs = (struct fshape*)(cvalue+1)+i;
#if defined(IFORT) || defined(FFC32) || defined(FFC64)
    fs->step = 8*step;
    fs->length = len;
    fs->flag = 1;
#endif
#if defined(FFC32) || defined(FFC64)
    fs->length2 = len;
#endif
#ifdef GFORTRAN
    fs->step = step;
    fs->start = 1;
    fs->end = len;
#endif
    step *= len;
  }
}

  cvalue->array = NA_PTR_TYPE(value, void*);


#if defined IFORT
  aq_module_mp_ag_boundarygrid_n_2d_(cag_data, value==Qnil ? NULL : cvalue);
#elif defined GFORTRAN
  __aq_module_MOD_ag_boundarygrid_n_2d(cag_data, value==Qnil ? NULL : cvalue);
#elif defined(FFC32) || defined(FFC64)
  rb_raise(rb_eRuntimeError, "ag_BoundaryGrid_N_2d is not supported for FFC comilar");
#endif

  free(cag_data);
  if ( value != Qnil )
    free(cvalue);
  return ag_data;
}

static VALUE
rbspml_ag_BoundaryGrid_N_1d(int argc, VALUE *argv, VALUE self)
{
  VALUE g_data, value;
  double* cg_data;
  double cvalue;

  rb_scan_args(argc, argv, "11", &g_data, &value);
  g_data = na_cast_object(g_data, NA_DFLOAT);
  cg_data = NA_PTR_TYPE(g_data, double*);
  if ( value != Qnil )
    cvalue = NUM2DBL(value);

#if defined IFORT
  aq_module_mp_ag_boundarygrid_n_1d_(cg_data, value==Qnil ? NULL : &cvalue);
#elif defined GFORTRAN
  __aq_module_MOD_ag_boundarygrid_n_1d(cg_data, value==Qnil ? NULL : &cvalue);
#elif defined(FFC32) || defined(FFC64)
  rb_raise(rb_eRuntimeError, "ag_BoundaryGrid_N_1d is not supported for FFC comilar");
#endif

  return g_data;
}


void init_aq_module(VALUE mSPML)
{
  VALUE mAQ;

  mAQ = rb_define_module_under(mSPML, "AQ");

  rb_define_module_function(mAQ, "g_R", rbspml_g_R, -1);
  rb_define_method(mAQ, "g_R", rbspml_g_R, -1);
  rb_define_module_function(mAQ, "g_R_Weight", rbspml_g_R_Weight, -1);
  rb_define_method(mAQ, "g_R_Weight", rbspml_g_R_Weight, -1);
  rb_define_module_function(mAQ, "aq_initial", rbspml_aq_initial, -1);
  rb_define_method(mAQ, "aq_initial", rbspml_aq_initial, -1);
  rb_define_module_function(mAQ, "ag_aq", rbspml_ag_aq, -1);
  rb_define_method(mAQ, "ag_aq", rbspml_ag_aq, -1);
  rb_define_module_function(mAQ, "g_q", rbspml_g_q, -1);
  rb_define_method(mAQ, "g_q", rbspml_g_q, -1);
  rb_define_module_function(mAQ, "aq_ag", rbspml_aq_ag, -1);
  rb_define_method(mAQ, "aq_ag", rbspml_aq_ag, -1);
  rb_define_module_function(mAQ, "q_g", rbspml_q_g, -1);
  rb_define_method(mAQ, "q_g", rbspml_q_g, -1);
  rb_define_module_function(mAQ, "aq_rDr_aq", rbspml_aq_rDr_aq, -1);
  rb_define_method(mAQ, "aq_rDr_aq", rbspml_aq_rDr_aq, -1);
  rb_define_module_function(mAQ, "q_rDr_q", rbspml_q_rDr_q, -1);
  rb_define_method(mAQ, "q_rDr_q", rbspml_q_rDr_q, -1);
  rb_define_module_function(mAQ, "aq_r2_aq", rbspml_aq_r2_aq, -1);
  rb_define_method(mAQ, "aq_r2_aq", rbspml_aq_r2_aq, -1);
  rb_define_module_function(mAQ, "q_r2_q", rbspml_q_r2_q, -1);
  rb_define_method(mAQ, "q_r2_q", rbspml_q_r2_q, -1);
  rb_define_module_function(mAQ, "aq_r2Inv_aq", rbspml_aq_r2Inv_aq, -1);
  rb_define_method(mAQ, "aq_r2Inv_aq", rbspml_aq_r2Inv_aq, -1);
  rb_define_module_function(mAQ, "q_r2Inv_q", rbspml_q_r2Inv_q, -1);
  rb_define_method(mAQ, "q_r2Inv_q", rbspml_q_r2Inv_q, -1);
  rb_define_module_function(mAQ, "a_Int_ag", rbspml_a_Int_ag, -1);
  rb_define_method(mAQ, "a_Int_ag", rbspml_a_Int_ag, -1);
  rb_define_module_function(mAQ, "Int_g", rbspml_Int_g, -1);
  rb_define_method(mAQ, "Int_g", rbspml_Int_g, -1);
  rb_define_module_function(mAQ, "a_Avr_ag", rbspml_a_Avr_ag, -1);
  rb_define_method(mAQ, "a_Avr_ag", rbspml_a_Avr_ag, -1);
  rb_define_module_function(mAQ, "Avr_g", rbspml_Avr_g, -1);
  rb_define_method(mAQ, "Avr_g", rbspml_Avr_g, -1);
  rb_define_module_function(mAQ, "aq_BoundaryTau_D_2d", rbspml_aq_BoundaryTau_D_2d, -1);
  rb_define_method(mAQ, "aq_BoundaryTau_D_2d", rbspml_aq_BoundaryTau_D_2d, -1);
  rb_define_module_function(mAQ, "aq_BoundaryTau_D_1d", rbspml_aq_BoundaryTau_D_1d, -1);
  rb_define_method(mAQ, "aq_BoundaryTau_D_1d", rbspml_aq_BoundaryTau_D_1d, -1);
  rb_define_module_function(mAQ, "aq_BoundaryTau_N_2d", rbspml_aq_BoundaryTau_N_2d, -1);
  rb_define_method(mAQ, "aq_BoundaryTau_N_2d", rbspml_aq_BoundaryTau_N_2d, -1);
  rb_define_module_function(mAQ, "aq_BoundaryTau_N_1d", rbspml_aq_BoundaryTau_N_1d, -1);
  rb_define_method(mAQ, "aq_BoundaryTau_N_1d", rbspml_aq_BoundaryTau_N_1d, -1);
  rb_define_module_function(mAQ, "ag_BoundaryGrid_D_2d", rbspml_ag_BoundaryGrid_D_2d, -1);
  rb_define_method(mAQ, "ag_BoundaryGrid_D_2d", rbspml_ag_BoundaryGrid_D_2d, -1);
  rb_define_module_function(mAQ, "ag_BoundaryGrid_D_1d", rbspml_ag_BoundaryGrid_D_1d, -1);
  rb_define_method(mAQ, "ag_BoundaryGrid_D_1d", rbspml_ag_BoundaryGrid_D_1d, -1);
  rb_define_module_function(mAQ, "ag_BoundaryGrid_N_2d", rbspml_ag_BoundaryGrid_N_2d, -1);
  rb_define_method(mAQ, "ag_BoundaryGrid_N_2d", rbspml_ag_BoundaryGrid_N_2d, -1);
  rb_define_module_function(mAQ, "ag_BoundaryGrid_N_1d", rbspml_ag_BoundaryGrid_N_1d, -1);
  rb_define_method(mAQ, "ag_BoundaryGrid_N_1d", rbspml_ag_BoundaryGrid_N_1d, -1);
}
