#include "ruby-spml.h"

#ifdef IFORT
extern struct farray* w_deriv_module_mp_w_lapla_w_(struct farray*, double*);
extern struct farray* w_deriv_module_mp_w_laplainv_w_(struct farray*, double*);
extern struct farray* w_deriv_module_mp_w_dlon_w_(struct farray*, double*);
extern struct farray* w_deriv_module_mp_xy_gradlon_w_(struct farray*, double*);
extern struct farray* w_deriv_module_mp_xy_gradlat_w_(struct farray*, double*);
extern struct farray* w_deriv_module_mp_w_divlon_xy_(struct farray*, double*);
extern struct farray* w_deriv_module_mp_w_divlat_xy_(struct farray*, double*);
extern struct farray* w_deriv_module_mp_w_div_xy_xy_(struct farray*, double*, double*);
extern struct farray* w_deriv_module_mp_w_jacobian_w_w_(struct farray*, double*, double*);
extern struct farray* w_deriv_module_mp_xy_gradlambda_w_(struct farray*, double*);
extern struct farray* w_deriv_module_mp_xy_gradmu_w_(struct farray*, double*);
extern struct farray* w_deriv_module_mp_w_divlambda_xy_(struct farray*, double*);
extern struct farray* w_deriv_module_mp_w_divmu_xy_(struct farray*, double*);
#endif
#ifdef GFORTRAN
extern struct farray* __w_deriv_module_MOD_w_lapla_w(struct farray*, double*);
extern struct farray* __w_deriv_module_MOD_w_laplainv_w(struct farray*, double*);
extern struct farray* __w_deriv_module_MOD_w_dlon_w(struct farray*, double*);
extern struct farray* __w_deriv_module_MOD_xy_gradlon_w(struct farray*, double*);
extern struct farray* __w_deriv_module_MOD_xy_gradlat_w(struct farray*, double*);
extern struct farray* __w_deriv_module_MOD_w_divlon_xy(struct farray*, double*);
extern struct farray* __w_deriv_module_MOD_w_divlat_xy(struct farray*, double*);
extern struct farray* __w_deriv_module_MOD_w_div_xy_xy(struct farray*, double*, double*);
extern struct farray* __w_deriv_module_MOD_w_jacobian_w_w(struct farray*, double*, double*);
extern struct farray* __w_deriv_module_MOD_xy_gradlambda_w(struct farray*, double*);
extern struct farray* __w_deriv_module_MOD_xy_gradmu_w(struct farray*, double*);
extern struct farray* __w_deriv_module_MOD_w_divlambda_xy(struct farray*, double*);
extern struct farray* __w_deriv_module_MOD_w_divmu_xy(struct farray*, double*);
#endif
#ifdef FFC32
asm ("w_deriv_module_w_lapla_w_:");
asm ("  pushl %ebp");
asm ("  movl %esp,%ebp");
asm ("  movl 12(%ebp), %eax");
asm ("  pushl %eax");
asm ("  movl 8(%ebp), %eax");
asm ("  pushl %eax");
asm ("  call w_deriv_module.w_lapla_w_");
asm ("  leave");
asm ("  ret");
asm ("w_deriv_module_w_laplainv_w_:");
asm ("  pushl %ebp");
asm ("  movl %esp,%ebp");
asm ("  movl 12(%ebp), %eax");
asm ("  pushl %eax");
asm ("  movl 8(%ebp), %eax");
asm ("  pushl %eax");
asm ("  call w_deriv_module.w_laplainv_w_");
asm ("  leave");
asm ("  ret");
asm ("w_deriv_module_w_dlon_w_:");
asm ("  pushl %ebp");
asm ("  movl %esp,%ebp");
asm ("  movl 12(%ebp), %eax");
asm ("  pushl %eax");
asm ("  movl 8(%ebp), %eax");
asm ("  pushl %eax");
asm ("  call w_deriv_module.w_dlon_w_");
asm ("  leave");
asm ("  ret");
asm ("w_deriv_module_xy_gradlon_w_:");
asm ("  pushl %ebp");
asm ("  movl %esp,%ebp");
asm ("  movl 12(%ebp), %eax");
asm ("  pushl %eax");
asm ("  movl 8(%ebp), %eax");
asm ("  pushl %eax");
asm ("  call w_deriv_module.xy_gradlon_w_");
asm ("  leave");
asm ("  ret");
asm ("w_deriv_module_xy_gradlat_w_:");
asm ("  pushl %ebp");
asm ("  movl %esp,%ebp");
asm ("  movl 12(%ebp), %eax");
asm ("  pushl %eax");
asm ("  movl 8(%ebp), %eax");
asm ("  pushl %eax");
asm ("  call w_deriv_module.xy_gradlat_w_");
asm ("  leave");
asm ("  ret");
asm ("w_deriv_module_w_divlon_xy_:");
asm ("  pushl %ebp");
asm ("  movl %esp,%ebp");
asm ("  movl 12(%ebp), %eax");
asm ("  pushl %eax");
asm ("  movl 8(%ebp), %eax");
asm ("  pushl %eax");
asm ("  call w_deriv_module.w_divlon_xy_");
asm ("  leave");
asm ("  ret");
asm ("w_deriv_module_w_divlat_xy_:");
asm ("  pushl %ebp");
asm ("  movl %esp,%ebp");
asm ("  movl 12(%ebp), %eax");
asm ("  pushl %eax");
asm ("  movl 8(%ebp), %eax");
asm ("  pushl %eax");
asm ("  call w_deriv_module.w_divlat_xy_");
asm ("  leave");
asm ("  ret");
asm ("w_deriv_module_w_div_xy_xy_:");
asm ("  pushl %ebp");
asm ("  movl %esp,%ebp");
asm ("  movl 16(%ebp), %eax");
asm ("  pushl %eax");
asm ("  movl 12(%ebp), %eax");
asm ("  pushl %eax");
asm ("  movl 8(%ebp), %eax");
asm ("  pushl %eax");
asm ("  call w_deriv_module.w_div_xy_xy_");
asm ("  leave");
asm ("  ret");
asm ("w_deriv_module_w_jacobian_w_w_:");
asm ("  pushl %ebp");
asm ("  movl %esp,%ebp");
asm ("  movl 16(%ebp), %eax");
asm ("  pushl %eax");
asm ("  movl 12(%ebp), %eax");
asm ("  pushl %eax");
asm ("  movl 8(%ebp), %eax");
asm ("  pushl %eax");
asm ("  call w_deriv_module.w_jacobian_w_w_");
asm ("  leave");
asm ("  ret");
asm ("w_deriv_module_xy_gradlambda_w_:");
asm ("  pushl %ebp");
asm ("  movl %esp,%ebp");
asm ("  movl 12(%ebp), %eax");
asm ("  pushl %eax");
asm ("  movl 8(%ebp), %eax");
asm ("  pushl %eax");
asm ("  call w_deriv_module.xy_gradlambda_w_");
asm ("  leave");
asm ("  ret");
asm ("w_deriv_module_xy_gradmu_w_:");
asm ("  pushl %ebp");
asm ("  movl %esp,%ebp");
asm ("  movl 12(%ebp), %eax");
asm ("  pushl %eax");
asm ("  movl 8(%ebp), %eax");
asm ("  pushl %eax");
asm ("  call w_deriv_module.xy_gradmu_w_");
asm ("  leave");
asm ("  ret");
asm ("w_deriv_module_w_divlambda_xy_:");
asm ("  pushl %ebp");
asm ("  movl %esp,%ebp");
asm ("  movl 12(%ebp), %eax");
asm ("  pushl %eax");
asm ("  movl 8(%ebp), %eax");
asm ("  pushl %eax");
asm ("  call w_deriv_module.w_divlambda_xy_");
asm ("  leave");
asm ("  ret");
asm ("w_deriv_module_w_divmu_xy_:");
asm ("  pushl %ebp");
asm ("  movl %esp,%ebp");
asm ("  movl 12(%ebp), %eax");
asm ("  pushl %eax");
asm ("  movl 8(%ebp), %eax");
asm ("  pushl %eax");
asm ("  call w_deriv_module.w_divmu_xy_");
asm ("  leave");
asm ("  ret");
#endif
#ifdef FFC64
asm ("w_deriv_module_w_lapla_w_:");
asm ("  push %rbp");
asm ("  movq %rsp,%rbp");
asm ("  subq $16,%rsp");
asm ("  call w_deriv_module.w_lapla_w_@PLT");
asm ("  xorq %rax,%rax");
asm ("  addq $16,%rsp");
asm ("  leave");
asm ("  ret");
asm ("w_deriv_module_w_laplainv_w_:");
asm ("  push %rbp");
asm ("  movq %rsp,%rbp");
asm ("  subq $16,%rsp");
asm ("  call w_deriv_module.w_laplainv_w_@PLT");
asm ("  xorq %rax,%rax");
asm ("  addq $16,%rsp");
asm ("  leave");
asm ("  ret");
asm ("w_deriv_module_w_dlon_w_:");
asm ("  push %rbp");
asm ("  movq %rsp,%rbp");
asm ("  subq $16,%rsp");
asm ("  call w_deriv_module.w_dlon_w_@PLT");
asm ("  xorq %rax,%rax");
asm ("  addq $16,%rsp");
asm ("  leave");
asm ("  ret");
asm ("w_deriv_module_xy_gradlon_w_:");
asm ("  push %rbp");
asm ("  movq %rsp,%rbp");
asm ("  subq $16,%rsp");
asm ("  call w_deriv_module.xy_gradlon_w_@PLT");
asm ("  xorq %rax,%rax");
asm ("  addq $16,%rsp");
asm ("  leave");
asm ("  ret");
asm ("w_deriv_module_xy_gradlat_w_:");
asm ("  push %rbp");
asm ("  movq %rsp,%rbp");
asm ("  subq $16,%rsp");
asm ("  call w_deriv_module.xy_gradlat_w_@PLT");
asm ("  xorq %rax,%rax");
asm ("  addq $16,%rsp");
asm ("  leave");
asm ("  ret");
asm ("w_deriv_module_w_divlon_xy_:");
asm ("  push %rbp");
asm ("  movq %rsp,%rbp");
asm ("  subq $16,%rsp");
asm ("  call w_deriv_module.w_divlon_xy_@PLT");
asm ("  xorq %rax,%rax");
asm ("  addq $16,%rsp");
asm ("  leave");
asm ("  ret");
asm ("w_deriv_module_w_divlat_xy_:");
asm ("  push %rbp");
asm ("  movq %rsp,%rbp");
asm ("  subq $16,%rsp");
asm ("  call w_deriv_module.w_divlat_xy_@PLT");
asm ("  xorq %rax,%rax");
asm ("  addq $16,%rsp");
asm ("  leave");
asm ("  ret");
asm ("w_deriv_module_w_div_xy_xy_:");
asm ("  push %rbp");
asm ("  movq %rsp,%rbp");
asm ("  subq $16,%rsp");
asm ("  call w_deriv_module.w_div_xy_xy_@PLT");
asm ("  xorq %rax,%rax");
asm ("  addq $16,%rsp");
asm ("  leave");
asm ("  ret");
asm ("w_deriv_module_w_jacobian_w_w_:");
asm ("  push %rbp");
asm ("  movq %rsp,%rbp");
asm ("  subq $16,%rsp");
asm ("  call w_deriv_module.w_jacobian_w_w_@PLT");
asm ("  xorq %rax,%rax");
asm ("  addq $16,%rsp");
asm ("  leave");
asm ("  ret");
asm ("w_deriv_module_xy_gradlambda_w_:");
asm ("  push %rbp");
asm ("  movq %rsp,%rbp");
asm ("  subq $16,%rsp");
asm ("  call w_deriv_module.xy_gradlambda_w_@PLT");
asm ("  xorq %rax,%rax");
asm ("  addq $16,%rsp");
asm ("  leave");
asm ("  ret");
asm ("w_deriv_module_xy_gradmu_w_:");
asm ("  push %rbp");
asm ("  movq %rsp,%rbp");
asm ("  subq $16,%rsp");
asm ("  call w_deriv_module.xy_gradmu_w_@PLT");
asm ("  xorq %rax,%rax");
asm ("  addq $16,%rsp");
asm ("  leave");
asm ("  ret");
asm ("w_deriv_module_w_divlambda_xy_:");
asm ("  push %rbp");
asm ("  movq %rsp,%rbp");
asm ("  subq $16,%rsp");
asm ("  call w_deriv_module.w_divlambda_xy_@PLT");
asm ("  xorq %rax,%rax");
asm ("  addq $16,%rsp");
asm ("  leave");
asm ("  ret");
asm ("w_deriv_module_w_divmu_xy_:");
asm ("  push %rbp");
asm ("  movq %rsp,%rbp");
asm ("  subq $16,%rsp");
asm ("  call w_deriv_module.w_divmu_xy_@PLT");
asm ("  xorq %rax,%rax");
asm ("  addq $16,%rsp");
asm ("  leave");
asm ("  ret");
#endif
#if defined(FFC32) || defined(FFC64)
extern struct farray* w_deriv_module_w_lapla_w_(struct farray*, double*);
extern struct farray* w_deriv_module_w_laplainv_w_(struct farray*, double*);
extern struct farray* w_deriv_module_w_dlon_w_(struct farray*, double*);
extern struct farray* w_deriv_module_xy_gradlon_w_(struct farray*, double*);
extern struct farray* w_deriv_module_xy_gradlat_w_(struct farray*, double*);
extern struct farray* w_deriv_module_w_divlon_xy_(struct farray*, double*);
extern struct farray* w_deriv_module_w_divlat_xy_(struct farray*, double*);
extern struct farray* w_deriv_module_w_div_xy_xy_(struct farray*, double*, double*);
extern struct farray* w_deriv_module_w_jacobian_w_w_(struct farray*, double*, double*);
extern struct farray* w_deriv_module_xy_gradlambda_w_(struct farray*, double*);
extern struct farray* w_deriv_module_xy_gradmu_w_(struct farray*, double*);
extern struct farray* w_deriv_module_w_divlambda_xy_(struct farray*, double*);
extern struct farray* w_deriv_module_w_divmu_xy_(struct farray*, double*);
#endif


static VALUE
rbspml_w_Lapla_w(int argc, VALUE *argv, VALUE self)
{
  VALUE w_data, out;
  double* cw_data;
  struct farray* cout;

  rb_scan_args(argc, argv, "10", &w_data);
  w_data = na_cast_object(w_data, NA_DFLOAT);
  cw_data = NA_PTR_TYPE(w_data, double*);
{
  int shape[1];
  shape[0] = (NUM2INT(rb_funcall(self,rb_intern("nm"),0))+1)*(NUM2INT(rb_funcall(self,rb_intern("nm"),0))+1);
  out = na_make_object(NA_DFLOAT, 1, shape, cNArray);
  cout = (struct farray*) xmalloc(sizeof(struct farray)+sizeof(struct fshape)*1);
#if defined(IFORT) || defined(GFORTRAN)
{
  int i,j=1,offset=1;
  for (i=0;i<0;i++) {
    j = j*NA_STRUCT(out)->shape[i];
    offset += j;
  }
  cout->offset = -offset;
}
#endif
#if defined IFORT
  cout->vsize = sizeof(double);
{
  long type = 10;
  cout->type = ((type<<(sizeof(void*)*6)) | 1);
}
  cout->rank = 1;
#elif defined GFORTRAN
{
  cout->flag = (1 | (1<<4) | (sizeof(double)<<6));
}
#elif defined(FFC32) || defined(FFC64)
  cout->total = NA_STRUCT(out)->total;
  cout->total_byte = cout->total*sizeof(double);
#endif
{
  int step=1, len, i;
  struct fshape* fs;
  for (i=0;i<1;i++) {
    len = NA_STRUCT(out)->shape[i];
    fs = (struct fshape*)(cout+1)+i;
#if defined(IFORT) || defined(FFC32) || defined(FFC64)
    fs->step = 8*step;
    fs->length = len;
    fs->flag = 1;
#endif
#if defined(FFC32) || defined(FFC64)
    fs->length2 = len;
#endif
#ifdef GFORTRAN
    fs->step = step;
    fs->start = 1;
    fs->end = len;
#endif
    step *= len;
  }
}

  cout->array = NA_PTR_TYPE(out, void*);
};

#if defined IFORT
  w_deriv_module_mp_w_lapla_w_(cout, cw_data);
#elif defined GFORTRAN
  __w_deriv_module_MOD_w_lapla_w(cout, cw_data);
#elif defined(FFC32) || defined(FFC64)
  w_deriv_module_w_lapla_w_(cout, cw_data);
#endif

#if defined(FFC32) || defined(FFC64)
{
  double* cnout = NA_PTR_TYPE(out,double*);
  int i;
  for (i=0;i<NA_TOTAL(out);i++)
    cnout[i] = ((double*)cout->array)[i];
}
#endif
  free(cout);
  return out;
}

static VALUE
rbspml_w_LaplaInv_w(int argc, VALUE *argv, VALUE self)
{
  VALUE w_data, out;
  double* cw_data;
  struct farray* cout;

  rb_scan_args(argc, argv, "10", &w_data);
  w_data = na_cast_object(w_data, NA_DFLOAT);
  cw_data = NA_PTR_TYPE(w_data, double*);
{
  int shape[1];
  shape[0] = (NUM2INT(rb_funcall(self,rb_intern("nm"),0))+1)*(NUM2INT(rb_funcall(self,rb_intern("nm"),0))+1);
  out = na_make_object(NA_DFLOAT, 1, shape, cNArray);
  cout = (struct farray*) xmalloc(sizeof(struct farray)+sizeof(struct fshape)*1);
#if defined(IFORT) || defined(GFORTRAN)
{
  int i,j=1,offset=1;
  for (i=0;i<0;i++) {
    j = j*NA_STRUCT(out)->shape[i];
    offset += j;
  }
  cout->offset = -offset;
}
#endif
#if defined IFORT
  cout->vsize = sizeof(double);
{
  long type = 10;
  cout->type = ((type<<(sizeof(void*)*6)) | 1);
}
  cout->rank = 1;
#elif defined GFORTRAN
{
  cout->flag = (1 | (1<<4) | (sizeof(double)<<6));
}
#elif defined(FFC32) || defined(FFC64)
  cout->total = NA_STRUCT(out)->total;
  cout->total_byte = cout->total*sizeof(double);
#endif
{
  int step=1, len, i;
  struct fshape* fs;
  for (i=0;i<1;i++) {
    len = NA_STRUCT(out)->shape[i];
    fs = (struct fshape*)(cout+1)+i;
#if defined(IFORT) || defined(FFC32) || defined(FFC64)
    fs->step = 8*step;
    fs->length = len;
    fs->flag = 1;
#endif
#if defined(FFC32) || defined(FFC64)
    fs->length2 = len;
#endif
#ifdef GFORTRAN
    fs->step = step;
    fs->start = 1;
    fs->end = len;
#endif
    step *= len;
  }
}

  cout->array = NA_PTR_TYPE(out, void*);
};

#if defined IFORT
  w_deriv_module_mp_w_laplainv_w_(cout, cw_data);
#elif defined GFORTRAN
  __w_deriv_module_MOD_w_laplainv_w(cout, cw_data);
#elif defined(FFC32) || defined(FFC64)
  w_deriv_module_w_laplainv_w_(cout, cw_data);
#endif

#if defined(FFC32) || defined(FFC64)
{
  double* cnout = NA_PTR_TYPE(out,double*);
  int i;
  for (i=0;i<NA_TOTAL(out);i++)
    cnout[i] = ((double*)cout->array)[i];
}
#endif
  free(cout);
  return out;
}

static VALUE
rbspml_w_DLon_w(int argc, VALUE *argv, VALUE self)
{
  VALUE w_data, out;
  double* cw_data;
  struct farray* cout;

  rb_scan_args(argc, argv, "10", &w_data);
  w_data = na_cast_object(w_data, NA_DFLOAT);
  cw_data = NA_PTR_TYPE(w_data, double*);
{
  int shape[1];
  shape[0] = (NUM2INT(rb_funcall(self,rb_intern("nm"),0))+1)*(NUM2INT(rb_funcall(self,rb_intern("nm"),0))+1);
  out = na_make_object(NA_DFLOAT, 1, shape, cNArray);
  cout = (struct farray*) xmalloc(sizeof(struct farray)+sizeof(struct fshape)*1);
#if defined(IFORT) || defined(GFORTRAN)
{
  int i,j=1,offset=1;
  for (i=0;i<0;i++) {
    j = j*NA_STRUCT(out)->shape[i];
    offset += j;
  }
  cout->offset = -offset;
}
#endif
#if defined IFORT
  cout->vsize = sizeof(double);
{
  long type = 10;
  cout->type = ((type<<(sizeof(void*)*6)) | 1);
}
  cout->rank = 1;
#elif defined GFORTRAN
{
  cout->flag = (1 | (1<<4) | (sizeof(double)<<6));
}
#elif defined(FFC32) || defined(FFC64)
  cout->total = NA_STRUCT(out)->total;
  cout->total_byte = cout->total*sizeof(double);
#endif
{
  int step=1, len, i;
  struct fshape* fs;
  for (i=0;i<1;i++) {
    len = NA_STRUCT(out)->shape[i];
    fs = (struct fshape*)(cout+1)+i;
#if defined(IFORT) || defined(FFC32) || defined(FFC64)
    fs->step = 8*step;
    fs->length = len;
    fs->flag = 1;
#endif
#if defined(FFC32) || defined(FFC64)
    fs->length2 = len;
#endif
#ifdef GFORTRAN
    fs->step = step;
    fs->start = 1;
    fs->end = len;
#endif
    step *= len;
  }
}

  cout->array = NA_PTR_TYPE(out, void*);
};

#if defined IFORT
  w_deriv_module_mp_w_dlon_w_(cout, cw_data);
#elif defined GFORTRAN
  __w_deriv_module_MOD_w_dlon_w(cout, cw_data);
#elif defined(FFC32) || defined(FFC64)
  w_deriv_module_w_dlon_w_(cout, cw_data);
#endif

#if defined(FFC32) || defined(FFC64)
{
  double* cnout = NA_PTR_TYPE(out,double*);
  int i;
  for (i=0;i<NA_TOTAL(out);i++)
    cnout[i] = ((double*)cout->array)[i];
}
#endif
  free(cout);
  return out;
}

static VALUE
rbspml_xy_GradLon_w(int argc, VALUE *argv, VALUE self)
{
  VALUE w_data, out;
  double* cw_data;
  struct farray* cout;

  rb_scan_args(argc, argv, "10", &w_data);
  w_data = na_cast_object(w_data, NA_DFLOAT);
  cw_data = NA_PTR_TYPE(w_data, double*);
{
  int shape[2];
  shape[0] = (NUM2INT(rb_funcall(self,rb_intern("im"),0))-1) - (0) + 1;
  shape[1] = (NUM2INT(rb_funcall(self,rb_intern("jm"),0))) - (1) + 1;
  out = na_make_object(NA_DFLOAT, 2, shape, cNArray);
  cout = (struct farray*) xmalloc(sizeof(struct farray)+sizeof(struct fshape)*2);
#if defined(IFORT) || defined(GFORTRAN)
{
  int i,j=1,offset=1;
  for (i=0;i<1;i++) {
    j = j*NA_STRUCT(out)->shape[i];
    offset += j;
  }
  cout->offset = -offset;
}
#endif
#if defined IFORT
  cout->vsize = sizeof(double);
{
  long type = 10;
  cout->type = ((type<<(sizeof(void*)*6)) | 1);
}
  cout->rank = 2;
#elif defined GFORTRAN
{
  cout->flag = (2 | (1<<4) | (sizeof(double)<<6));
}
#elif defined(FFC32) || defined(FFC64)
  cout->total = NA_STRUCT(out)->total;
  cout->total_byte = cout->total*sizeof(double);
#endif
{
  int step=1, len, i;
  struct fshape* fs;
  for (i=0;i<2;i++) {
    len = NA_STRUCT(out)->shape[i];
    fs = (struct fshape*)(cout+1)+i;
#if defined(IFORT) || defined(FFC32) || defined(FFC64)
    fs->step = 8*step;
    fs->length = len;
    fs->flag = 1;
#endif
#if defined(FFC32) || defined(FFC64)
    fs->length2 = len;
#endif
#ifdef GFORTRAN
    fs->step = step;
    fs->start = 1;
    fs->end = len;
#endif
    step *= len;
  }
}

  cout->array = NA_PTR_TYPE(out, void*);
};

#if defined IFORT
  w_deriv_module_mp_xy_gradlon_w_(cout, cw_data);
#elif defined GFORTRAN
  __w_deriv_module_MOD_xy_gradlon_w(cout, cw_data);
#elif defined(FFC32) || defined(FFC64)
  w_deriv_module_xy_gradlon_w_(cout, cw_data);
#endif

#if defined(FFC32) || defined(FFC64)
{
  double* cnout = NA_PTR_TYPE(out,double*);
  int i;
  for (i=0;i<NA_TOTAL(out);i++)
    cnout[i] = ((double*)cout->array)[i];
}
#endif
  free(cout);
  return out;
}

static VALUE
rbspml_xy_GradLat_w(int argc, VALUE *argv, VALUE self)
{
  VALUE w_data, out;
  double* cw_data;
  struct farray* cout;

  rb_scan_args(argc, argv, "10", &w_data);
  w_data = na_cast_object(w_data, NA_DFLOAT);
  cw_data = NA_PTR_TYPE(w_data, double*);
{
  int shape[2];
  shape[0] = (NUM2INT(rb_funcall(self,rb_intern("im"),0))-1) - (0) + 1;
  shape[1] = (NUM2INT(rb_funcall(self,rb_intern("jm"),0))) - (1) + 1;
  out = na_make_object(NA_DFLOAT, 2, shape, cNArray);
  cout = (struct farray*) xmalloc(sizeof(struct farray)+sizeof(struct fshape)*2);
#if defined(IFORT) || defined(GFORTRAN)
{
  int i,j=1,offset=1;
  for (i=0;i<1;i++) {
    j = j*NA_STRUCT(out)->shape[i];
    offset += j;
  }
  cout->offset = -offset;
}
#endif
#if defined IFORT
  cout->vsize = sizeof(double);
{
  long type = 10;
  cout->type = ((type<<(sizeof(void*)*6)) | 1);
}
  cout->rank = 2;
#elif defined GFORTRAN
{
  cout->flag = (2 | (1<<4) | (sizeof(double)<<6));
}
#elif defined(FFC32) || defined(FFC64)
  cout->total = NA_STRUCT(out)->total;
  cout->total_byte = cout->total*sizeof(double);
#endif
{
  int step=1, len, i;
  struct fshape* fs;
  for (i=0;i<2;i++) {
    len = NA_STRUCT(out)->shape[i];
    fs = (struct fshape*)(cout+1)+i;
#if defined(IFORT) || defined(FFC32) || defined(FFC64)
    fs->step = 8*step;
    fs->length = len;
    fs->flag = 1;
#endif
#if defined(FFC32) || defined(FFC64)
    fs->length2 = len;
#endif
#ifdef GFORTRAN
    fs->step = step;
    fs->start = 1;
    fs->end = len;
#endif
    step *= len;
  }
}

  cout->array = NA_PTR_TYPE(out, void*);
};

#if defined IFORT
  w_deriv_module_mp_xy_gradlat_w_(cout, cw_data);
#elif defined GFORTRAN
  __w_deriv_module_MOD_xy_gradlat_w(cout, cw_data);
#elif defined(FFC32) || defined(FFC64)
  w_deriv_module_xy_gradlat_w_(cout, cw_data);
#endif

#if defined(FFC32) || defined(FFC64)
{
  double* cnout = NA_PTR_TYPE(out,double*);
  int i;
  for (i=0;i<NA_TOTAL(out);i++)
    cnout[i] = ((double*)cout->array)[i];
}
#endif
  free(cout);
  return out;
}

static VALUE
rbspml_w_DivLon_xy(int argc, VALUE *argv, VALUE self)
{
  VALUE xy_data, out;
  double* cxy_data;
  struct farray* cout;

  rb_scan_args(argc, argv, "10", &xy_data);
  xy_data = na_cast_object(xy_data, NA_DFLOAT);
  cxy_data = NA_PTR_TYPE(xy_data, double*);
{
  int shape[1];
  shape[0] = (NUM2INT(rb_funcall(self,rb_intern("nm"),0))+1)*(NUM2INT(rb_funcall(self,rb_intern("nm"),0))+1);
  out = na_make_object(NA_DFLOAT, 1, shape, cNArray);
  cout = (struct farray*) xmalloc(sizeof(struct farray)+sizeof(struct fshape)*1);
#if defined(IFORT) || defined(GFORTRAN)
{
  int i,j=1,offset=1;
  for (i=0;i<0;i++) {
    j = j*NA_STRUCT(out)->shape[i];
    offset += j;
  }
  cout->offset = -offset;
}
#endif
#if defined IFORT
  cout->vsize = sizeof(double);
{
  long type = 10;
  cout->type = ((type<<(sizeof(void*)*6)) | 1);
}
  cout->rank = 1;
#elif defined GFORTRAN
{
  cout->flag = (1 | (1<<4) | (sizeof(double)<<6));
}
#elif defined(FFC32) || defined(FFC64)
  cout->total = NA_STRUCT(out)->total;
  cout->total_byte = cout->total*sizeof(double);
#endif
{
  int step=1, len, i;
  struct fshape* fs;
  for (i=0;i<1;i++) {
    len = NA_STRUCT(out)->shape[i];
    fs = (struct fshape*)(cout+1)+i;
#if defined(IFORT) || defined(FFC32) || defined(FFC64)
    fs->step = 8*step;
    fs->length = len;
    fs->flag = 1;
#endif
#if defined(FFC32) || defined(FFC64)
    fs->length2 = len;
#endif
#ifdef GFORTRAN
    fs->step = step;
    fs->start = 1;
    fs->end = len;
#endif
    step *= len;
  }
}

  cout->array = NA_PTR_TYPE(out, void*);
};

#if defined IFORT
  w_deriv_module_mp_w_divlon_xy_(cout, cxy_data);
#elif defined GFORTRAN
  __w_deriv_module_MOD_w_divlon_xy(cout, cxy_data);
#elif defined(FFC32) || defined(FFC64)
  w_deriv_module_w_divlon_xy_(cout, cxy_data);
#endif

#if defined(FFC32) || defined(FFC64)
{
  double* cnout = NA_PTR_TYPE(out,double*);
  int i;
  for (i=0;i<NA_TOTAL(out);i++)
    cnout[i] = ((double*)cout->array)[i];
}
#endif
  free(cout);
  return out;
}

static VALUE
rbspml_w_DivLat_xy(int argc, VALUE *argv, VALUE self)
{
  VALUE xy_data, out;
  double* cxy_data;
  struct farray* cout;

  rb_scan_args(argc, argv, "10", &xy_data);
  xy_data = na_cast_object(xy_data, NA_DFLOAT);
  cxy_data = NA_PTR_TYPE(xy_data, double*);
{
  int shape[1];
  shape[0] = (NUM2INT(rb_funcall(self,rb_intern("nm"),0))+1)*(NUM2INT(rb_funcall(self,rb_intern("nm"),0))+1);
  out = na_make_object(NA_DFLOAT, 1, shape, cNArray);
  cout = (struct farray*) xmalloc(sizeof(struct farray)+sizeof(struct fshape)*1);
#if defined(IFORT) || defined(GFORTRAN)
{
  int i,j=1,offset=1;
  for (i=0;i<0;i++) {
    j = j*NA_STRUCT(out)->shape[i];
    offset += j;
  }
  cout->offset = -offset;
}
#endif
#if defined IFORT
  cout->vsize = sizeof(double);
{
  long type = 10;
  cout->type = ((type<<(sizeof(void*)*6)) | 1);
}
  cout->rank = 1;
#elif defined GFORTRAN
{
  cout->flag = (1 | (1<<4) | (sizeof(double)<<6));
}
#elif defined(FFC32) || defined(FFC64)
  cout->total = NA_STRUCT(out)->total;
  cout->total_byte = cout->total*sizeof(double);
#endif
{
  int step=1, len, i;
  struct fshape* fs;
  for (i=0;i<1;i++) {
    len = NA_STRUCT(out)->shape[i];
    fs = (struct fshape*)(cout+1)+i;
#if defined(IFORT) || defined(FFC32) || defined(FFC64)
    fs->step = 8*step;
    fs->length = len;
    fs->flag = 1;
#endif
#if defined(FFC32) || defined(FFC64)
    fs->length2 = len;
#endif
#ifdef GFORTRAN
    fs->step = step;
    fs->start = 1;
    fs->end = len;
#endif
    step *= len;
  }
}

  cout->array = NA_PTR_TYPE(out, void*);
};

#if defined IFORT
  w_deriv_module_mp_w_divlat_xy_(cout, cxy_data);
#elif defined GFORTRAN
  __w_deriv_module_MOD_w_divlat_xy(cout, cxy_data);
#elif defined(FFC32) || defined(FFC64)
  w_deriv_module_w_divlat_xy_(cout, cxy_data);
#endif

#if defined(FFC32) || defined(FFC64)
{
  double* cnout = NA_PTR_TYPE(out,double*);
  int i;
  for (i=0;i<NA_TOTAL(out);i++)
    cnout[i] = ((double*)cout->array)[i];
}
#endif
  free(cout);
  return out;
}

static VALUE
rbspml_w_Div_xy_xy(int argc, VALUE *argv, VALUE self)
{
  VALUE xy_u, xy_v, out;
  double* cxy_u;
  double* cxy_v;
  struct farray* cout;

  rb_scan_args(argc, argv, "20", &xy_u, &xy_v);
  xy_u = na_cast_object(xy_u, NA_DFLOAT);
  cxy_u = NA_PTR_TYPE(xy_u, double*);
  xy_v = na_cast_object(xy_v, NA_DFLOAT);
  cxy_v = NA_PTR_TYPE(xy_v, double*);
{
  int shape[1];
  shape[0] = (NUM2INT(rb_funcall(self,rb_intern("nm"),0))+1)*(NUM2INT(rb_funcall(self,rb_intern("nm"),0))+1);
  out = na_make_object(NA_DFLOAT, 1, shape, cNArray);
  cout = (struct farray*) xmalloc(sizeof(struct farray)+sizeof(struct fshape)*1);
#if defined(IFORT) || defined(GFORTRAN)
{
  int i,j=1,offset=1;
  for (i=0;i<0;i++) {
    j = j*NA_STRUCT(out)->shape[i];
    offset += j;
  }
  cout->offset = -offset;
}
#endif
#if defined IFORT
  cout->vsize = sizeof(double);
{
  long type = 10;
  cout->type = ((type<<(sizeof(void*)*6)) | 1);
}
  cout->rank = 1;
#elif defined GFORTRAN
{
  cout->flag = (1 | (1<<4) | (sizeof(double)<<6));
}
#elif defined(FFC32) || defined(FFC64)
  cout->total = NA_STRUCT(out)->total;
  cout->total_byte = cout->total*sizeof(double);
#endif
{
  int step=1, len, i;
  struct fshape* fs;
  for (i=0;i<1;i++) {
    len = NA_STRUCT(out)->shape[i];
    fs = (struct fshape*)(cout+1)+i;
#if defined(IFORT) || defined(FFC32) || defined(FFC64)
    fs->step = 8*step;
    fs->length = len;
    fs->flag = 1;
#endif
#if defined(FFC32) || defined(FFC64)
    fs->length2 = len;
#endif
#ifdef GFORTRAN
    fs->step = step;
    fs->start = 1;
    fs->end = len;
#endif
    step *= len;
  }
}

  cout->array = NA_PTR_TYPE(out, void*);
};

#if defined IFORT
  w_deriv_module_mp_w_div_xy_xy_(cout, cxy_u, cxy_v);
#elif defined GFORTRAN
  __w_deriv_module_MOD_w_div_xy_xy(cout, cxy_u, cxy_v);
#elif defined(FFC32) || defined(FFC64)
  w_deriv_module_w_div_xy_xy_(cout, cxy_u, cxy_v);
#endif

#if defined(FFC32) || defined(FFC64)
{
  double* cnout = NA_PTR_TYPE(out,double*);
  int i;
  for (i=0;i<NA_TOTAL(out);i++)
    cnout[i] = ((double*)cout->array)[i];
}
#endif
  free(cout);
  return out;
}

static VALUE
rbspml_w_Jacobian_w_w(int argc, VALUE *argv, VALUE self)
{
  VALUE w_a, w_b, out;
  double* cw_a;
  double* cw_b;
  struct farray* cout;

  rb_scan_args(argc, argv, "20", &w_a, &w_b);
  w_a = na_cast_object(w_a, NA_DFLOAT);
  cw_a = NA_PTR_TYPE(w_a, double*);
  w_b = na_cast_object(w_b, NA_DFLOAT);
  cw_b = NA_PTR_TYPE(w_b, double*);
{
  int shape[1];
  shape[0] = (NUM2INT(rb_funcall(self,rb_intern("nm"),0))+1)*(NUM2INT(rb_funcall(self,rb_intern("nm"),0))+1);
  out = na_make_object(NA_DFLOAT, 1, shape, cNArray);
  cout = (struct farray*) xmalloc(sizeof(struct farray)+sizeof(struct fshape)*1);
#if defined(IFORT) || defined(GFORTRAN)
{
  int i,j=1,offset=1;
  for (i=0;i<0;i++) {
    j = j*NA_STRUCT(out)->shape[i];
    offset += j;
  }
  cout->offset = -offset;
}
#endif
#if defined IFORT
  cout->vsize = sizeof(double);
{
  long type = 10;
  cout->type = ((type<<(sizeof(void*)*6)) | 1);
}
  cout->rank = 1;
#elif defined GFORTRAN
{
  cout->flag = (1 | (1<<4) | (sizeof(double)<<6));
}
#elif defined(FFC32) || defined(FFC64)
  cout->total = NA_STRUCT(out)->total;
  cout->total_byte = cout->total*sizeof(double);
#endif
{
  int step=1, len, i;
  struct fshape* fs;
  for (i=0;i<1;i++) {
    len = NA_STRUCT(out)->shape[i];
    fs = (struct fshape*)(cout+1)+i;
#if defined(IFORT) || defined(FFC32) || defined(FFC64)
    fs->step = 8*step;
    fs->length = len;
    fs->flag = 1;
#endif
#if defined(FFC32) || defined(FFC64)
    fs->length2 = len;
#endif
#ifdef GFORTRAN
    fs->step = step;
    fs->start = 1;
    fs->end = len;
#endif
    step *= len;
  }
}

  cout->array = NA_PTR_TYPE(out, void*);
};

#if defined IFORT
  w_deriv_module_mp_w_jacobian_w_w_(cout, cw_a, cw_b);
#elif defined GFORTRAN
  __w_deriv_module_MOD_w_jacobian_w_w(cout, cw_a, cw_b);
#elif defined(FFC32) || defined(FFC64)
  w_deriv_module_w_jacobian_w_w_(cout, cw_a, cw_b);
#endif

#if defined(FFC32) || defined(FFC64)
{
  double* cnout = NA_PTR_TYPE(out,double*);
  int i;
  for (i=0;i<NA_TOTAL(out);i++)
    cnout[i] = ((double*)cout->array)[i];
}
#endif
  free(cout);
  return out;
}

static VALUE
rbspml_xy_GradLambda_w(int argc, VALUE *argv, VALUE self)
{
  VALUE w_data, out;
  double* cw_data;
  struct farray* cout;

  rb_scan_args(argc, argv, "10", &w_data);
  w_data = na_cast_object(w_data, NA_DFLOAT);
  cw_data = NA_PTR_TYPE(w_data, double*);
{
  int shape[2];
  shape[0] = (NUM2INT(rb_funcall(self,rb_intern("im"),0))-1) - (0) + 1;
  shape[1] = (NUM2INT(rb_funcall(self,rb_intern("jm"),0))) - (1) + 1;
  out = na_make_object(NA_DFLOAT, 2, shape, cNArray);
  cout = (struct farray*) xmalloc(sizeof(struct farray)+sizeof(struct fshape)*2);
#if defined(IFORT) || defined(GFORTRAN)
{
  int i,j=1,offset=1;
  for (i=0;i<1;i++) {
    j = j*NA_STRUCT(out)->shape[i];
    offset += j;
  }
  cout->offset = -offset;
}
#endif
#if defined IFORT
  cout->vsize = sizeof(double);
{
  long type = 10;
  cout->type = ((type<<(sizeof(void*)*6)) | 1);
}
  cout->rank = 2;
#elif defined GFORTRAN
{
  cout->flag = (2 | (1<<4) | (sizeof(double)<<6));
}
#elif defined(FFC32) || defined(FFC64)
  cout->total = NA_STRUCT(out)->total;
  cout->total_byte = cout->total*sizeof(double);
#endif
{
  int step=1, len, i;
  struct fshape* fs;
  for (i=0;i<2;i++) {
    len = NA_STRUCT(out)->shape[i];
    fs = (struct fshape*)(cout+1)+i;
#if defined(IFORT) || defined(FFC32) || defined(FFC64)
    fs->step = 8*step;
    fs->length = len;
    fs->flag = 1;
#endif
#if defined(FFC32) || defined(FFC64)
    fs->length2 = len;
#endif
#ifdef GFORTRAN
    fs->step = step;
    fs->start = 1;
    fs->end = len;
#endif
    step *= len;
  }
}

  cout->array = NA_PTR_TYPE(out, void*);
};

#if defined IFORT
  w_deriv_module_mp_xy_gradlambda_w_(cout, cw_data);
#elif defined GFORTRAN
  __w_deriv_module_MOD_xy_gradlambda_w(cout, cw_data);
#elif defined(FFC32) || defined(FFC64)
  w_deriv_module_xy_gradlambda_w_(cout, cw_data);
#endif

#if defined(FFC32) || defined(FFC64)
{
  double* cnout = NA_PTR_TYPE(out,double*);
  int i;
  for (i=0;i<NA_TOTAL(out);i++)
    cnout[i] = ((double*)cout->array)[i];
}
#endif
  free(cout);
  return out;
}

static VALUE
rbspml_xy_GradMu_w(int argc, VALUE *argv, VALUE self)
{
  VALUE w_data, out;
  double* cw_data;
  struct farray* cout;

  rb_scan_args(argc, argv, "10", &w_data);
  w_data = na_cast_object(w_data, NA_DFLOAT);
  cw_data = NA_PTR_TYPE(w_data, double*);
{
  int shape[2];
  shape[0] = (NUM2INT(rb_funcall(self,rb_intern("im"),0))-1) - (0) + 1;
  shape[1] = (NUM2INT(rb_funcall(self,rb_intern("jm"),0))) - (1) + 1;
  out = na_make_object(NA_DFLOAT, 2, shape, cNArray);
  cout = (struct farray*) xmalloc(sizeof(struct farray)+sizeof(struct fshape)*2);
#if defined(IFORT) || defined(GFORTRAN)
{
  int i,j=1,offset=1;
  for (i=0;i<1;i++) {
    j = j*NA_STRUCT(out)->shape[i];
    offset += j;
  }
  cout->offset = -offset;
}
#endif
#if defined IFORT
  cout->vsize = sizeof(double);
{
  long type = 10;
  cout->type = ((type<<(sizeof(void*)*6)) | 1);
}
  cout->rank = 2;
#elif defined GFORTRAN
{
  cout->flag = (2 | (1<<4) | (sizeof(double)<<6));
}
#elif defined(FFC32) || defined(FFC64)
  cout->total = NA_STRUCT(out)->total;
  cout->total_byte = cout->total*sizeof(double);
#endif
{
  int step=1, len, i;
  struct fshape* fs;
  for (i=0;i<2;i++) {
    len = NA_STRUCT(out)->shape[i];
    fs = (struct fshape*)(cout+1)+i;
#if defined(IFORT) || defined(FFC32) || defined(FFC64)
    fs->step = 8*step;
    fs->length = len;
    fs->flag = 1;
#endif
#if defined(FFC32) || defined(FFC64)
    fs->length2 = len;
#endif
#ifdef GFORTRAN
    fs->step = step;
    fs->start = 1;
    fs->end = len;
#endif
    step *= len;
  }
}

  cout->array = NA_PTR_TYPE(out, void*);
};

#if defined IFORT
  w_deriv_module_mp_xy_gradmu_w_(cout, cw_data);
#elif defined GFORTRAN
  __w_deriv_module_MOD_xy_gradmu_w(cout, cw_data);
#elif defined(FFC32) || defined(FFC64)
  w_deriv_module_xy_gradmu_w_(cout, cw_data);
#endif

#if defined(FFC32) || defined(FFC64)
{
  double* cnout = NA_PTR_TYPE(out,double*);
  int i;
  for (i=0;i<NA_TOTAL(out);i++)
    cnout[i] = ((double*)cout->array)[i];
}
#endif
  free(cout);
  return out;
}

static VALUE
rbspml_w_DivLambda_xy(int argc, VALUE *argv, VALUE self)
{
  VALUE xy_data, out;
  double* cxy_data;
  struct farray* cout;

  rb_scan_args(argc, argv, "10", &xy_data);
  xy_data = na_cast_object(xy_data, NA_DFLOAT);
  cxy_data = NA_PTR_TYPE(xy_data, double*);
{
  int shape[1];
  shape[0] = (NUM2INT(rb_funcall(self,rb_intern("nm"),0))+1)*(NUM2INT(rb_funcall(self,rb_intern("nm"),0))+1);
  out = na_make_object(NA_DFLOAT, 1, shape, cNArray);
  cout = (struct farray*) xmalloc(sizeof(struct farray)+sizeof(struct fshape)*1);
#if defined(IFORT) || defined(GFORTRAN)
{
  int i,j=1,offset=1;
  for (i=0;i<0;i++) {
    j = j*NA_STRUCT(out)->shape[i];
    offset += j;
  }
  cout->offset = -offset;
}
#endif
#if defined IFORT
  cout->vsize = sizeof(double);
{
  long type = 10;
  cout->type = ((type<<(sizeof(void*)*6)) | 1);
}
  cout->rank = 1;
#elif defined GFORTRAN
{
  cout->flag = (1 | (1<<4) | (sizeof(double)<<6));
}
#elif defined(FFC32) || defined(FFC64)
  cout->total = NA_STRUCT(out)->total;
  cout->total_byte = cout->total*sizeof(double);
#endif
{
  int step=1, len, i;
  struct fshape* fs;
  for (i=0;i<1;i++) {
    len = NA_STRUCT(out)->shape[i];
    fs = (struct fshape*)(cout+1)+i;
#if defined(IFORT) || defined(FFC32) || defined(FFC64)
    fs->step = 8*step;
    fs->length = len;
    fs->flag = 1;
#endif
#if defined(FFC32) || defined(FFC64)
    fs->length2 = len;
#endif
#ifdef GFORTRAN
    fs->step = step;
    fs->start = 1;
    fs->end = len;
#endif
    step *= len;
  }
}

  cout->array = NA_PTR_TYPE(out, void*);
};

#if defined IFORT
  w_deriv_module_mp_w_divlambda_xy_(cout, cxy_data);
#elif defined GFORTRAN
  __w_deriv_module_MOD_w_divlambda_xy(cout, cxy_data);
#elif defined(FFC32) || defined(FFC64)
  w_deriv_module_w_divlambda_xy_(cout, cxy_data);
#endif

#if defined(FFC32) || defined(FFC64)
{
  double* cnout = NA_PTR_TYPE(out,double*);
  int i;
  for (i=0;i<NA_TOTAL(out);i++)
    cnout[i] = ((double*)cout->array)[i];
}
#endif
  free(cout);
  return out;
}

static VALUE
rbspml_w_DivMu_xy(int argc, VALUE *argv, VALUE self)
{
  VALUE xy_data, out;
  double* cxy_data;
  struct farray* cout;

  rb_scan_args(argc, argv, "10", &xy_data);
  xy_data = na_cast_object(xy_data, NA_DFLOAT);
  cxy_data = NA_PTR_TYPE(xy_data, double*);
{
  int shape[1];
  shape[0] = (NUM2INT(rb_funcall(self,rb_intern("nm"),0))+1)*(NUM2INT(rb_funcall(self,rb_intern("nm"),0))+1);
  out = na_make_object(NA_DFLOAT, 1, shape, cNArray);
  cout = (struct farray*) xmalloc(sizeof(struct farray)+sizeof(struct fshape)*1);
#if defined(IFORT) || defined(GFORTRAN)
{
  int i,j=1,offset=1;
  for (i=0;i<0;i++) {
    j = j*NA_STRUCT(out)->shape[i];
    offset += j;
  }
  cout->offset = -offset;
}
#endif
#if defined IFORT
  cout->vsize = sizeof(double);
{
  long type = 10;
  cout->type = ((type<<(sizeof(void*)*6)) | 1);
}
  cout->rank = 1;
#elif defined GFORTRAN
{
  cout->flag = (1 | (1<<4) | (sizeof(double)<<6));
}
#elif defined(FFC32) || defined(FFC64)
  cout->total = NA_STRUCT(out)->total;
  cout->total_byte = cout->total*sizeof(double);
#endif
{
  int step=1, len, i;
  struct fshape* fs;
  for (i=0;i<1;i++) {
    len = NA_STRUCT(out)->shape[i];
    fs = (struct fshape*)(cout+1)+i;
#if defined(IFORT) || defined(FFC32) || defined(FFC64)
    fs->step = 8*step;
    fs->length = len;
    fs->flag = 1;
#endif
#if defined(FFC32) || defined(FFC64)
    fs->length2 = len;
#endif
#ifdef GFORTRAN
    fs->step = step;
    fs->start = 1;
    fs->end = len;
#endif
    step *= len;
  }
}

  cout->array = NA_PTR_TYPE(out, void*);
};

#if defined IFORT
  w_deriv_module_mp_w_divmu_xy_(cout, cxy_data);
#elif defined GFORTRAN
  __w_deriv_module_MOD_w_divmu_xy(cout, cxy_data);
#elif defined(FFC32) || defined(FFC64)
  w_deriv_module_w_divmu_xy_(cout, cxy_data);
#endif

#if defined(FFC32) || defined(FFC64)
{
  double* cnout = NA_PTR_TYPE(out,double*);
  int i;
  for (i=0;i<NA_TOTAL(out);i++)
    cnout[i] = ((double*)cout->array)[i];
}
#endif
  free(cout);
  return out;
}


void init_w_deriv_module(VALUE mSPML)
{
  VALUE mW_DERIV;

  mW_DERIV = rb_define_module_under(mSPML, "W_DERIV");

  rb_define_module_function(mW_DERIV, "w_Lapla_w", rbspml_w_Lapla_w, -1);
  rb_define_method(mW_DERIV, "w_Lapla_w", rbspml_w_Lapla_w, -1);
  rb_define_module_function(mW_DERIV, "w_LaplaInv_w", rbspml_w_LaplaInv_w, -1);
  rb_define_method(mW_DERIV, "w_LaplaInv_w", rbspml_w_LaplaInv_w, -1);
  rb_define_module_function(mW_DERIV, "w_DLon_w", rbspml_w_DLon_w, -1);
  rb_define_method(mW_DERIV, "w_DLon_w", rbspml_w_DLon_w, -1);
  rb_define_module_function(mW_DERIV, "xy_GradLon_w", rbspml_xy_GradLon_w, -1);
  rb_define_method(mW_DERIV, "xy_GradLon_w", rbspml_xy_GradLon_w, -1);
  rb_define_module_function(mW_DERIV, "xy_GradLat_w", rbspml_xy_GradLat_w, -1);
  rb_define_method(mW_DERIV, "xy_GradLat_w", rbspml_xy_GradLat_w, -1);
  rb_define_module_function(mW_DERIV, "w_DivLon_xy", rbspml_w_DivLon_xy, -1);
  rb_define_method(mW_DERIV, "w_DivLon_xy", rbspml_w_DivLon_xy, -1);
  rb_define_module_function(mW_DERIV, "w_DivLat_xy", rbspml_w_DivLat_xy, -1);
  rb_define_method(mW_DERIV, "w_DivLat_xy", rbspml_w_DivLat_xy, -1);
  rb_define_module_function(mW_DERIV, "w_Div_xy_xy", rbspml_w_Div_xy_xy, -1);
  rb_define_method(mW_DERIV, "w_Div_xy_xy", rbspml_w_Div_xy_xy, -1);
  rb_define_module_function(mW_DERIV, "w_Jacobian_w_w", rbspml_w_Jacobian_w_w, -1);
  rb_define_method(mW_DERIV, "w_Jacobian_w_w", rbspml_w_Jacobian_w_w, -1);
  rb_define_module_function(mW_DERIV, "xy_GradLambda_w", rbspml_xy_GradLambda_w, -1);
  rb_define_method(mW_DERIV, "xy_GradLambda_w", rbspml_xy_GradLambda_w, -1);
  rb_define_module_function(mW_DERIV, "xy_GradMu_w", rbspml_xy_GradMu_w, -1);
  rb_define_method(mW_DERIV, "xy_GradMu_w", rbspml_xy_GradMu_w, -1);
  rb_define_module_function(mW_DERIV, "w_DivLambda_xy", rbspml_w_DivLambda_xy, -1);
  rb_define_method(mW_DERIV, "w_DivLambda_xy", rbspml_w_DivLambda_xy, -1);
  rb_define_module_function(mW_DERIV, "w_DivMu_xy", rbspml_w_DivMu_xy, -1);
  rb_define_method(mW_DERIV, "w_DivMu_xy", rbspml_w_DivMu_xy, -1);
}
