#include "ruby-spml.h"

#ifdef IFORT
extern struct farray* wa_spectrum_module_mp_nma_energyfromstreamfunc_wa_(struct farray*, struct farray*);
extern struct farray* wa_spectrum_module_mp_na_energyfromstreamfunc_wa_(struct farray*, struct farray*);
extern struct farray* wa_spectrum_module_mp_nma_enstrophyfromstreamfunc_wa_(struct farray*, struct farray*);
extern struct farray* wa_spectrum_module_mp_na_enstrophyfromstreamfunc_wa_(struct farray*, struct farray*);
#endif
#ifdef GFORTRAN
extern struct farray* __wa_spectrum_module_MOD_nma_energyfromstreamfunc_wa(struct farray*, struct farray*);
extern struct farray* __wa_spectrum_module_MOD_na_energyfromstreamfunc_wa(struct farray*, struct farray*);
extern struct farray* __wa_spectrum_module_MOD_nma_enstrophyfromstreamfunc_wa(struct farray*, struct farray*);
extern struct farray* __wa_spectrum_module_MOD_na_enstrophyfromstreamfunc_wa(struct farray*, struct farray*);
#endif
#ifdef FFC32
asm ("wa_spectrum_module_nma_energyfromstreamfunc_wa_:");
asm ("  pushl %ebp");
asm ("  movl %esp,%ebp");
asm ("  movl 12(%ebp), %eax");
asm ("  pushl %eax");
asm ("  movl 8(%ebp), %eax");
asm ("  pushl %eax");
asm ("  call wa_spectrum_module.nma_energyfromstreamfunc_wa_");
asm ("  leave");
asm ("  ret");
asm ("wa_spectrum_module_na_energyfromstreamfunc_wa_:");
asm ("  pushl %ebp");
asm ("  movl %esp,%ebp");
asm ("  movl 12(%ebp), %eax");
asm ("  pushl %eax");
asm ("  movl 8(%ebp), %eax");
asm ("  pushl %eax");
asm ("  call wa_spectrum_module.na_energyfromstreamfunc_wa_");
asm ("  leave");
asm ("  ret");
asm ("wa_spectrum_module_nma_enstrophyfromstreamfunc_wa_:");
asm ("  pushl %ebp");
asm ("  movl %esp,%ebp");
asm ("  movl 12(%ebp), %eax");
asm ("  pushl %eax");
asm ("  movl 8(%ebp), %eax");
asm ("  pushl %eax");
asm ("  call wa_spectrum_module.nma_enstrophyfromstreamfunc_wa_");
asm ("  leave");
asm ("  ret");
asm ("wa_spectrum_module_na_enstrophyfromstreamfunc_wa_:");
asm ("  pushl %ebp");
asm ("  movl %esp,%ebp");
asm ("  movl 12(%ebp), %eax");
asm ("  pushl %eax");
asm ("  movl 8(%ebp), %eax");
asm ("  pushl %eax");
asm ("  call wa_spectrum_module.na_enstrophyfromstreamfunc_wa_");
asm ("  leave");
asm ("  ret");
#endif
#ifdef FFC64
asm ("wa_spectrum_module_nma_energyfromstreamfunc_wa_:");
asm ("  push %rbp");
asm ("  movq %rsp,%rbp");
asm ("  subq $16,%rsp");
asm ("  call wa_spectrum_module.nma_energyfromstreamfunc_wa_@PLT");
asm ("  xorq %rax,%rax");
asm ("  addq $16,%rsp");
asm ("  leave");
asm ("  ret");
asm ("wa_spectrum_module_na_energyfromstreamfunc_wa_:");
asm ("  push %rbp");
asm ("  movq %rsp,%rbp");
asm ("  subq $16,%rsp");
asm ("  call wa_spectrum_module.na_energyfromstreamfunc_wa_@PLT");
asm ("  xorq %rax,%rax");
asm ("  addq $16,%rsp");
asm ("  leave");
asm ("  ret");
asm ("wa_spectrum_module_nma_enstrophyfromstreamfunc_wa_:");
asm ("  push %rbp");
asm ("  movq %rsp,%rbp");
asm ("  subq $16,%rsp");
asm ("  call wa_spectrum_module.nma_enstrophyfromstreamfunc_wa_@PLT");
asm ("  xorq %rax,%rax");
asm ("  addq $16,%rsp");
asm ("  leave");
asm ("  ret");
asm ("wa_spectrum_module_na_enstrophyfromstreamfunc_wa_:");
asm ("  push %rbp");
asm ("  movq %rsp,%rbp");
asm ("  subq $16,%rsp");
asm ("  call wa_spectrum_module.na_enstrophyfromstreamfunc_wa_@PLT");
asm ("  xorq %rax,%rax");
asm ("  addq $16,%rsp");
asm ("  leave");
asm ("  ret");
#endif
#if defined(FFC32) || defined(FFC64)
extern struct farray* wa_spectrum_module_nma_energyfromstreamfunc_wa_(struct farray*, struct farray*);
extern struct farray* wa_spectrum_module_na_energyfromstreamfunc_wa_(struct farray*, struct farray*);
extern struct farray* wa_spectrum_module_nma_enstrophyfromstreamfunc_wa_(struct farray*, struct farray*);
extern struct farray* wa_spectrum_module_na_enstrophyfromstreamfunc_wa_(struct farray*, struct farray*);
#endif


static VALUE
rbspml_nma_EnergyFromStreamfunc_wa(int argc, VALUE *argv, VALUE self)
{
  VALUE wa_strfunc, out;
  struct farray* cwa_strfunc;
  struct farray* cout;

  rb_scan_args(argc, argv, "10", &wa_strfunc);
  wa_strfunc = na_cast_object(wa_strfunc, NA_DFLOAT);
  cwa_strfunc = (struct farray*) xmalloc(sizeof(struct farray)+sizeof(struct fshape)*2);
#if defined(IFORT) || defined(GFORTRAN)
{
  int i,j=1,offset=1;
  for (i=0;i<1;i++) {
    j = j*NA_STRUCT(wa_strfunc)->shape[i];
    offset += j;
  }
  cwa_strfunc->offset = -offset;
}
#endif
#if defined IFORT
  cwa_strfunc->vsize = sizeof(double);
{
  long type = 10;
  cwa_strfunc->type = ((type<<(sizeof(void*)*6)) | 1);
}
  cwa_strfunc->rank = 2;
#elif defined GFORTRAN
{
  cwa_strfunc->flag = (2 | (1<<4) | (sizeof(double)<<6));
}
#elif defined(FFC32) || defined(FFC64)
  cwa_strfunc->total = NA_STRUCT(wa_strfunc)->total;
  cwa_strfunc->total_byte = cwa_strfunc->total*sizeof(double);
#endif
{
  int step=1, len, i;
  struct fshape* fs;
  for (i=0;i<2;i++) {
    len = NA_STRUCT(wa_strfunc)->shape[i];
    fs = (struct fshape*)(cwa_strfunc+1)+i;
#if defined(IFORT) || defined(FFC32) || defined(FFC64)
    fs->step = 8*step;
    fs->length = len;
    fs->flag = 1;
#endif
#if defined(FFC32) || defined(FFC64)
    fs->length2 = len;
#endif
#ifdef GFORTRAN
    fs->step = step;
    fs->start = 1;
    fs->end = len;
#endif
    step *= len;
  }
}

  cwa_strfunc->array = NA_PTR_TYPE(wa_strfunc, void*);
{
  int shape[3];
  shape[0] = (NUM2INT(rb_funcall(self,rb_intern("nm"),0))) - (0) + 1;
  shape[1] = (NUM2INT(rb_funcall(self,rb_intern("nm"),0))) - (-NUM2INT(rb_funcall(self,rb_intern("nm"),0))) + 1;
  shape[2] = (NA_STRUCT(wa_strfunc)->shape[2]);
  out = na_make_object(NA_DFLOAT, 3, shape, cNArray);
  cout = (struct farray*) xmalloc(sizeof(struct farray)+sizeof(struct fshape)*3);
#if defined(IFORT) || defined(GFORTRAN)
{
  int i,j=1,offset=1;
  for (i=0;i<2;i++) {
    j = j*NA_STRUCT(out)->shape[i];
    offset += j;
  }
  cout->offset = -offset;
}
#endif
#if defined IFORT
  cout->vsize = sizeof(double);
{
  long type = 10;
  cout->type = ((type<<(sizeof(void*)*6)) | 1);
}
  cout->rank = 3;
#elif defined GFORTRAN
{
  cout->flag = (3 | (1<<4) | (sizeof(double)<<6));
}
#elif defined(FFC32) || defined(FFC64)
  cout->total = NA_STRUCT(out)->total;
  cout->total_byte = cout->total*sizeof(double);
#endif
{
  int step=1, len, i;
  struct fshape* fs;
  for (i=0;i<3;i++) {
    len = NA_STRUCT(out)->shape[i];
    fs = (struct fshape*)(cout+1)+i;
#if defined(IFORT) || defined(FFC32) || defined(FFC64)
    fs->step = 8*step;
    fs->length = len;
    fs->flag = 1;
#endif
#if defined(FFC32) || defined(FFC64)
    fs->length2 = len;
#endif
#ifdef GFORTRAN
    fs->step = step;
    fs->start = 1;
    fs->end = len;
#endif
    step *= len;
  }
}

  cout->array = NA_PTR_TYPE(out, void*);
};

#if defined IFORT
  wa_spectrum_module_mp_nma_energyfromstreamfunc_wa_(cout, cwa_strfunc);
#elif defined GFORTRAN
  __wa_spectrum_module_MOD_nma_energyfromstreamfunc_wa(cout, cwa_strfunc);
#elif defined(FFC32) || defined(FFC64)
  wa_spectrum_module_nma_energyfromstreamfunc_wa_(cout, cwa_strfunc);
#endif

  free(cwa_strfunc);
#if defined(FFC32) || defined(FFC64)
{
  double* cnout = NA_PTR_TYPE(out,double*);
  int i;
  for (i=0;i<NA_TOTAL(out);i++)
    cnout[i] = ((double*)cout->array)[i];
}
#endif
  free(cout);
  return out;
}

static VALUE
rbspml_na_EnergyFromStreamfunc_wa(int argc, VALUE *argv, VALUE self)
{
  VALUE wa_strfunc, out;
  struct farray* cwa_strfunc;
  struct farray* cout;

  rb_scan_args(argc, argv, "10", &wa_strfunc);
  wa_strfunc = na_cast_object(wa_strfunc, NA_DFLOAT);
  cwa_strfunc = (struct farray*) xmalloc(sizeof(struct farray)+sizeof(struct fshape)*2);
#if defined(IFORT) || defined(GFORTRAN)
{
  int i,j=1,offset=1;
  for (i=0;i<1;i++) {
    j = j*NA_STRUCT(wa_strfunc)->shape[i];
    offset += j;
  }
  cwa_strfunc->offset = -offset;
}
#endif
#if defined IFORT
  cwa_strfunc->vsize = sizeof(double);
{
  long type = 10;
  cwa_strfunc->type = ((type<<(sizeof(void*)*6)) | 1);
}
  cwa_strfunc->rank = 2;
#elif defined GFORTRAN
{
  cwa_strfunc->flag = (2 | (1<<4) | (sizeof(double)<<6));
}
#elif defined(FFC32) || defined(FFC64)
  cwa_strfunc->total = NA_STRUCT(wa_strfunc)->total;
  cwa_strfunc->total_byte = cwa_strfunc->total*sizeof(double);
#endif
{
  int step=1, len, i;
  struct fshape* fs;
  for (i=0;i<2;i++) {
    len = NA_STRUCT(wa_strfunc)->shape[i];
    fs = (struct fshape*)(cwa_strfunc+1)+i;
#if defined(IFORT) || defined(FFC32) || defined(FFC64)
    fs->step = 8*step;
    fs->length = len;
    fs->flag = 1;
#endif
#if defined(FFC32) || defined(FFC64)
    fs->length2 = len;
#endif
#ifdef GFORTRAN
    fs->step = step;
    fs->start = 1;
    fs->end = len;
#endif
    step *= len;
  }
}

  cwa_strfunc->array = NA_PTR_TYPE(wa_strfunc, void*);
{
  int shape[2];
  shape[0] = (NUM2INT(rb_funcall(self,rb_intern("nm"),0))) - (0) + 1;
  shape[1] = (NA_STRUCT(wa_strfunc)->shape[2]);
  out = na_make_object(NA_DFLOAT, 2, shape, cNArray);
  cout = (struct farray*) xmalloc(sizeof(struct farray)+sizeof(struct fshape)*2);
#if defined(IFORT) || defined(GFORTRAN)
{
  int i,j=1,offset=1;
  for (i=0;i<1;i++) {
    j = j*NA_STRUCT(out)->shape[i];
    offset += j;
  }
  cout->offset = -offset;
}
#endif
#if defined IFORT
  cout->vsize = sizeof(double);
{
  long type = 10;
  cout->type = ((type<<(sizeof(void*)*6)) | 1);
}
  cout->rank = 2;
#elif defined GFORTRAN
{
  cout->flag = (2 | (1<<4) | (sizeof(double)<<6));
}
#elif defined(FFC32) || defined(FFC64)
  cout->total = NA_STRUCT(out)->total;
  cout->total_byte = cout->total*sizeof(double);
#endif
{
  int step=1, len, i;
  struct fshape* fs;
  for (i=0;i<2;i++) {
    len = NA_STRUCT(out)->shape[i];
    fs = (struct fshape*)(cout+1)+i;
#if defined(IFORT) || defined(FFC32) || defined(FFC64)
    fs->step = 8*step;
    fs->length = len;
    fs->flag = 1;
#endif
#if defined(FFC32) || defined(FFC64)
    fs->length2 = len;
#endif
#ifdef GFORTRAN
    fs->step = step;
    fs->start = 1;
    fs->end = len;
#endif
    step *= len;
  }
}

  cout->array = NA_PTR_TYPE(out, void*);
};

#if defined IFORT
  wa_spectrum_module_mp_na_energyfromstreamfunc_wa_(cout, cwa_strfunc);
#elif defined GFORTRAN
  __wa_spectrum_module_MOD_na_energyfromstreamfunc_wa(cout, cwa_strfunc);
#elif defined(FFC32) || defined(FFC64)
  wa_spectrum_module_na_energyfromstreamfunc_wa_(cout, cwa_strfunc);
#endif

  free(cwa_strfunc);
#if defined(FFC32) || defined(FFC64)
{
  double* cnout = NA_PTR_TYPE(out,double*);
  int i;
  for (i=0;i<NA_TOTAL(out);i++)
    cnout[i] = ((double*)cout->array)[i];
}
#endif
  free(cout);
  return out;
}

static VALUE
rbspml_nma_EnstrophyFromStreamfunc_wa(int argc, VALUE *argv, VALUE self)
{
  VALUE wa_strfunc, out;
  struct farray* cwa_strfunc;
  struct farray* cout;

  rb_scan_args(argc, argv, "10", &wa_strfunc);
  wa_strfunc = na_cast_object(wa_strfunc, NA_DFLOAT);
  cwa_strfunc = (struct farray*) xmalloc(sizeof(struct farray)+sizeof(struct fshape)*2);
#if defined(IFORT) || defined(GFORTRAN)
{
  int i,j=1,offset=1;
  for (i=0;i<1;i++) {
    j = j*NA_STRUCT(wa_strfunc)->shape[i];
    offset += j;
  }
  cwa_strfunc->offset = -offset;
}
#endif
#if defined IFORT
  cwa_strfunc->vsize = sizeof(double);
{
  long type = 10;
  cwa_strfunc->type = ((type<<(sizeof(void*)*6)) | 1);
}
  cwa_strfunc->rank = 2;
#elif defined GFORTRAN
{
  cwa_strfunc->flag = (2 | (1<<4) | (sizeof(double)<<6));
}
#elif defined(FFC32) || defined(FFC64)
  cwa_strfunc->total = NA_STRUCT(wa_strfunc)->total;
  cwa_strfunc->total_byte = cwa_strfunc->total*sizeof(double);
#endif
{
  int step=1, len, i;
  struct fshape* fs;
  for (i=0;i<2;i++) {
    len = NA_STRUCT(wa_strfunc)->shape[i];
    fs = (struct fshape*)(cwa_strfunc+1)+i;
#if defined(IFORT) || defined(FFC32) || defined(FFC64)
    fs->step = 8*step;
    fs->length = len;
    fs->flag = 1;
#endif
#if defined(FFC32) || defined(FFC64)
    fs->length2 = len;
#endif
#ifdef GFORTRAN
    fs->step = step;
    fs->start = 1;
    fs->end = len;
#endif
    step *= len;
  }
}

  cwa_strfunc->array = NA_PTR_TYPE(wa_strfunc, void*);
{
  int shape[3];
  shape[0] = (NUM2INT(rb_funcall(self,rb_intern("nm"),0))) - (0) + 1;
  shape[1] = (NUM2INT(rb_funcall(self,rb_intern("nm"),0))) - (-NUM2INT(rb_funcall(self,rb_intern("nm"),0))) + 1;
  shape[2] = (NA_STRUCT(wa_strfunc)->shape[2]);
  out = na_make_object(NA_DFLOAT, 3, shape, cNArray);
  cout = (struct farray*) xmalloc(sizeof(struct farray)+sizeof(struct fshape)*3);
#if defined(IFORT) || defined(GFORTRAN)
{
  int i,j=1,offset=1;
  for (i=0;i<2;i++) {
    j = j*NA_STRUCT(out)->shape[i];
    offset += j;
  }
  cout->offset = -offset;
}
#endif
#if defined IFORT
  cout->vsize = sizeof(double);
{
  long type = 10;
  cout->type = ((type<<(sizeof(void*)*6)) | 1);
}
  cout->rank = 3;
#elif defined GFORTRAN
{
  cout->flag = (3 | (1<<4) | (sizeof(double)<<6));
}
#elif defined(FFC32) || defined(FFC64)
  cout->total = NA_STRUCT(out)->total;
  cout->total_byte = cout->total*sizeof(double);
#endif
{
  int step=1, len, i;
  struct fshape* fs;
  for (i=0;i<3;i++) {
    len = NA_STRUCT(out)->shape[i];
    fs = (struct fshape*)(cout+1)+i;
#if defined(IFORT) || defined(FFC32) || defined(FFC64)
    fs->step = 8*step;
    fs->length = len;
    fs->flag = 1;
#endif
#if defined(FFC32) || defined(FFC64)
    fs->length2 = len;
#endif
#ifdef GFORTRAN
    fs->step = step;
    fs->start = 1;
    fs->end = len;
#endif
    step *= len;
  }
}

  cout->array = NA_PTR_TYPE(out, void*);
};

#if defined IFORT
  wa_spectrum_module_mp_nma_enstrophyfromstreamfunc_wa_(cout, cwa_strfunc);
#elif defined GFORTRAN
  __wa_spectrum_module_MOD_nma_enstrophyfromstreamfunc_wa(cout, cwa_strfunc);
#elif defined(FFC32) || defined(FFC64)
  wa_spectrum_module_nma_enstrophyfromstreamfunc_wa_(cout, cwa_strfunc);
#endif

  free(cwa_strfunc);
#if defined(FFC32) || defined(FFC64)
{
  double* cnout = NA_PTR_TYPE(out,double*);
  int i;
  for (i=0;i<NA_TOTAL(out);i++)
    cnout[i] = ((double*)cout->array)[i];
}
#endif
  free(cout);
  return out;
}

static VALUE
rbspml_na_EnstrophyFromStreamfunc_wa(int argc, VALUE *argv, VALUE self)
{
  VALUE wa_strfunc, out;
  struct farray* cwa_strfunc;
  struct farray* cout;

  rb_scan_args(argc, argv, "10", &wa_strfunc);
  wa_strfunc = na_cast_object(wa_strfunc, NA_DFLOAT);
  cwa_strfunc = (struct farray*) xmalloc(sizeof(struct farray)+sizeof(struct fshape)*2);
#if defined(IFORT) || defined(GFORTRAN)
{
  int i,j=1,offset=1;
  for (i=0;i<1;i++) {
    j = j*NA_STRUCT(wa_strfunc)->shape[i];
    offset += j;
  }
  cwa_strfunc->offset = -offset;
}
#endif
#if defined IFORT
  cwa_strfunc->vsize = sizeof(double);
{
  long type = 10;
  cwa_strfunc->type = ((type<<(sizeof(void*)*6)) | 1);
}
  cwa_strfunc->rank = 2;
#elif defined GFORTRAN
{
  cwa_strfunc->flag = (2 | (1<<4) | (sizeof(double)<<6));
}
#elif defined(FFC32) || defined(FFC64)
  cwa_strfunc->total = NA_STRUCT(wa_strfunc)->total;
  cwa_strfunc->total_byte = cwa_strfunc->total*sizeof(double);
#endif
{
  int step=1, len, i;
  struct fshape* fs;
  for (i=0;i<2;i++) {
    len = NA_STRUCT(wa_strfunc)->shape[i];
    fs = (struct fshape*)(cwa_strfunc+1)+i;
#if defined(IFORT) || defined(FFC32) || defined(FFC64)
    fs->step = 8*step;
    fs->length = len;
    fs->flag = 1;
#endif
#if defined(FFC32) || defined(FFC64)
    fs->length2 = len;
#endif
#ifdef GFORTRAN
    fs->step = step;
    fs->start = 1;
    fs->end = len;
#endif
    step *= len;
  }
}

  cwa_strfunc->array = NA_PTR_TYPE(wa_strfunc, void*);
{
  int shape[2];
  shape[0] = (NUM2INT(rb_funcall(self,rb_intern("nm"),0))) - (0) + 1;
  shape[1] = (NA_STRUCT(wa_strfunc)->shape[2]);
  out = na_make_object(NA_DFLOAT, 2, shape, cNArray);
  cout = (struct farray*) xmalloc(sizeof(struct farray)+sizeof(struct fshape)*2);
#if defined(IFORT) || defined(GFORTRAN)
{
  int i,j=1,offset=1;
  for (i=0;i<1;i++) {
    j = j*NA_STRUCT(out)->shape[i];
    offset += j;
  }
  cout->offset = -offset;
}
#endif
#if defined IFORT
  cout->vsize = sizeof(double);
{
  long type = 10;
  cout->type = ((type<<(sizeof(void*)*6)) | 1);
}
  cout->rank = 2;
#elif defined GFORTRAN
{
  cout->flag = (2 | (1<<4) | (sizeof(double)<<6));
}
#elif defined(FFC32) || defined(FFC64)
  cout->total = NA_STRUCT(out)->total;
  cout->total_byte = cout->total*sizeof(double);
#endif
{
  int step=1, len, i;
  struct fshape* fs;
  for (i=0;i<2;i++) {
    len = NA_STRUCT(out)->shape[i];
    fs = (struct fshape*)(cout+1)+i;
#if defined(IFORT) || defined(FFC32) || defined(FFC64)
    fs->step = 8*step;
    fs->length = len;
    fs->flag = 1;
#endif
#if defined(FFC32) || defined(FFC64)
    fs->length2 = len;
#endif
#ifdef GFORTRAN
    fs->step = step;
    fs->start = 1;
    fs->end = len;
#endif
    step *= len;
  }
}

  cout->array = NA_PTR_TYPE(out, void*);
};

#if defined IFORT
  wa_spectrum_module_mp_na_enstrophyfromstreamfunc_wa_(cout, cwa_strfunc);
#elif defined GFORTRAN
  __wa_spectrum_module_MOD_na_enstrophyfromstreamfunc_wa(cout, cwa_strfunc);
#elif defined(FFC32) || defined(FFC64)
  wa_spectrum_module_na_enstrophyfromstreamfunc_wa_(cout, cwa_strfunc);
#endif

  free(cwa_strfunc);
#if defined(FFC32) || defined(FFC64)
{
  double* cnout = NA_PTR_TYPE(out,double*);
  int i;
  for (i=0;i<NA_TOTAL(out);i++)
    cnout[i] = ((double*)cout->array)[i];
}
#endif
  free(cout);
  return out;
}


void init_wa_spectrum_module(VALUE mSPML)
{
  VALUE mWA_SPECTRUM;

  mWA_SPECTRUM = rb_define_module_under(mSPML, "WA_SPECTRUM");

  rb_define_module_function(mWA_SPECTRUM, "nma_EnergyFromStreamfunc_wa", rbspml_nma_EnergyFromStreamfunc_wa, -1);
  rb_define_method(mWA_SPECTRUM, "nma_EnergyFromStreamfunc_wa", rbspml_nma_EnergyFromStreamfunc_wa, -1);
  rb_define_module_function(mWA_SPECTRUM, "na_EnergyFromStreamfunc_wa", rbspml_na_EnergyFromStreamfunc_wa, -1);
  rb_define_method(mWA_SPECTRUM, "na_EnergyFromStreamfunc_wa", rbspml_na_EnergyFromStreamfunc_wa, -1);
  rb_define_module_function(mWA_SPECTRUM, "nma_EnstrophyFromStreamfunc_wa", rbspml_nma_EnstrophyFromStreamfunc_wa, -1);
  rb_define_method(mWA_SPECTRUM, "nma_EnstrophyFromStreamfunc_wa", rbspml_nma_EnstrophyFromStreamfunc_wa, -1);
  rb_define_module_function(mWA_SPECTRUM, "na_EnstrophyFromStreamfunc_wa", rbspml_na_EnstrophyFromStreamfunc_wa, -1);
  rb_define_method(mWA_SPECTRUM, "na_EnstrophyFromStreamfunc_wa", rbspml_na_EnstrophyFromStreamfunc_wa, -1);
}
